/*
 *  @(#)dollar_atomType0_2.cs
 *  $B=R8l(B $atom_type0/2
 */

namespace JJC.Psharp.Predicates {

	using JJC.Psharp.Lang;

	public sealed class dollar_atomType0_2 : Predicate {
		Term arg1, arg2;

		public dollar_atomType0_2(Term a1, Term a2, Predicate cont){ 
			arg1 = a1;
			arg2 = a2;
			this.cont = cont;
		}
		public dollar_atomType0_2(){}
		public override void setArgument(Term[] args, Predicate cont){
			arg1 = args[0];
			arg2 = args[1];
			this.cont = cont;
		}

		public override Predicate exec() {
			Term a1, a2;
			a1 = arg1.dereference();
			a2 = arg2.dereference();

			if( !a1.isSymbol() ) 
				return engine.fail();
			int i = Token.string_type(((SymbolTerm)a1).name);
			if( !a2.unify(new IntegerTerm(i), engine.trail) ) 
				return engine.fail();
			return cont;
		}

		public override int arity() { return 2; }

		public override string ToString() {
			return "$atom_type0(" + arg1 + ", " + arg2 + ")";
		}
	}

}