/*
 * @(#)dollar_bitwiseNeg_2.cs
 */

namespace JJC.Psharp.Predicates {

	using JJC.Psharp.Lang;

	public sealed class dollar_bitwiseNeg_2 : Predicate {
		Term arg1, arg2;

		public dollar_bitwiseNeg_2(Term a1, Term a2, Predicate cont){
			arg1 = a1;
			arg2 = a2;
			this.cont = cont;
		}
		public dollar_bitwiseNeg_2(){}
		public override void setArgument(Term[] args, Predicate cont){
			arg1 = args[0];
			arg2 = args[1];
			this.cont = cont;
		}

		public override Predicate exec(){
			Term a2;
			a2 = arg2.dereference();

			try {
				int x = engine.evalTerm(arg1);
				if( !a2.unify(new IntegerTerm((int)(~x)), engine.trail) ) 
					return engine.fail();
			} catch (ArithException) {
				return engine.abort("{TYPE ERROR: " + this + "}\n");
			}
			return cont;
		}

		public override int arity() { return 2; }

		public override string ToString() {
			return "$bitwise_neg(" + arg1 + "," + arg2 + ")";
		}
	}

}