/*
 *  @(#) dollar_close_1.cs
 *  $B=R8l(B $close/1
 */

namespace JJC.Psharp.Predicates {

	using JJC.Psharp.Lang;

	using System.IO;

	public sealed class dollar_close_1 : Predicate {
		public static SymbolTerm 
			SYM_user = SymbolTerm.makeSymbol("user");
		public static SymbolTerm 
			SYM_user_input  = SymbolTerm.makeSymbol("user_input");
		public static SymbolTerm 
			SYM_user_output = SymbolTerm.makeSymbol("user_output");
		public static SymbolTerm 
			SYM_user_error = SymbolTerm.makeSymbol("user_error");
		Term arg1;

		public dollar_close_1(Term a1, Predicate cont) {
			arg1 = a1;
			this.cont = cont;
		}
		public dollar_close_1() {}
		public override void setArgument(Term[] args, Predicate cont){
			arg1 = args[0];
			this.cont = cont;
		}

		public override Predicate exec() {
			Term a1;
			a1 = arg1.dereference();
			object obj;
	
			try {
				if ( a1.isVariable() ) {
					return engine.abort("{INSTANTIATION ERROR: " + this + "}\n");
					//		return null;
				}
				if ( a1.Equals(SYM_user) ) {
					//engine.user_input.Close();
					//engine.user_output.Close();
					//engine.user_error.Close();
					return cont;
				}
				if ( a1.Equals(SYM_user_input) ) {
					engine.user_input.Close();
					return cont;
				}
				if ( a1.Equals(SYM_user_output) ) {
					engine.user_output.Close();
					return cont;
				}
				if ( a1.Equals(SYM_user_error) ) {
					engine.user_error.Close();
					return cont;
				}
			} catch (IOException) {
				return engine.abort("{IO ERROR: " + this + "}\n");
				//return null;
			}

			if ( !a1.isCsObject() ) {
				return engine.abort("{TYPE ERROR: " + this + 
					" -arg 1: expected stream, found " +
					a1 + "}\n");
				//	    return null;
			}
			obj = ((CsObjectTerm)a1).Object();
			try {
				if ( obj is TextWriter ) {
					((TextWriter)obj).Close();
					return cont;
				} 
				if ( obj is PushbackReader ) {
					((PushbackReader)obj).Close();
					return cont;
				} 
				//	    if ( obj is PushbackInputStream ) {
				//		((PushbackInputStream)obj).Close();
				//		return cont;
				//	    } 
			} catch (IOException) {
				return engine.abort("{IO ERROR: " + this + "}\n");
				//	    return null;
			}
			return engine.abort("{TYPE ERROR: " + this + 
				" -arg 1: expected stream, found " +
				a1 + "}\n");
			//	return null;
		}

		public override int arity() { return 1; }

		public override string ToString() {
			return "$close(" + arg1 + ")";
		}
	}

}