/*
 *  @(#) dollar_get0_2.cs
 *  $B=R8l(B get0/2
 */

namespace JJC.Psharp.Predicates {

	using JJC.Psharp.Lang;

	using System.IO;

	public sealed class dollar_get0_2 : Predicate {
		private static SymbolTerm SYM_user = SymbolTerm.makeSymbol("user");
		private static SymbolTerm SYM_user_input = SymbolTerm.makeSymbol("user_input");
		Term arg1, arg2;

		public dollar_get0_2(Term a1, Term a2, Predicate cont) {
			arg1 = a1;
			arg2 = a2;
			this.cont = cont;
		}
		public dollar_get0_2() {}
		public override void setArgument(Term[] args, Predicate cont){
			arg1 = args[0];
			arg2 = args[1];
			this.cont = cont;
		}

		public override Predicate exec() {
			Term a1, a2;
			a1 = arg1.dereference();
			a2 = arg2.dereference();
			object obj;
			int input;


			if ( a1.isVariable() ) {
				return engine.abort("{INSTANTIATION  ERROR: " + this + "}\n");
				//	    return null;
			}
			if ( a1.Equals(SYM_user) || a1.Equals(SYM_user_input) ) {
				try { 
					//		if ( !engine.user_input.Ready() ){
					//		    PushbackReader newIn = new PushbackReader(new BufferedReader(new InputStreamReader(System.in))); 
					//		    engine.user_input = newIn;
					//		}
					input = engine.user_input.Read();
					if( !a2.unify(new IntegerTerm(input), engine.trail) )
						return engine.fail();
				} catch (IOException) {
					return engine.abort("{IO Error: " + this +  "}");
				}
				return cont;
			}
			if ( !a1.isCsObject() ) {
				return engine.abort("{TYPE ERROR: " + this + 
					" -arg 1: expected stream, found " +
					a1 + "}\n");
				//	    return null;
			}
			obj = ((CsObjectTerm)a1).Object();
			if ( !(obj is PushbackReader) ) {
				return engine.abort("{TYPE ERROR: " + this + 
					" -arg 1: expected stream, found " +
					a1 + "}\n");
				//	    return null;
			}
			try { 
				//	    if ( !((PushbackReader)obj).Ready() ){
				//		engine.abort("{IO ERROR: " + this + 
				//			     " -arg 1: not available stream, found " +
				//			     a1 + "}\n");
				//		return null;
				//	    }
				input = ((PushbackReader)obj).Read();
				if( !a2.unify(new IntegerTerm(input), engine.trail) )
					return engine.fail();
			} catch (IOException) {
				return engine.abort("{IO Error: " + this + "}");
			}
			return cont;
		}

		public override int arity() { return 2; }
		public override string ToString() {
			return "$get0(" + arg1 + ", " + arg2 + ")";
		}
	}

}