/*
 * @(#)dollar_getTerm_2.cs
 * $B=R8l(B $get_term/2
 */

namespace JJC.Psharp.Predicates {

	using JJC.Psharp.Lang;

	using System.Collections;

	public sealed class dollar_getTerm_2 : Predicate {
		private static SymbolTerm Nil = SymbolTerm.makeSymbol("[]");
		Term arg1, arg2;

		public dollar_getTerm_2(Term a1, Term a2, Predicate cont) {
			arg1 = a1;
			arg2 = a2;
			this.cont = cont;
		}
		public dollar_getTerm_2() {}
		public override void setArgument(Term[] args, Predicate cont){
			arg1 = args[0];
			arg2 = args[1];
			this.cont = cont;
		}

		public override Predicate exec() {
			Term a1, a2;
			a1 = arg1.dereference();
			a2 = arg2.dereference();
			string key;
			Term entry;

			key = a1.ToString();
			entry = (Term)(engine.current_table[key]);
			if (entry == null)
				entry = Nil;
			if ( !a2.unify(entry, engine.trail) ) 
				return engine.fail();
			return cont;
		}

		public override int arity() { return 2; }
		public override string ToString() {
			return "$get_term(" + arg1 + "," + arg2 + ")";
		}
	}

}