/*
 * @(#)dollar_numberChars_2.cs
 * $B=R8l(B $number_chars/2
 */

namespace JJC.Psharp.Predicates {

	using JJC.Psharp.Lang;

	public sealed class dollar_numberChars_2 : Predicate {
		public static SymbolTerm Nil = SymbolTerm.makeSymbol("[]");
		Term arg1, arg2;

		public dollar_numberChars_2(Term a1, Term a2, Predicate cont) {
			arg1 = a1;
			arg2 = a2;
			this.cont = cont;
		}
		public dollar_numberChars_2() {}
		public override void setArgument(Term[] args, Predicate cont){
			arg1 = args[0];
			arg2 = args[1];
			this.cont = cont;
		}

		public override Predicate exec() {
			Term a1, a2;
			a1 = arg1.dereference();	
			a2 = arg2.dereference();

			string s = null;

			/*
			if( !a1.isVariable() && !a1.isInteger() ){
				System.out.WriteLine("TYPE ERROR:  " + this.ToString());
				return engine.fail();
			}*/
			if( a1.isVariable() ){
				if( !a2.isNil() && !a2.isList() ){
					/* System.out.WriteLine("TYPE ERROR:  " + this.ToString()); */
					return engine.fail();
				}
				if ( a2.isNil() ) s = "";
				if ( a2.isList() ){
					int j = ((ListTerm) a2).length();
					char[] chars = new char[j];
					Term car = ((ListTerm)a2).car.dereference();
					Term cdr = ((ListTerm)a2).cdr.dereference();
					try {
						for(int i=0; i<j; i++) {
							chars[i] = (char)(((IntegerTerm) car).value());
							if(cdr.isNil())
								break;
							car = ((ListTerm)cdr).car.dereference();
							cdr = ((ListTerm)cdr).cdr.dereference();
						}
					} catch (System.Exception){
						/* System.out.WriteLine("TYPE ERROR:  " + this.ToString());*/
						return engine.fail();
					}
					s = new string(chars);
				}
				if( !a1.unify(SymbolTerm.makeSymbol(s), engine.trail) )
					return engine.fail();
				return cont;
			}
			else if( a1.isInteger() ){
				s = "" + ((IntegerTerm)a1).value();
				Term y = Nil;
				for (int i=s.Length; i>0; i--) {
					y = new ListTerm(new IntegerTerm((int)s[i-1]), y);
				}
				if ( !a2.unify(y, engine.trail) ) 
					return engine.fail();
				return cont;
			}
			return engine.fail();
		}

		public override int arity() { return 2; }
		public override string ToString() {
			return "$number_chars(" + arg1 + ", " + arg2 + ")";
		}
	}

}