/*
 * @(#) dollar_open_3.cs
 * $B=R8l(B $open/3
 */

namespace JJC.Psharp.Predicates {

	using JJC.Psharp.Lang;

	using System.IO;

	public sealed class dollar_open_3 : Predicate {
		private static SymbolTerm SYM_read = SymbolTerm.makeSymbol("read");
		private static SymbolTerm SYM_write = SymbolTerm.makeSymbol("write");
		private static SymbolTerm SYM_append = SymbolTerm.makeSymbol("append");

		Term arg1, arg2, arg3;

		public dollar_open_3(Term a1, Term a2, Term a3, Predicate cont) {
			arg1 = a1;
			arg2 = a2;
			arg3 = a3;
			this.cont = cont;
		}
		public dollar_open_3() {}
		public override void setArgument(Term[] args, Predicate cont){
			arg1 = args[0];
			arg2 = args[1];
			arg3 = args[2];
			this.cont = cont;
		}

		public override Predicate exec() {
			Term a1, a2, a3;
			a1 = arg1.dereference();
			a2 = arg2.dereference();
			a3 = arg3.dereference();

			try {
				if ( a2.Equals(SYM_read) ) {
					// File f;
					PushbackReader cin;
		
					FileStream fs = File.OpenRead(((SymbolTerm)a1).name); 
					// f = new File(((SymbolTerm)a1).name);
					cin = new PushbackReader( (TextReader)( new StreamReader( fs )) ); 
					if ( !a3.unify(new CsObjectTerm(cin), engine.trail) ) 
						return engine.fail();
					return cont;

				}
				if ( a2.Equals(SYM_write) ) {
					string file_name;
					TextWriter cout;

					file_name = ((SymbolTerm)a1).name;
					FileStream fs = File.OpenWrite( file_name );
					cout = new StreamWriter( fs );
					if ( !a3.unify(new CsObjectTerm(cout), engine.trail) ) 
						return engine.fail();
					return cont;
				}
				if ( a2.Equals(SYM_append) ) {
					string file_name;
					TextWriter cout;

					file_name = ((SymbolTerm)a1).name;
					FileStream fs = File.OpenWrite( file_name );
					cout = new StreamWriter( fs );
					if ( !a3.unify(new CsObjectTerm(cout), engine.trail) ) 
						return engine.fail();
					return cont;
				}
			} catch (FileNotFoundException) {	
				return engine.fail(); 
			} catch (System.Exception) {
				return engine.fail();
			}
			return engine.fail();
		}

		public override int arity() { return 3; }
		public override string ToString() {
			return "$open(" + arg1 + "," + arg2 + "," + arg3 + ")";
		}
	}

}