/*
 *  @(#) dollar_setInput_1.cs
 *  $B=R8l(B $set_input/1
 */

namespace JJC.Psharp.Predicates {

	using JJC.Psharp.Lang;

	using System.IO;

	public sealed class dollar_setInput_1 : Predicate {
		private static SymbolTerm SYM_user = SymbolTerm.makeSymbol("user");
		private static SymbolTerm SYM_user_input = SymbolTerm.makeSymbol("user_input");
		Term arg1;

		public dollar_setInput_1(Term a1, Predicate cont) {
			arg1 = a1;
			this.cont = cont;
		}
		public dollar_setInput_1() {}
		public override void setArgument(Term[] args, Predicate cont){
			arg1 = args[0];
			this.cont = cont;
		}

		public override Predicate exec() {
			Term a1;
			a1 = arg1.dereference();
			object obj;
			PushbackReader cin;
	
			if ( a1.isVariable() ) {
				return engine.abort("{INSTANTIATION  ERROR: " + this + "}\n");
				//	    return null;
			}
			if ( a1.Equals(SYM_user) || a1.Equals(SYM_user_input) ) {
				engine.setInput(engine.user_input);
				return cont;
			}
			if ( !a1.isCsObject() ) {
				return engine.abort("{TYPE ERROR: " + this + 
					" - arg 1: expected stream, found " +
					a1 + "}");
				//	    return null;
				//	    return engine.fail();
			}
			obj = ((CsObjectTerm)a1).Object();
			if ( !(obj is PushbackReader) ) {
				return engine.abort("{TYPE ERROR: " + this + 
					" - arg 1: expected stream, found " +
					a1 + "}");
				//	    return null;
				//	    return engine.fail();
			}
			cin = (PushbackReader)obj;
			engine.setInput(cin);
			return cont;
		}

		public override int arity() { return 1; }
		public override string ToString() {
			return "$set_input(" + arg1 + ")";
		}
	}

}