/*
 *  @(#)dollar_statistics_2.cs
 *  $B=R8l(B $statistics/2
 */

namespace JJC.Psharp.Predicates {

	using JJC.Psharp.Lang;

	public sealed class dollar_statistics_2 : Predicate{
		private static SymbolTerm Nil = SymbolTerm.makeSymbol("[]");
		private static SymbolTerm SYM_runtime = SymbolTerm.makeSymbol("runtime");
		private static SymbolTerm SYM_trail  = SymbolTerm.makeSymbol("trail");
		private static SymbolTerm SYM_choice = SymbolTerm.makeSymbol("choice");
		Term arg1, arg2;

		public dollar_statistics_2(Term a1, Term a2, Predicate cont){
			arg1 = a1;
			arg2 = a2;
			this.cont = cont;
		}
		public dollar_statistics_2(){}
		public override void setArgument(Term[] args, Predicate cont){
			arg1 = args[0];
			arg2 = args[1];
			this.cont = cont;
		}

		public override Predicate exec(){
			Term a1, a2;
			a1 = arg1.dereference();
			a2 = arg2.dereference();

			if ( a1.Equals(SYM_runtime) ) {
				long val1, val2;
				Term start, previous, result;

				val1 = (System.DateTime.Now.Ticks / 10000) - engine.runtime0;
				val2 = val1 - engine.old_runtime;
				engine.old_runtime = val1;
				start = new IntegerTerm((int)val1);
				previous = new IntegerTerm((int)val2);
				result = new ListTerm(start, new ListTerm(previous, Nil));
				if( !a2.unify(result, engine.trail) ) 
					return engine.fail();
				return cont;
			}
			if ( a1.Equals(SYM_trail) ) {
				int top, max;
				Term free, used, result;

				top = engine.trail_top();
				max = engine.trail_max();
				used = new IntegerTerm(top);
				free = new IntegerTerm(max - top);
				result = new ListTerm(used, new ListTerm(free, Nil));
				if( !a2.unify(result, engine.trail) ) 
					return engine.fail();
				return cont;
			}
			if ( a1.Equals(SYM_choice) ) {
				int top, max;
				Term free, used, result;

				top = engine.stack_top();
				max = engine.stack_max();
				used = new IntegerTerm(top);
				free = new IntegerTerm(max - top);
				result = new ListTerm(used, new ListTerm(free, Nil));
				if( !a2.unify(result, engine.trail) ) 
					return engine.fail();
				return cont;
			}
			return engine.fail();
		}

		public override int arity() { return 2 ; }
		public override string ToString(){
			return "$statistics(" + arg1 + ", " + arg2 + ")";
		}
	}

}