/*
 *  @(#) dollar_tab_2.cs
 *  $B=R8l(B get0/2
 */

namespace JJC.Psharp.Predicates {

	using JJC.Psharp.Lang;

	using System.IO;

	public sealed class dollar_tab_2 : Predicate {
		private static SymbolTerm SYM_user = SymbolTerm.makeSymbol("user");
		private static SymbolTerm SYM_user_output = SymbolTerm.makeSymbol("user_output");
		Term arg1, arg2;

		public dollar_tab_2(Term a1, Term a2, Predicate cont) {
			arg1 = a1;
			arg2 = a2;
			this.cont = cont;
		}
		public dollar_tab_2() {}
		public override void setArgument(Term[] args, Predicate cont){
			arg1 = args[0];
			arg2 = args[1];
			this.cont = cont;
		}

		public override Predicate exec() {
			Term a1;
			a1 = arg1.dereference();
			object obj;
			int tab;

			try {
				tab = engine.evalTerm(arg2);
			} catch (ArithException) {
				return engine.abort("{TYPE ERROR: " + this + 
					" - arg 2: expected expression, found " +
					arg2 + "}");
				//	    return null;
			}
			if ( a1.isVariable() ) {
				return engine.abort("{INSTANTIATION  ERROR: " + this + 
					" -arg 1: expected stream, found " +
					a1 + "}\n");
				//	    return null;
			}
			if ( a1.Equals(SYM_user) || a1.Equals(SYM_user_output) ) {
				for (int i=tab; i>0; i--) {
					engine.current_output.Write(' ');
				}
				return cont;
			}
			if ( !a1.isCsObject() ) {
				return engine.abort("{TYPE ERROR: " + this + 
					" - arg 1: expected stream, found " +
					a1 + "}");
				//	    return null;
				//	    return engine.fail();
			}
			obj = ((CsObjectTerm)a1).Object();
			if ( !(obj is TextWriter) ) {
				return engine.abort("{TYPE ERROR: " + this + 
					" - arg 1: expected stream, found " +
					a1 + "}");
				//	    return null;
				//	    return engine.fail();
			}
			for (int i=tab; i>0; i--) {
				((TextWriter)obj).Write(' ');
			}
			return cont;
		}

		public override int arity() { return 2; }
		public override string ToString() {
			return "$tab(" + arg1 + ", " + arg2 + ")";
		}
	}

}