/*
 *  @(#)dollar_unify_2.cs
 *  $B=R8l(B $unify/2 (=/2)
 */

namespace JJC.Psharp.Predicates {

	using JJC.Psharp.Lang;

	public sealed class dollar_unify_2 : Predicate {
		Term arg1, arg2;

		public dollar_unify_2(Term a1, Term a2, Predicate cont) {
			arg1 = a1;
			arg2 = a2;
			this.cont = cont;
		}
		public dollar_unify_2() {}
		public override void setArgument(Term[] args, Predicate cont){
			arg1 = args[0];
			arg2 = args[1];
			this.cont = cont;
		}

		public override Predicate exec() {
			Term a1, a2;
			a1 = arg1.dereference();
			a2 = arg2.dereference();

			if( !a1.unify(a2, engine.trail) ) 
				return engine.fail();
			return cont;
		}

		public override int arity() { return 2; }
		public override string ToString() {
			return "(" + arg1 + " = " + arg2 + ")";
		}
	}

}