/*
 * @(#)dollar_urlSource_2.java
 * $B=R8l(B $url_source/2
 */

// // import java.io.*;
// // import java.net.*;

namespace JJC.Psharp.Predicates {

	using JJC.Psharp.Lang;
	using System;
	using System.IO;
	using System.Net;

	public sealed class dollar_urlSource_2 : Predicate {
		Term arg1, arg2;

		public dollar_urlSource_2(Term a1, Term a2, Predicate cont) {
			arg1 = a1;
			arg2 = a2;
			this.cont = cont;
		}
		public dollar_urlSource_2() {}
		public override void setArgument(Term[] args, Predicate cont){
			arg1 = args[0];
			arg2 = args[1];
			this.cont = cont;
		}

		public override Predicate exec() {
			Term a1, a2;
			a1 = arg1.dereference();
			a2 = arg2.dereference();

			if ( !a1.isSymbol() )
				return engine.abort("{TYPE ERROR: " + this +
					" expected URL expression (e.g http:// ....), found " + 
					a1 + "}\n");
			if ( !a2.isVariable() )
				return engine.abort("{TYPE ERROR: " + this +
					" expected unbound variable, found " + 
					a1 + "}\n");

			string s = "";			
		    //URL url = null;
			//URLConnection c = null;
			TextReader cin = null;

			try {
				WebRequest request = System.Net.WebRequest.Create( a1.ToString( ) );
				WebResponse response = request.GetResponse( );
				Stream stream = response.GetResponseStream( );
				cin = new System.IO.StreamReader( stream );

				//url = new URL(a1.toString());
				//c = url.openConnection();
				//	    System.out.println("{connecting " + c.getURL() + "...}");
				//c.connect();
				//System.out.println("{connected, " + c.getURL() + "...}");
				//System.out.println("{content type, " + c.getContentType() + "...}");
				//System.out.println("{content encoding, " + c.getContentEncoding() + "...}");
				//System.out.println("{content length, " + c.getContentLength() + "...}");
				//cin = new BufferedReader(new InputStreamReader(c.getInputStream()));
				string tmp = "";
				tmp = cin.ReadLine();
				while (tmp != null){
					s += tmp;
					tmp = cin.ReadLine();
				}
			}
				/*
			catch (MalformedURLException e1){ 
				return engine.fail();
				//e1.printStackTrace(); 
			}
			catch (IOException e2){	
				return engine.fail();
				//e2.printStackTrace(); 
			}
			*/
			catch (Exception){ 
				return engine.fail();
				//e.printStackTrace(); 
			}
			finally {
				try {
					cin.Close();
				}
				catch (Exception){}
			}

			if ( !a2.unify(SymbolTerm.makeSymbol(s), engine.trail) )
				return engine.fail();
			return cont;
		}

		public override int arity() { return 2; }

		public override string ToString() {
			return "$url_source(" + arg1 + "," + arg2 + ")";
		}
	}

}