/* MAY HAVE TO COMMENT OUT SOME BITS UNTIL I LEARN HOW TO DO REFLECTION */

/*
 *  @(#)ListTerm.cs
 */

/* 
 * @author Mutsunori Banbara 
 *         banbara@pascal.seg.kobe-u.ac.jp
 *         Nara National College of Technology
 * @author Naoyuki Tamura 
 *         tamura@kobe-u.ac.jp
 *         Kobe University
 */

// import java.lang.*;
// import java.lang.reflect.*;
// import java.util.*;

namespace JJC.Psharp.Lang {

	public sealed class ListTerm : Term {
		private Term icar;
		public Term car {
			get {
				return icar;
			}
			set {
				icar = value;
			}
		}
		private Term icdr;
		public Term cdr {
			get {
				return icdr;
			}
			set {
				icdr = value;
			}
		}
		public ListTerm(Term _car, Term _cdr) { 
			car = _car; 
			cdr = _cdr; 
		}

		public override bool unify(Term t, Trail trail) {
			t = t.dereference();
			if ( t.isVariable() )
				return ((VariableTerm)t).unify(this, trail);
			if ( !t.isList() )
				return false;
			ListTerm t1 = (ListTerm)t;
			return car.unify(t1.car, trail) && cdr.unify(t1.cdr, trail);
		}

		public override bool Equals(Term t) {
			//	t = t.dereference();
			if ( !t.isList() )
				return false;
			ListTerm t1 = (ListTerm)t;
			return car.Equals(t1.car.dereference()) && cdr.Equals(t1.cdr.dereference());
		}

		//    public Term copyTerm(Hashtable table) {
		//	return new ListTerm(car.copyTerm(table), cdr.copyTerm(table));
		//    }

		public override Term copyTerm(Prolog engine) {
			return new ListTerm(car.copyTerm(engine), cdr.copyTerm(engine));
		}

		// $B$"$^$j$h$/$J$$!*(B
		public int length() {
			int count = 0;
			Term tmp = this;
			while( tmp.isList() ){
				count++;
				tmp = ((ListTerm)tmp).cdr.dereference();
			}
			return count;
		}

		/*
		public int length() {
		int count = 1;
		Term x = cdr.dereference();
		while(! x.isNil()){
			count++;
			x = (((ListTerm) x).cdr()).dereference();
		}
		return count;
		}*/

		/*
		public Class getJavaType() {
		return java.lang.Object[].class;
		}*/

		public override object toCsObject() {
			int len = length();
			object array = null;
			try {
				// PUT BACK! array = Array.newInstance(Object.class, len);
				Term tmp = this;
				object element = null;
				for (int i=0; i<len; i++) {
					element = ((ListTerm)tmp).car.dereference().toCsObject();
					// PUT BACK! Array.set(array, i, element);
					tmp = ((ListTerm)tmp).cdr.dereference();
				}
			} catch (System.Exception e){
				System.Console.WriteLine( e.Message );
				System.Console.WriteLine("{ERROR : " + this + "}");
			}
			return array;
		}

		/*
		public Object toCsObject() {
		int len = length();
		Object[] objects = new java.lang.Object[len];
		Term tmp = this;
		for (int i=0; i<len; i++) {
			objects[i] = ((ListTerm)tmp).car().toCsObject();
			tmp = ((ListTerm)tmp).cdr();
		}
		return objects;
		}*/

		/*
		public Object toCsObject() {
		Vector vec = new Vector();
		Term tmp = this;
		while( tmp.isList()){
			vec.addElement(((ListTerm)tmp).car().toCsObject());
			tmp = ((ListTerm)tmp).cdr();	    
		}
		return vec;
		}*/

		public override string ToString() {
			string s;
			Term x = this;

			s = "[";
			for (;;) {
				s += ((ListTerm)x).car.ToString();
				x = ((ListTerm)x).cdr.dereference();
				if (!(x is ListTerm))
					break;
				s += ",";
			}
			if (! x.isNil()) {
				s += "|" + x.ToString();
			}
			s += "]";
			return s;
		}
	}

}