/*
 * *** Please do not edit ! ***
 * @(#) dollar_assertCurrentPredicate_2.cs
 * @procedure $assert_current_predicate/2 in built.pl
 */

/*
 * @version Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_assertCurrentPredicate_2 : Predicate {
    static internal readonly Predicate dollar_assertCurrentPredicate_2_1 = new Predicates.dollar_assertCurrentPredicate_2_1();
    static internal readonly Predicate dollar_assertCurrentPredicate_2_2 = new Predicates.dollar_assertCurrentPredicate_2_2();
    static internal readonly Predicate dollar_assertCurrentPredicate_2_sub_1 = new Predicates.dollar_assertCurrentPredicate_2_sub_1();

    public Term arg1, arg2;

    public dollar_assertCurrentPredicate_2(Term a1, Term a2, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        this.cont = cont;
    }

    public dollar_assertCurrentPredicate_2(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        this.cont = cont;
    }

    public override Predicate exec() {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.cont = cont;
        return call();
    }

    public virtual Predicate call() {
        engine.setB0();
        return engine.jtry(dollar_assertCurrentPredicate_2_1, dollar_assertCurrentPredicate_2_sub_1);
    }

    public override int arity() { return 2; }

    public override string ToString() {
        return "$assert_current_predicate(" + arg1 + ", " + arg2 + ")";
    }
}

sealed class dollar_assertCurrentPredicate_2_sub_1 : dollar_assertCurrentPredicate_2 {

    public override Predicate exec() {
        return engine.trust(dollar_assertCurrentPredicate_2_2);
    }
}

sealed class dollar_assertCurrentPredicate_2_1 : dollar_assertCurrentPredicate_2 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("/", 2);
    static internal readonly SymbolTerm f2 = SymbolTerm.makeSymbol("$current_predicates", 2);

    public override Predicate exec() {
        Term a1, a2, a3, a4, a5, a6;
        Predicate p1, p2;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        this.cont = engine.cont;

        if ( a2.isStructure() ){
            if (f1 != ((StructureTerm)a2).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a2).args;
            a3 = args[0];
            a4 = args[1];
        } else if (a2.isVariable() ){
            a3 = engine.makeVariable();
            a4 = engine.makeVariable();
            Term[] args = {a3, a4};
            if ( !a2.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        a5 = engine.makeVariable();
        Term[] h3 = {a3, a4};
        a6 = new StructureTerm(f2, h3);
        p1 = new Predicates.dollar_cut_1(a5, cont);
        p2 = new Predicates.Clause_3(a1, a6, engine.makeVariable(), p1);
        return new Predicates.dollar_getLevel_1(a5, p2);
    }
}

sealed class dollar_assertCurrentPredicate_2_2 : dollar_assertCurrentPredicate_2 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("/", 2);
    static internal readonly SymbolTerm f2 = SymbolTerm.makeSymbol("$current_predicates", 2);

    public override Predicate exec() {
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9, a10;
        Predicate p1, p2, p3;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        this.cont = engine.cont;

        if ( a2.isStructure() ){
            if (f1 != ((StructureTerm)a2).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a2).args;
            a3 = args[0];
            a4 = args[1];
        } else if (a2.isVariable() ){
            a3 = engine.makeVariable();
            a4 = engine.makeVariable();
            Term[] args = {a3, a4};
            if ( !a2.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        Term[] h3 = {a3, a4};
        a5 = new StructureTerm(f2, h3);
        a6 = engine.makeVariable();
        a7 = engine.makeVariable();
        a8 = engine.makeVariable();
        a9 = new ListTerm(a7, a8);
        a10 = engine.makeVariable();
        p1 = new Predicates.dollar_putTerm_3(a1, a6, a10, cont);
        p2 = new Predicates.dollar_copyTerm_2(a9, a10, p1);
        p3 = new Predicates.dollar_getTerm_3(a1, a6, a8, p2);
        return new Predicates.dollar_canonicalClause_3(a5, a6, a7, p3);
    }
}
}

