/*
 * *** Please do not edit ! ***
 * @(#) dollar_dcgConnect_4.cs
 * @procedure $dcg_connect/4 in built.pl
 */

/*
 * @version Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_dcgConnect_4 : Predicate {
    static internal readonly Predicate dollar_dcgConnect_4_1 = new Predicates.dollar_dcgConnect_4_1();
    static internal readonly Predicate dollar_dcgConnect_4_2 = new Predicates.dollar_dcgConnect_4_2();
    static internal readonly Predicate dollar_dcgConnect_4_3 = new Predicates.dollar_dcgConnect_4_3();
    static internal readonly Predicate dollar_dcgConnect_4_con = new Predicates.dollar_dcgConnect_4_con();
    static internal readonly Predicate dollar_dcgConnect_4_int = new Predicates.dollar_dcgConnect_4_int();
    static internal readonly Predicate dollar_dcgConnect_4_lis = new Predicates.dollar_dcgConnect_4_lis();
    static internal readonly Predicate dollar_dcgConnect_4_var = new Predicates.dollar_dcgConnect_4_var();

    public Term arg1, arg2, arg3, arg4;

    public dollar_dcgConnect_4(Term a1, Term a2, Term a3, Term a4, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        arg4 = a4; 
        this.cont = cont;
    }

    public dollar_dcgConnect_4(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        arg4 = args[3]; 
        this.cont = cont;
    }

    public override Predicate exec() {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.aregs[3] = arg3;
        engine.aregs[4] = arg4;
        engine.cont = cont;
        return call();
    }

    public virtual Predicate call() {
        engine.setB0();
        return engine.switch_on_term(
                                   dollar_dcgConnect_4_var,
                                   dollar_dcgConnect_4_int,
                                   dollar_dcgConnect_4_con,
                                   dollar_dcgConnect_4_var,
                                   dollar_dcgConnect_4_lis
                                   );
    }

    public override int arity() { return 4; }

    public override string ToString() {
        return "$dcg_connect(" + arg1 + ", " + arg2 + ", " + arg3 + ", " + arg4 + ")";
    }
}

sealed class dollar_dcgConnect_4_var : dollar_dcgConnect_4 {
    static internal readonly Predicate dollar_dcgConnect_4_var_1 = new Predicates.dollar_dcgConnect_4_var_1();

    public override Predicate exec() {
        return engine.jtry(dollar_dcgConnect_4_1, dollar_dcgConnect_4_var_1);
    }
}

sealed class dollar_dcgConnect_4_var_1 : dollar_dcgConnect_4 {
    static internal readonly Predicate dollar_dcgConnect_4_var_2 = new Predicates.dollar_dcgConnect_4_var_2();

    public override Predicate exec() {
        return engine.retry(dollar_dcgConnect_4_2, dollar_dcgConnect_4_var_2);
    }
}

sealed class dollar_dcgConnect_4_var_2 : dollar_dcgConnect_4 {

    public override Predicate exec() {
        return engine.trust(dollar_dcgConnect_4_3);
    }
}

sealed class dollar_dcgConnect_4_int : dollar_dcgConnect_4 {
    static internal readonly Predicate dollar_dcgConnect_4_int_1 = new Predicates.dollar_dcgConnect_4_int_1();

    public override Predicate exec() {
        return engine.jtry(dollar_dcgConnect_4_2, dollar_dcgConnect_4_int_1);
    }
}

sealed class dollar_dcgConnect_4_int_1 : dollar_dcgConnect_4 {

    public override Predicate exec() {
        return engine.trust(dollar_dcgConnect_4_3);
    }
}

sealed class dollar_dcgConnect_4_con : dollar_dcgConnect_4 {
    static internal readonly Predicate dollar_dcgConnect_4_con_1 = new Predicates.dollar_dcgConnect_4_con_1();

    public override Predicate exec() {
        return engine.jtry(dollar_dcgConnect_4_2, dollar_dcgConnect_4_con_1);
    }
}

sealed class dollar_dcgConnect_4_con_1 : dollar_dcgConnect_4 {

    public override Predicate exec() {
        return engine.trust(dollar_dcgConnect_4_3);
    }
}

sealed class dollar_dcgConnect_4_lis : dollar_dcgConnect_4 {
    static internal readonly Predicate dollar_dcgConnect_4_lis_1 = new Predicates.dollar_dcgConnect_4_lis_1();

    public override Predicate exec() {
        return engine.jtry(dollar_dcgConnect_4_2, dollar_dcgConnect_4_lis_1);
    }
}

sealed class dollar_dcgConnect_4_lis_1 : dollar_dcgConnect_4 {

    public override Predicate exec() {
        return engine.trust(dollar_dcgConnect_4_3);
    }
}

sealed class dollar_dcgConnect_4_1 : dollar_dcgConnect_4 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("->", 2);

    public override Predicate exec() {
        Term a1, a2, a3, a4, a5, a6, a7;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        this.cont = engine.cont;

        if ( a1.isStructure() ){
            if (f1 != ((StructureTerm)a1).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a1).args;
        } else if (a1.isVariable() ){
            Term[] args = {engine.makeVariable(), engine.makeVariable()};
            if ( !a1.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a2.isStructure() ){
            if (f1 != ((StructureTerm)a2).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a2).args;
            a5 = args[0];
            a6 = args[1];
        } else if (a2.isVariable() ){
            a5 = engine.makeVariable();
            a6 = engine.makeVariable();
            Term[] args = {a5, a6};
            if ( !a2.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a4.isStructure() ){
            if (f1 != ((StructureTerm)a4).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a4).args;
            if ( !a5.unify(args[0],  engine.trail) )
                return engine.fail();
            a7 = args[1];
        } else if (a4.isVariable() ){
            a7 = engine.makeVariable();
            Term[] args = {a5, a7};
            if ( !a4.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        p1 = new Predicates.dollar_dcgAnd_3(a6, a3, a7, cont);
        return new Predicates.dollar_neckCut_0(p1);
    }
}

sealed class dollar_dcgConnect_4_2 : dollar_dcgConnect_4 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("->", 2);
    static internal readonly SymbolTerm f2 = SymbolTerm.makeSymbol(",", 2);

    public override Predicate exec() {
        Term a1, a2, a3, a4, a5, a6, a7;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        this.cont = engine.cont;

        if ( a2.isStructure() ){
            if (f1 != ((StructureTerm)a2).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a2).args;
            a5 = args[0];
            a6 = args[1];
        } else if (a2.isVariable() ){
            a5 = engine.makeVariable();
            a6 = engine.makeVariable();
            Term[] args = {a5, a6};
            if ( !a2.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a4.isStructure() ){
            if (f2 != ((StructureTerm)a4).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a4).args;
            a7 = args[0];
            if ( !a3.unify(args[1],  engine.trail) )
                return engine.fail();
        } else if (a4.isVariable() ){
            a7 = engine.makeVariable();
            Term[] args = {a7, a3};
            if ( !a4.unify(new StructureTerm(f2, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a7.isStructure() ){
            if (f1 != ((StructureTerm)a7).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a7).args;
            if ( !a5.unify(args[0],  engine.trail) )
                return engine.fail();
            if ( !a6.unify(args[1],  engine.trail) )
                return engine.fail();
        } else if (a7.isVariable() ){
            Term[] args = {a5, a6};
            if ( !a7.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        return new Predicates.dollar_neckCut_0(cont);
    }
}

sealed class dollar_dcgConnect_4_3 : dollar_dcgConnect_4 {

    public override Predicate exec() {
        Term a1, a2, a3, a4;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        this.cont = engine.cont;

        return new Predicates.dollar_dcgAnd_3(a2, a3, a4, cont);
    }
}
}

