/*
 * *** Please do not edit ! ***
 * @(#) dollar_illarg_3.cs
 * @procedure $illarg/3 in built.pl
 */

/*
 * @version Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_illarg_3 : Predicate {
    static internal readonly Predicate dollar_illarg_3_1 = new Predicates.dollar_illarg_3_1();
    static internal readonly Predicate dollar_illarg_3_2 = new Predicates.dollar_illarg_3_2();
    static internal readonly Predicate dollar_illarg_3_3 = new Predicates.dollar_illarg_3_3();
    static internal readonly Predicate dollar_illarg_3_4 = new Predicates.dollar_illarg_3_4();
    static internal readonly Predicate dollar_illarg_3_5 = new Predicates.dollar_illarg_3_5();
    static internal readonly Predicate dollar_illarg_3_6 = new Predicates.dollar_illarg_3_6();
    static internal readonly Predicate dollar_illarg_3_7 = new Predicates.dollar_illarg_3_7();
    static internal readonly Predicate dollar_illarg_3_con = new Predicates.dollar_illarg_3_con();
    static internal readonly Predicate dollar_illarg_3_str = new Predicates.dollar_illarg_3_str();
    static internal readonly Predicate dollar_illarg_3_var = new Predicates.dollar_illarg_3_var();

    public Term arg1, arg2, arg3;

    public dollar_illarg_3(Term a1, Term a2, Term a3, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        this.cont = cont;
    }

    public dollar_illarg_3(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        this.cont = cont;
    }

    public override Predicate exec() {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.aregs[3] = arg3;
        engine.cont = cont;
        return call();
    }

    public virtual Predicate call() {
        engine.setB0();
        return engine.switch_on_term(
                                   dollar_illarg_3_var,
                                   dollar_illarg_3_7,
                                   dollar_illarg_3_con,
                                   dollar_illarg_3_str,
                                   dollar_illarg_3_7
                                   );
    }

    public override int arity() { return 3; }

    public override string ToString() {
        return "$illarg(" + arg1 + ", " + arg2 + ", " + arg3 + ")";
    }
}

sealed class dollar_illarg_3_var : dollar_illarg_3 {
    static internal readonly Predicate dollar_illarg_3_var_1 = new Predicates.dollar_illarg_3_var_1();

    public override Predicate exec() {
        return engine.jtry(dollar_illarg_3_1, dollar_illarg_3_var_1);
    }
}

sealed class dollar_illarg_3_var_1 : dollar_illarg_3 {
    static internal readonly Predicate dollar_illarg_3_var_2 = new Predicates.dollar_illarg_3_var_2();

    public override Predicate exec() {
        return engine.retry(dollar_illarg_3_2, dollar_illarg_3_var_2);
    }
}

sealed class dollar_illarg_3_var_2 : dollar_illarg_3 {
    static internal readonly Predicate dollar_illarg_3_var_3 = new Predicates.dollar_illarg_3_var_3();

    public override Predicate exec() {
        return engine.retry(dollar_illarg_3_3, dollar_illarg_3_var_3);
    }
}

sealed class dollar_illarg_3_var_3 : dollar_illarg_3 {
    static internal readonly Predicate dollar_illarg_3_var_4 = new Predicates.dollar_illarg_3_var_4();

    public override Predicate exec() {
        return engine.retry(dollar_illarg_3_4, dollar_illarg_3_var_4);
    }
}

sealed class dollar_illarg_3_var_4 : dollar_illarg_3 {
    static internal readonly Predicate dollar_illarg_3_var_5 = new Predicates.dollar_illarg_3_var_5();

    public override Predicate exec() {
        return engine.retry(dollar_illarg_3_5, dollar_illarg_3_var_5);
    }
}

sealed class dollar_illarg_3_var_5 : dollar_illarg_3 {
    static internal readonly Predicate dollar_illarg_3_var_6 = new Predicates.dollar_illarg_3_var_6();

    public override Predicate exec() {
        return engine.retry(dollar_illarg_3_6, dollar_illarg_3_var_6);
    }
}

sealed class dollar_illarg_3_var_6 : dollar_illarg_3 {

    public override Predicate exec() {
        return engine.trust(dollar_illarg_3_7);
    }
}

sealed class dollar_illarg_3_con : dollar_illarg_3 {
    static internal readonly Predicate dollar_illarg_3_con_1 = new Predicates.dollar_illarg_3_con_1();

    public override Predicate exec() {
        return engine.jtry(dollar_illarg_3_1, dollar_illarg_3_con_1);
    }
}

sealed class dollar_illarg_3_con_1 : dollar_illarg_3 {

    public override Predicate exec() {
        return engine.trust(dollar_illarg_3_7);
    }
}

sealed class dollar_illarg_3_str : dollar_illarg_3 {
    static internal readonly Predicate dollar_illarg_3_str_1 = new Predicates.dollar_illarg_3_str_1();

    public override Predicate exec() {
        return engine.jtry(dollar_illarg_3_2, dollar_illarg_3_str_1);
    }
}

sealed class dollar_illarg_3_str_1 : dollar_illarg_3 {
    static internal readonly Predicate dollar_illarg_3_str_2 = new Predicates.dollar_illarg_3_str_2();

    public override Predicate exec() {
        return engine.retry(dollar_illarg_3_3, dollar_illarg_3_str_2);
    }
}

sealed class dollar_illarg_3_str_2 : dollar_illarg_3 {
    static internal readonly Predicate dollar_illarg_3_str_3 = new Predicates.dollar_illarg_3_str_3();

    public override Predicate exec() {
        return engine.retry(dollar_illarg_3_4, dollar_illarg_3_str_3);
    }
}

sealed class dollar_illarg_3_str_3 : dollar_illarg_3 {
    static internal readonly Predicate dollar_illarg_3_str_4 = new Predicates.dollar_illarg_3_str_4();

    public override Predicate exec() {
        return engine.retry(dollar_illarg_3_5, dollar_illarg_3_str_4);
    }
}

sealed class dollar_illarg_3_str_4 : dollar_illarg_3 {
    static internal readonly Predicate dollar_illarg_3_str_5 = new Predicates.dollar_illarg_3_str_5();

    public override Predicate exec() {
        return engine.retry(dollar_illarg_3_6, dollar_illarg_3_str_5);
    }
}

sealed class dollar_illarg_3_str_5 : dollar_illarg_3 {

    public override Predicate exec() {
        return engine.trust(dollar_illarg_3_7);
    }
}

sealed class dollar_illarg_3_1 : dollar_illarg_3 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("var");
    static internal readonly SymbolTerm f2 = SymbolTerm.makeSymbol("instantiation_error", 2);

    public override Predicate exec() {
        Term a1, a2, a3, a4;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        this.cont = engine.cont;

        if ( !s1.unify(a1, engine.trail) ) return engine.fail();
        Term[] h3 = {a2, a3};
        a4 = new StructureTerm(f2, h3);
        return new Predicates.dollar_printError_1(a4, cont);
    }
}

sealed class dollar_illarg_3_2 : dollar_illarg_3 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("type", 1);

    public override Predicate exec() {
        Term a1, a2, a3, a4, a5, a6;
        Predicate p1, p2;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        this.cont = engine.cont;

        if ( a1.isStructure() ){
            if (f1 != ((StructureTerm)a1).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a1).args;
            a4 = args[0];
        } else if (a1.isVariable() ){
            a4 = engine.makeVariable();
            Term[] args = {a4};
            if ( !a1.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        a5 = engine.makeVariable();
        a6 = engine.makeVariable();
        p1 = new Predicates.dollar_printError_1(a6, cont);
        p2 = new Predicates.dollar_dummyBuilt__3_5(a4, a2, a3, a5, a6, p1);
        return new Predicates.dollar_arg_3(a3, a2, a5, p2);
    }
}

sealed class dollar_illarg_3_3 : dollar_illarg_3 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("domain", 2);

    public override Predicate exec() {
        Term a1, a2, a3, a4, a5, a6, a7;
        Predicate p1, p2;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        this.cont = engine.cont;

        if ( a1.isStructure() ){
            if (f1 != ((StructureTerm)a1).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a1).args;
            a4 = args[0];
            a5 = args[1];
        } else if (a1.isVariable() ){
            a4 = engine.makeVariable();
            a5 = engine.makeVariable();
            Term[] args = {a4, a5};
            if ( !a1.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        a6 = engine.makeVariable();
        a7 = engine.makeVariable();
        p1 = new Predicates.dollar_printError_1(a7, cont);
        p2 = new Predicates.dollar_dummyBuilt__4_6(a4, a5, a2, a3, a6, a7, p1);
        return new Predicates.dollar_arg_3(a3, a2, a6, p2);
    }
}

sealed class dollar_illarg_3_4 : dollar_illarg_3 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("context", 2);
    static internal readonly SymbolTerm f2 = SymbolTerm.makeSymbol("context_error", 3);

    public override Predicate exec() {
        Term a1, a2, a3, a4, a5, a6;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        this.cont = engine.cont;

        if ( a1.isStructure() ){
            if (f1 != ((StructureTerm)a1).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a1).args;
            a4 = args[0];
            a5 = args[1];
        } else if (a1.isVariable() ){
            a4 = engine.makeVariable();
            a5 = engine.makeVariable();
            Term[] args = {a4, a5};
            if ( !a1.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        Term[] h3 = {a2, a4, a5};
        a6 = new StructureTerm(f2, h3);
        return new Predicates.dollar_printError_1(a6, cont);
    }
}

sealed class dollar_illarg_3_5 : dollar_illarg_3 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("existence", 3);
    static internal readonly SymbolTerm f2 = SymbolTerm.makeSymbol("existence_error", 5);

    public override Predicate exec() {
        Term a1, a2, a3, a4, a5, a6, a7;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        this.cont = engine.cont;

        if ( a1.isStructure() ){
            if (f1 != ((StructureTerm)a1).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a1).args;
            a4 = args[0];
            a5 = args[1];
            a6 = args[2];
        } else if (a1.isVariable() ){
            a4 = engine.makeVariable();
            a5 = engine.makeVariable();
            a6 = engine.makeVariable();
            Term[] args = {a4, a5, a6};
            if ( !a1.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        Term[] h3 = {a2, a3, a4, a5, a6};
        a7 = new StructureTerm(f2, h3);
        return new Predicates.dollar_printError_1(a7, cont);
    }
}

sealed class dollar_illarg_3_6 : dollar_illarg_3 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("permission", 4);
    static internal readonly SymbolTerm f2 = SymbolTerm.makeSymbol("permission_error", 5);

    public override Predicate exec() {
        Term a1, a2, a3, a4, a5, a6, a7, a8;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        this.cont = engine.cont;

        if ( a1.isStructure() ){
            if (f1 != ((StructureTerm)a1).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a1).args;
            a4 = args[0];
            a5 = args[1];
            a6 = args[2];
            a7 = args[3];
        } else if (a1.isVariable() ){
            a4 = engine.makeVariable();
            a5 = engine.makeVariable();
            a6 = engine.makeVariable();
            a7 = engine.makeVariable();
            Term[] args = {a4, a5, a6, a7};
            if ( !a1.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        Term[] h3 = {a2, a4, a5, a6, a7};
        a8 = new StructureTerm(f2, h3);
        return new Predicates.dollar_printError_1(a8, cont);
    }
}

sealed class dollar_illarg_3_7 : dollar_illarg_3 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("Error Occurs !!");

    public override Predicate exec() {
        Term a1, a2, a3;
        Predicate p1, p2;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        this.cont = engine.cont;

        p1 = new Predicates.dollar_abort_0(cont);
        p2 = new Predicates.dollar_nl_0(p1);
        return new Predicates.Write_1(s1, p2);
    }
}
}

