/*
 * *** Please do not edit ! ***
 * @(#) dollar_listToString_2.cs
 * @procedure $list_to_string/2 in built.pl
 */

/*
 * @version Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_listToString_2 : Predicate {
    static internal readonly Predicate dollar_fail_0 = new Predicates.dollar_fail_0();
    static internal readonly Predicate dollar_listToString_2_1 = new Predicates.dollar_listToString_2_1();
    static internal readonly Predicate dollar_listToString_2_2 = new Predicates.dollar_listToString_2_2();
    static internal readonly Predicate dollar_listToString_2_var = new Predicates.dollar_listToString_2_var();

    public Term arg1, arg2;

    public dollar_listToString_2(Term a1, Term a2, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        this.cont = cont;
    }

    public dollar_listToString_2(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        this.cont = cont;
    }

    public override Predicate exec() {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.cont = cont;
        return call();
    }

    public virtual Predicate call() {
        engine.setB0();
        return engine.switch_on_term(
                                   dollar_listToString_2_var,
                                   dollar_fail_0,
                                   dollar_listToString_2_1,
                                   dollar_fail_0,
                                   dollar_listToString_2_2
                                   );
    }

    public override int arity() { return 2; }

    public override string ToString() {
        return "$list_to_string(" + arg1 + ", " + arg2 + ")";
    }
}

sealed class dollar_listToString_2_var : dollar_listToString_2 {
    static internal readonly Predicate dollar_listToString_2_var_1 = new Predicates.dollar_listToString_2_var_1();

    public override Predicate exec() {
        return engine.jtry(dollar_listToString_2_1, dollar_listToString_2_var_1);
    }
}

sealed class dollar_listToString_2_var_1 : dollar_listToString_2 {

    public override Predicate exec() {
        return engine.trust(dollar_listToString_2_2);
    }
}

sealed class dollar_listToString_2_1 : dollar_listToString_2 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("[]");
    static internal readonly SymbolTerm s2 = SymbolTerm.makeSymbol("");

    public override Predicate exec() {
        Term a1, a2;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        this.cont = engine.cont;

        if ( !s1.unify(a1, engine.trail) ) return engine.fail();
        p1 = new Predicates.dollar_unify_2(a2, s2, cont);
        return new Predicates.dollar_neckCut_0(p1);
    }
}

sealed class dollar_listToString_2_2 : dollar_listToString_2 {

    public override Predicate exec() {
        Term a1, a2, a3, a4, a5, a6, a7, a8;
        Predicate p1, p2, p3, p4;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        this.cont = engine.cont;

        if ( a1.isList() ){
            a3 = ((ListTerm)a1).car;
            a4 = ((ListTerm)a1).cdr;
        } else if ( a1.isVariable() ){
            a3 = engine.makeVariable();
            a4 = engine.makeVariable();
            if ( !a1.unify(new ListTerm(a3, a4), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        a5 = engine.makeVariable();
        a6 = engine.makeVariable();
        a7 = engine.makeVariable();
        a8 = engine.makeVariable();
        p1 = new Predicates.Name_2(a2, a8, cont);
        p2 = new Predicates.dollar_append_3(a5, a7, a8, p1);
        p3 = new Predicates.Name_2(a6, a7, p2);
        p4 = new Predicates.dollar_listToString_2(a4, a6, p3);
        return new Predicates.Name_2(a3, a5, p4);
    }
}
}

