/*
 * *** Please do not edit ! ***
 * @(#) dollar_listToTerm_3.cs
 * @procedure $list_to_term/3 in built.pl
 */

/*
 * @version Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_listToTerm_3 : Predicate {
    static internal readonly Predicate dollar_listToTerm_3_1 = new Predicates.dollar_listToTerm_3_1();
    static internal readonly Predicate dollar_listToTerm_3_2 = new Predicates.dollar_listToTerm_3_2();
    static internal readonly Predicate dollar_listToTerm_3_3 = new Predicates.dollar_listToTerm_3_3();
    static internal readonly Predicate dollar_listToTerm_3_con = new Predicates.dollar_listToTerm_3_con();
    static internal readonly Predicate dollar_listToTerm_3_lis = new Predicates.dollar_listToTerm_3_lis();
    static internal readonly Predicate dollar_listToTerm_3_var = new Predicates.dollar_listToTerm_3_var();

    public Term arg1, arg2, arg3;

    public dollar_listToTerm_3(Term a1, Term a2, Term a3, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        this.cont = cont;
    }

    public dollar_listToTerm_3(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        this.cont = cont;
    }

    public override Predicate exec() {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.aregs[3] = arg3;
        engine.cont = cont;
        return call();
    }

    public virtual Predicate call() {
        engine.setB0();
        return engine.switch_on_term(
                                   dollar_listToTerm_3_var,
                                   dollar_listToTerm_3_1,
                                   dollar_listToTerm_3_con,
                                   dollar_listToTerm_3_1,
                                   dollar_listToTerm_3_lis
                                   );
    }

    public override int arity() { return 3; }

    public override string ToString() {
        return "$list_to_term(" + arg1 + ", " + arg2 + ", " + arg3 + ")";
    }
}

sealed class dollar_listToTerm_3_var : dollar_listToTerm_3 {
    static internal readonly Predicate dollar_listToTerm_3_var_1 = new Predicates.dollar_listToTerm_3_var_1();

    public override Predicate exec() {
        return engine.jtry(dollar_listToTerm_3_1, dollar_listToTerm_3_var_1);
    }
}

sealed class dollar_listToTerm_3_var_1 : dollar_listToTerm_3 {
    static internal readonly Predicate dollar_listToTerm_3_var_2 = new Predicates.dollar_listToTerm_3_var_2();

    public override Predicate exec() {
        return engine.retry(dollar_listToTerm_3_2, dollar_listToTerm_3_var_2);
    }
}

sealed class dollar_listToTerm_3_var_2 : dollar_listToTerm_3 {

    public override Predicate exec() {
        return engine.trust(dollar_listToTerm_3_3);
    }
}

sealed class dollar_listToTerm_3_con : dollar_listToTerm_3 {
    static internal readonly Predicate dollar_listToTerm_3_con_1 = new Predicates.dollar_listToTerm_3_con_1();

    public override Predicate exec() {
        return engine.jtry(dollar_listToTerm_3_1, dollar_listToTerm_3_con_1);
    }
}

sealed class dollar_listToTerm_3_con_1 : dollar_listToTerm_3 {

    public override Predicate exec() {
        return engine.trust(dollar_listToTerm_3_2);
    }
}

sealed class dollar_listToTerm_3_lis : dollar_listToTerm_3 {
    static internal readonly Predicate dollar_listToTerm_3_lis_1 = new Predicates.dollar_listToTerm_3_lis_1();

    public override Predicate exec() {
        return engine.jtry(dollar_listToTerm_3_1, dollar_listToTerm_3_lis_1);
    }
}

sealed class dollar_listToTerm_3_lis_1 : dollar_listToTerm_3 {

    public override Predicate exec() {
        return engine.trust(dollar_listToTerm_3_3);
    }
}

sealed class dollar_listToTerm_3_1 : dollar_listToTerm_3 {

    public override Predicate exec() {
        Term a1, a2, a3, a4;
        Predicate p1, p2, p3;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        this.cont = engine.cont;

        a4 = engine.makeVariable();
        p1 = new Predicates.dollar_fail_0(cont);
        p2 = new Predicates.dollar_cut_1(a4, p1);
        p3 = new Predicates.dollar_var_1(a1, p2);
        return new Predicates.dollar_getLevel_1(a4, p3);
    }
}

sealed class dollar_listToTerm_3_2 : dollar_listToTerm_3 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("[]");

    public override Predicate exec() {
        Term a1, a2, a3;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        this.cont = engine.cont;

        if ( !s1.unify(a1, engine.trail) ) return engine.fail();
        return cont;
    }
}

sealed class dollar_listToTerm_3_3 : dollar_listToTerm_3 {
    static internal readonly IntegerTerm s1 = new IntegerTerm(1);

    public override Predicate exec() {
        Term a1, a2, a3, a4, a5, a6;
        Predicate p1, p2;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        this.cont = engine.cont;

        if ( a1.isList() ){
            a4 = ((ListTerm)a1).car;
            a5 = ((ListTerm)a1).cdr;
        } else if ( a1.isVariable() ){
            a4 = engine.makeVariable();
            a5 = engine.makeVariable();
            if ( !a1.unify(new ListTerm(a4, a5), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        a6 = engine.makeVariable();
        p1 = new Predicates.dollar_listToTerm_3(a5, a2, a6, cont);
        p2 = new Predicates.dollar_plus_3(a3, s1, a6, p1);
        return new Predicates.dollar_arg_3(a3, a2, a4, p2);
    }
}
}

