/*
 * *** Please do not edit ! ***
 * @(#) dollar_numbervars_3.cs
 * @procedure $numbervars/3 in built.pl
 */

/*
 * @version Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_numbervars_3 : Predicate {
    static internal readonly Predicate dollar_numbervars_3_1 = new Predicates.dollar_numbervars_3_1();
    static internal readonly Predicate dollar_numbervars_3_2 = new Predicates.dollar_numbervars_3_2();
    static internal readonly Predicate dollar_numbervars_3_3 = new Predicates.dollar_numbervars_3_3();
    static internal readonly Predicate dollar_numbervars_3_4 = new Predicates.dollar_numbervars_3_4();
    static internal readonly Predicate dollar_numbervars_3_sub_1 = new Predicates.dollar_numbervars_3_sub_1();

    public Term arg1, arg2, arg3;

    public dollar_numbervars_3(Term a1, Term a2, Term a3, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        this.cont = cont;
    }

    public dollar_numbervars_3(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        this.cont = cont;
    }

    public override Predicate exec() {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.aregs[3] = arg3;
        engine.cont = cont;
        return call();
    }

    public virtual Predicate call() {
        engine.setB0();
        return engine.jtry(dollar_numbervars_3_1, dollar_numbervars_3_sub_1);
    }

    public override int arity() { return 3; }

    public override string ToString() {
        return "$numbervars(" + arg1 + ", " + arg2 + ", " + arg3 + ")";
    }
}

sealed class dollar_numbervars_3_sub_1 : dollar_numbervars_3 {
    static internal readonly Predicate dollar_numbervars_3_sub_2 = new Predicates.dollar_numbervars_3_sub_2();

    public override Predicate exec() {
        return engine.retry(dollar_numbervars_3_2, dollar_numbervars_3_sub_2);
    }
}

sealed class dollar_numbervars_3_sub_2 : dollar_numbervars_3 {
    static internal readonly Predicate dollar_numbervars_3_sub_3 = new Predicates.dollar_numbervars_3_sub_3();

    public override Predicate exec() {
        return engine.retry(dollar_numbervars_3_3, dollar_numbervars_3_sub_3);
    }
}

sealed class dollar_numbervars_3_sub_3 : dollar_numbervars_3 {

    public override Predicate exec() {
        return engine.trust(dollar_numbervars_3_4);
    }
}

sealed class dollar_numbervars_3_1 : dollar_numbervars_3 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("$VAR", 1);
    static internal readonly IntegerTerm s3 = new IntegerTerm(1);

    public override Predicate exec() {
        Term a1, a2, a3, a4, a5;
        Predicate p1, p2, p3, p4;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        this.cont = engine.cont;

        a4 = engine.makeVariable();
        Term[] h2 = {a2};
        a5 = new StructureTerm(f1, h2);
        p1 = new Predicates.dollar_plus_3(a2, s3, a3, cont);
        p2 = new Predicates.dollar_unify_2(a1, a5, p1);
        p3 = new Predicates.dollar_cut_1(a4, p2);
        p4 = new Predicates.dollar_var_1(a1, p3);
        return new Predicates.dollar_getLevel_1(a4, p4);
    }
}

sealed class dollar_numbervars_3_2 : dollar_numbervars_3 {

    public override Predicate exec() {
        Term a1, a2, a3, a4;
        Predicate p1, p2;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        this.cont = engine.cont;

        if ( !a2.unify(a3, engine.trail) ) return engine.fail();
        a4 = engine.makeVariable();
        p1 = new Predicates.dollar_cut_1(a4, cont);
        p2 = new Predicates.dollar_atomic_1(a1, p1);
        return new Predicates.dollar_getLevel_1(a4, p2);
    }
}

sealed class dollar_numbervars_3_3 : dollar_numbervars_3 {

    public override Predicate exec() {
        Term a1, a2, a3, a4;
        Predicate p1, p2;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        this.cont = engine.cont;

        if ( !a2.unify(a3, engine.trail) ) return engine.fail();
        a4 = engine.makeVariable();
        p1 = new Predicates.dollar_cut_1(a4, cont);
        p2 = new Predicates.dollar_csObject_1(a1, p1);
        return new Predicates.dollar_getLevel_1(a4, p2);
    }
}

sealed class dollar_numbervars_3_4 : dollar_numbervars_3 {
    static internal readonly IntegerTerm s1 = new IntegerTerm(1);

    public override Predicate exec() {
        Term a1, a2, a3, a4;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        this.cont = engine.cont;

        a4 = engine.makeVariable();
        p1 = new Predicates.dollar_numbervarsStr_5(s1, a4, a1, a2, a3, cont);
        return new Predicates.dollar_functor_3(a1, engine.makeVariable(), a4, p1);
    }
}
}

