/*
 * *** Please do not edit ! ***
 * @(#) dollar_univInternal_2.cs
 * @procedure $univ_internal/2 in built.pl
 */

/*
 * @version Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_univInternal_2 : Predicate {
    static internal readonly Predicate dollar_univInternal_2_1 = new Predicates.dollar_univInternal_2_1();
    static internal readonly Predicate dollar_univInternal_2_2 = new Predicates.dollar_univInternal_2_2();
    static internal readonly Predicate dollar_univInternal_2_sub_1 = new Predicates.dollar_univInternal_2_sub_1();

    public Term arg1, arg2;

    public dollar_univInternal_2(Term a1, Term a2, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        this.cont = cont;
    }

    public dollar_univInternal_2(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        this.cont = cont;
    }

    public override Predicate exec() {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.cont = cont;
        return call();
    }

    public virtual Predicate call() {
        engine.setB0();
        return engine.jtry(dollar_univInternal_2_1, dollar_univInternal_2_sub_1);
    }

    public override int arity() { return 2; }

    public override string ToString() {
        return "$univ_internal(" + arg1 + ", " + arg2 + ")";
    }
}

sealed class dollar_univInternal_2_sub_1 : dollar_univInternal_2 {

    public override Predicate exec() {
        return engine.trust(dollar_univInternal_2_2);
    }
}

sealed class dollar_univInternal_2_1 : dollar_univInternal_2 {

    public override Predicate exec() {
        Term a1, a2, a3;
        Predicate p1, p2;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        this.cont = engine.cont;

        a3 = engine.makeVariable();
        p1 = new Predicates.dollar_cut_1(a3, cont);
        p2 = new Predicates.dollar_listToTerm_2(a2, a1, p1);
        return new Predicates.dollar_getLevel_1(a3, p2);
    }
}

sealed class dollar_univInternal_2_2 : dollar_univInternal_2 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("var");
    static internal readonly SymbolTerm f2 = SymbolTerm.makeSymbol("=..", 2);
    static internal readonly IntegerTerm s4 = new IntegerTerm(2);

    public override Predicate exec() {
        Term a1, a2, a3;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        this.cont = engine.cont;

        Term[] h3 = {a1, a2};
        a3 = new StructureTerm(f2, h3);
        return new Predicates.dollar_illarg_3(s1, a3, s4, cont);
    }
}
}

