/*
 * *** Please do not edit ! ***
 * @(#) dollar_writeStatistics_2.cs
 * @procedure $write_statistics/2 in built.pl
 */

/*
 * @version Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_writeStatistics_2 : Predicate {
    static internal readonly Predicate dollar_writeStatistics_2_1 = new Predicates.dollar_writeStatistics_2_1();
    static internal readonly Predicate dollar_writeStatistics_2_2 = new Predicates.dollar_writeStatistics_2_2();
    static internal readonly Predicate dollar_writeStatistics_2_var = new Predicates.dollar_writeStatistics_2_var();

    public Term arg1, arg2;

    public dollar_writeStatistics_2(Term a1, Term a2, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        this.cont = cont;
    }

    public dollar_writeStatistics_2(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        this.cont = cont;
    }

    public override Predicate exec() {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.cont = cont;
        return call();
    }

    public virtual Predicate call() {
        engine.setB0();
        return engine.switch_on_term(
                                   dollar_writeStatistics_2_var,
                                   dollar_writeStatistics_2_2,
                                   dollar_writeStatistics_2_var,
                                   dollar_writeStatistics_2_2,
                                   dollar_writeStatistics_2_2
                                   );
    }

    public override int arity() { return 2; }

    public override string ToString() {
        return "$write_statistics(" + arg1 + ", " + arg2 + ")";
    }
}

sealed class dollar_writeStatistics_2_var : dollar_writeStatistics_2 {
    static internal readonly Predicate dollar_writeStatistics_2_var_1 = new Predicates.dollar_writeStatistics_2_var_1();

    public override Predicate exec() {
        return engine.jtry(dollar_writeStatistics_2_1, dollar_writeStatistics_2_var_1);
    }
}

sealed class dollar_writeStatistics_2_var_1 : dollar_writeStatistics_2 {

    public override Predicate exec() {
        return engine.trust(dollar_writeStatistics_2_2);
    }
}

sealed class dollar_writeStatistics_2_1 : dollar_writeStatistics_2 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("runtime");
    static internal readonly SymbolTerm s2 = SymbolTerm.makeSymbol("[]");
    static internal readonly SymbolTerm s3 = SymbolTerm.makeSymbol("runtime = ");
    static internal readonly SymbolTerm s4 = SymbolTerm.makeSymbol(" from start, ");
    static internal readonly SymbolTerm s5 = SymbolTerm.makeSymbol(" from previous");

    public override Predicate exec() {
        Term a1, a2, a3, a4, a5;
        Predicate p1, p2, p3, p4, p5, p6;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        this.cont = engine.cont;

        if ( !s1.unify(a1, engine.trail) ) return engine.fail();
        if ( a2.isList() ){
            a3 = ((ListTerm)a2).car;
            a4 = ((ListTerm)a2).cdr;
        } else if ( a2.isVariable() ){
            a3 = engine.makeVariable();
            a4 = engine.makeVariable();
            if ( !a2.unify(new ListTerm(a3, a4), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a4.isList() ){
            a5 = ((ListTerm)a4).car;
            if ( !s2.unify(((ListTerm)a4).cdr, engine.trail) )
                return engine.fail();
        } else if ( a4.isVariable() ){
            a5 = engine.makeVariable();
            if ( !a4.unify(new ListTerm(a5, s2), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        p1 = new Predicates.dollar_nl_0(cont);
        p2 = new Predicates.Write_1(s5, p1);
        p3 = new Predicates.Write_1(a5, p2);
        p4 = new Predicates.Write_1(s4, p3);
        p5 = new Predicates.Write_1(a3, p4);
        p6 = new Predicates.Write_1(s3, p5);
        return new Predicates.dollar_neckCut_0(p6);
    }
}

sealed class dollar_writeStatistics_2_2 : dollar_writeStatistics_2 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("[]");
    static internal readonly SymbolTerm s2 = SymbolTerm.makeSymbol(" = ");
    static internal readonly SymbolTerm s3 = SymbolTerm.makeSymbol(" entries, ");
    static internal readonly SymbolTerm s4 = SymbolTerm.makeSymbol(" in use, ");
    static internal readonly SymbolTerm s5 = SymbolTerm.makeSymbol(" in free");

    public override Predicate exec() {
        Term a1, a2, a3, a4, a5, a6;
        Predicate p1, p2, p3, p4, p5, p6, p7, p8, p9;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        this.cont = engine.cont;

        if ( a2.isList() ){
            a3 = ((ListTerm)a2).car;
            a4 = ((ListTerm)a2).cdr;
        } else if ( a2.isVariable() ){
            a3 = engine.makeVariable();
            a4 = engine.makeVariable();
            if ( !a2.unify(new ListTerm(a3, a4), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a4.isList() ){
            a5 = ((ListTerm)a4).car;
            if ( !s1.unify(((ListTerm)a4).cdr, engine.trail) )
                return engine.fail();
        } else if ( a4.isVariable() ){
            a5 = engine.makeVariable();
            if ( !a4.unify(new ListTerm(a5, s1), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        a6 = engine.makeVariable();
        p1 = new Predicates.dollar_nl_0(cont);
        p2 = new Predicates.Write_1(s5, p1);
        p3 = new Predicates.Write_1(a5, p2);
        p4 = new Predicates.Write_1(s4, p3);
        p5 = new Predicates.Write_1(a3, p4);
        p6 = new Predicates.Write_1(s3, p5);
        p7 = new Predicates.Write_1(a6, p6);
        p8 = new Predicates.Write_1(s2, p7);
        p9 = new Predicates.Write_1(a1, p8);
        return new Predicates.dollar_plus_3(a3, a5, a6, p9);
    }
}
}

