/*
 * *** Please do not edit ! ***
 * @(#) eq_stop_stop_2.cs
 * @procedure =.. /2 in built.pl
 */

/*
 * @version Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class eq_stop_stop_2 : Predicate {
    static internal readonly Predicate eq_stop_stop_2_1 = new Predicates.eq_stop_stop_2_1();
    static internal readonly Predicate eq_stop_stop_2_2 = new Predicates.eq_stop_stop_2_2();
    static internal readonly Predicate eq_stop_stop_2_3 = new Predicates.eq_stop_stop_2_3();
    static internal readonly Predicate eq_stop_stop_2_sub_1 = new Predicates.eq_stop_stop_2_sub_1();

    public Term arg1, arg2;

    public eq_stop_stop_2(Term a1, Term a2, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        this.cont = cont;
    }

    public eq_stop_stop_2(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        this.cont = cont;
    }

    public override Predicate exec() {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.cont = cont;
        return call();
    }

    public virtual Predicate call() {
        engine.setB0();
        return engine.jtry(eq_stop_stop_2_1, eq_stop_stop_2_sub_1);
    }

    public override int arity() { return 2; }

    public override string ToString() {
        return "=..(" + arg1 + ", " + arg2 + ")";
    }
}

sealed class eq_stop_stop_2_sub_1 : eq_stop_stop_2 {
    static internal readonly Predicate eq_stop_stop_2_sub_2 = new Predicates.eq_stop_stop_2_sub_2();

    public override Predicate exec() {
        return engine.retry(eq_stop_stop_2_2, eq_stop_stop_2_sub_2);
    }
}

sealed class eq_stop_stop_2_sub_2 : eq_stop_stop_2 {

    public override Predicate exec() {
        return engine.trust(eq_stop_stop_2_3);
    }
}

sealed class eq_stop_stop_2_1 : eq_stop_stop_2 {
    static internal readonly IntegerTerm s1 = new IntegerTerm(1);

    public override Predicate exec() {
        Term a1, a2, a3, a4, a5, a6, a7;
        Predicate p1, p2, p3, p4, p5;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        this.cont = engine.cont;

        a3 = engine.makeVariable();
        a4 = engine.makeVariable();
        a5 = engine.makeVariable();
        a6 = engine.makeVariable();
        a7 = new ListTerm(a4, a6);
        p1 = new Predicates.dollar_unify_2(a2, a7, cont);
        p2 = new Predicates.dollar_termToList_4(a1, s1, a5, a6, p1);
        p3 = new Predicates.dollar_functor_3(a1, a4, a5, p2);
        p4 = new Predicates.dollar_cut_1(a3, p3);
        p5 = new Predicates.dollar_nonvar_1(a1, p4);
        return new Predicates.dollar_getLevel_1(a3, p5);
    }
}

sealed class eq_stop_stop_2_2 : eq_stop_stop_2 {

    public override Predicate exec() {
        Term a1, a2, a3;
        Predicate p1, p2, p3;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        this.cont = engine.cont;

        a3 = engine.makeVariable();
        p1 = new Predicates.dollar_univInternal_2(a1, a2, cont);
        p2 = new Predicates.dollar_cut_1(a3, p1);
        p3 = new Predicates.dollar_nonvar_1(a2, p2);
        return new Predicates.dollar_getLevel_1(a3, p3);
    }
}

sealed class eq_stop_stop_2_3 : eq_stop_stop_2 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("var");
    static internal readonly SymbolTerm f2 = SymbolTerm.makeSymbol("=..", 2);
    static internal readonly IntegerTerm s4 = new IntegerTerm(2);

    public override Predicate exec() {
        Term a1, a2, a3;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        this.cont = engine.cont;

        Term[] h3 = {a1, a2};
        a3 = new StructureTerm(f2, h3);
        return new Predicates.dollar_illarg_3(s1, a3, s4, cont);
    }
}
}

