/*
 * *** Please do not edit ! ***
 * @(#) Callable_1.cs
 * @procedure callable/1 in built.pl
 */

/*
 * @version Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class Callable_1 : Predicate {
    static internal readonly Predicate Callable_1_1 = new Predicates.Callable_1_1();
    static internal readonly Predicate Callable_1_2 = new Predicates.Callable_1_2();
    static internal readonly Predicate Callable_1_sub_1 = new Predicates.Callable_1_sub_1();

    public Term arg1;

    public Callable_1(Term a1, Predicate cont) {
        arg1 = a1; 
        this.cont = cont;
    }

    public Callable_1(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        this.cont = cont;
    }

    public override Predicate exec() {
        engine.aregs[1] = arg1;
        engine.cont = cont;
        return call();
    }

    public virtual Predicate call() {
        engine.setB0();
        return engine.jtry(Callable_1_1, Callable_1_sub_1);
    }

    public override int arity() { return 1; }

    public override string ToString() {
        return "callable(" + arg1 + ")";
    }
}

sealed class Callable_1_sub_1 : Callable_1 {

    public override Predicate exec() {
        return engine.trust(Callable_1_2);
    }
}

sealed class Callable_1_1 : Callable_1 {

    public override Predicate exec() {
        Term a1, a2;
        Predicate p1, p2;
        a1 = engine.aregs[1].dereference();
        this.cont = engine.cont;

        a2 = engine.makeVariable();
        p1 = new Predicates.dollar_cut_1(a2, cont);
        p2 = new Predicates.dollar_atom_1(a1, p1);
        return new Predicates.dollar_getLevel_1(a2, p2);
    }
}

sealed class Callable_1_2 : Callable_1 {

    public override Predicate exec() {
        Term a1;
        a1 = engine.aregs[1].dereference();
        this.cont = engine.cont;

        return new Predicates.Compound_1(a1, cont);
    }
}
}

