/*
 * *** Please do not edit ! ***
 * @(#) Compound_1.cs
 * @procedure compound/1 in built.pl
 */

/*
 * @version Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class Compound_1 : Predicate {
    static internal readonly IntegerTerm s1 = new IntegerTerm(0);

    public Term arg1;

    public Compound_1(Term a1, Predicate cont) {
        arg1 = a1; 
        this.cont = cont;
    }

    public Compound_1(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        this.cont = cont;
    }

    public override Predicate exec() {
        engine.setB0();
        Term a1, a2;
        Predicate p1, p2;
        a1 = arg1.dereference();

        a2 = engine.makeVariable();
        p1 = new Predicates.dollar_greaterThan_2(a2, s1, cont);
        p2 = new Predicates.dollar_functor_3(a1, engine.makeVariable(), a2, p1);
        return new Predicates.dollar_nonvar_1(a1, p2);
    }

    public override int arity() { return 1; }

    public override string ToString() {
        return "compound(" + arg1 + ")";
    }
}
}

