/*
 * *** Please do not edit ! ***
 * @(#) Fcompile_1.cs
 * @procedure fcompile/1 in built.pl
 */

/*
 * @version Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class Fcompile_1 : Predicate {
    static internal readonly Predicate Fcompile_1_1 = new Predicates.Fcompile_1_1();
    static internal readonly Predicate Fcompile_1_2 = new Predicates.Fcompile_1_2();
    static internal readonly Predicate Fcompile_1_3 = new Predicates.Fcompile_1_3();
    static internal readonly Predicate Fcompile_1_4 = new Predicates.Fcompile_1_4();
    static internal readonly Predicate Fcompile_1_con = new Predicates.Fcompile_1_con();
    static internal readonly Predicate Fcompile_1_int = new Predicates.Fcompile_1_int();
    static internal readonly Predicate Fcompile_1_lis = new Predicates.Fcompile_1_lis();
    static internal readonly Predicate Fcompile_1_str = new Predicates.Fcompile_1_str();
    static internal readonly Predicate Fcompile_1_var = new Predicates.Fcompile_1_var();

    public Term arg1;

    public Fcompile_1(Term a1, Predicate cont) {
        arg1 = a1; 
        this.cont = cont;
    }

    public Fcompile_1(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        this.cont = cont;
    }

    public override Predicate exec() {
        engine.aregs[1] = arg1;
        engine.cont = cont;
        return call();
    }

    public virtual Predicate call() {
        engine.setB0();
        return engine.switch_on_term(
                                   Fcompile_1_var,
                                   Fcompile_1_int,
                                   Fcompile_1_con,
                                   Fcompile_1_str,
                                   Fcompile_1_lis
                                   );
    }

    public override int arity() { return 1; }

    public override string ToString() {
        return "fcompile(" + arg1 + ")";
    }
}

sealed class Fcompile_1_var : Fcompile_1 {
    static internal readonly Predicate Fcompile_1_var_1 = new Predicates.Fcompile_1_var_1();

    public override Predicate exec() {
        return engine.jtry(Fcompile_1_1, Fcompile_1_var_1);
    }
}

sealed class Fcompile_1_var_1 : Fcompile_1 {
    static internal readonly Predicate Fcompile_1_var_2 = new Predicates.Fcompile_1_var_2();

    public override Predicate exec() {
        return engine.retry(Fcompile_1_2, Fcompile_1_var_2);
    }
}

sealed class Fcompile_1_var_2 : Fcompile_1 {
    static internal readonly Predicate Fcompile_1_var_3 = new Predicates.Fcompile_1_var_3();

    public override Predicate exec() {
        return engine.retry(Fcompile_1_3, Fcompile_1_var_3);
    }
}

sealed class Fcompile_1_var_3 : Fcompile_1 {

    public override Predicate exec() {
        return engine.trust(Fcompile_1_4);
    }
}

sealed class Fcompile_1_int : Fcompile_1 {
    static internal readonly Predicate Fcompile_1_int_1 = new Predicates.Fcompile_1_int_1();

    public override Predicate exec() {
        return engine.jtry(Fcompile_1_1, Fcompile_1_int_1);
    }
}

sealed class Fcompile_1_int_1 : Fcompile_1 {

    public override Predicate exec() {
        return engine.trust(Fcompile_1_3);
    }
}

sealed class Fcompile_1_con : Fcompile_1 {
    static internal readonly Predicate Fcompile_1_con_1 = new Predicates.Fcompile_1_con_1();

    public override Predicate exec() {
        return engine.jtry(Fcompile_1_1, Fcompile_1_con_1);
    }
}

sealed class Fcompile_1_con_1 : Fcompile_1 {
    static internal readonly Predicate Fcompile_1_con_2 = new Predicates.Fcompile_1_con_2();

    public override Predicate exec() {
        return engine.retry(Fcompile_1_2, Fcompile_1_con_2);
    }
}

sealed class Fcompile_1_con_2 : Fcompile_1 {

    public override Predicate exec() {
        return engine.trust(Fcompile_1_3);
    }
}

sealed class Fcompile_1_str : Fcompile_1 {
    static internal readonly Predicate Fcompile_1_str_1 = new Predicates.Fcompile_1_str_1();

    public override Predicate exec() {
        return engine.jtry(Fcompile_1_1, Fcompile_1_str_1);
    }
}

sealed class Fcompile_1_str_1 : Fcompile_1 {

    public override Predicate exec() {
        return engine.trust(Fcompile_1_3);
    }
}

sealed class Fcompile_1_lis : Fcompile_1 {
    static internal readonly Predicate Fcompile_1_lis_1 = new Predicates.Fcompile_1_lis_1();

    public override Predicate exec() {
        return engine.jtry(Fcompile_1_1, Fcompile_1_lis_1);
    }
}

sealed class Fcompile_1_lis_1 : Fcompile_1 {
    static internal readonly Predicate Fcompile_1_lis_2 = new Predicates.Fcompile_1_lis_2();

    public override Predicate exec() {
        return engine.retry(Fcompile_1_3, Fcompile_1_lis_2);
    }
}

sealed class Fcompile_1_lis_2 : Fcompile_1 {

    public override Predicate exec() {
        return engine.trust(Fcompile_1_4);
    }
}

sealed class Fcompile_1_1 : Fcompile_1 {

    public override Predicate exec() {
        Term a1, a2;
        Predicate p1, p2, p3;
        a1 = engine.aregs[1].dereference();
        this.cont = engine.cont;

        a2 = engine.makeVariable();
        p1 = new Predicates.dollar_fail_0(cont);
        p2 = new Predicates.dollar_cut_1(a2, p1);
        p3 = new Predicates.dollar_var_1(a1, p2);
        return new Predicates.dollar_getLevel_1(a2, p3);
    }
}

sealed class Fcompile_1_2 : Fcompile_1 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("[]");

    public override Predicate exec() {
        Term a1;
        a1 = engine.aregs[1].dereference();
        this.cont = engine.cont;

        if ( !s1.unify(a1, engine.trail) ) return engine.fail();
        return new Predicates.dollar_neckCut_0(cont);
    }
}

sealed class Fcompile_1_3 : Fcompile_1 {

    public override Predicate exec() {
        Term a1, a2;
        Predicate p1, p2, p3;
        a1 = engine.aregs[1].dereference();
        this.cont = engine.cont;

        a2 = engine.makeVariable();
        p1 = new Predicates.dollar_fcompile_1(a1, cont);
        p2 = new Predicates.dollar_cut_1(a2, p1);
        p3 = new Predicates.dollar_atom_1(a1, p2);
        return new Predicates.dollar_getLevel_1(a2, p3);
    }
}

sealed class Fcompile_1_4 : Fcompile_1 {

    public override Predicate exec() {
        Term a1, a2, a3, a4;
        Predicate p1, p2, p3, p4;
        a1 = engine.aregs[1].dereference();
        this.cont = engine.cont;

        if ( a1.isList() ){
            a2 = ((ListTerm)a1).car;
            a3 = ((ListTerm)a1).cdr;
        } else if ( a1.isVariable() ){
            a2 = engine.makeVariable();
            a3 = engine.makeVariable();
            if ( !a1.unify(new ListTerm(a2, a3), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        a4 = engine.makeVariable();
        p1 = new Predicates.Fcompile_1(a3, cont);
        p2 = new Predicates.dollar_fcompile_1(a2, p1);
        p3 = new Predicates.dollar_cut_1(a4, p2);
        p4 = new Predicates.dollar_atom_1(a2, p3);
        return new Predicates.dollar_getLevel_1(a4, p4);
    }
}
}

