/*
 * *** Please do not edit ! ***
 * @(#) Ground_1.cs
 * @procedure ground/1 in built.pl
 */

/*
 * @version Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class Ground_1 : Predicate {
    static internal readonly Predicate Ground_1_1 = new Predicates.Ground_1_1();
    static internal readonly Predicate Ground_1_2 = new Predicates.Ground_1_2();
    static internal readonly Predicate Ground_1_3 = new Predicates.Ground_1_3();
    static internal readonly Predicate Ground_1_sub_1 = new Predicates.Ground_1_sub_1();

    public Term arg1;

    public Ground_1(Term a1, Predicate cont) {
        arg1 = a1; 
        this.cont = cont;
    }

    public Ground_1(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        this.cont = cont;
    }

    public override Predicate exec() {
        engine.aregs[1] = arg1;
        engine.cont = cont;
        return call();
    }

    public virtual Predicate call() {
        engine.setB0();
        return engine.jtry(Ground_1_1, Ground_1_sub_1);
    }

    public override int arity() { return 1; }

    public override string ToString() {
        return "ground(" + arg1 + ")";
    }
}

sealed class Ground_1_sub_1 : Ground_1 {
    static internal readonly Predicate Ground_1_sub_2 = new Predicates.Ground_1_sub_2();

    public override Predicate exec() {
        return engine.retry(Ground_1_2, Ground_1_sub_2);
    }
}

sealed class Ground_1_sub_2 : Ground_1 {

    public override Predicate exec() {
        return engine.trust(Ground_1_3);
    }
}

sealed class Ground_1_1 : Ground_1 {

    public override Predicate exec() {
        Term a1, a2;
        Predicate p1, p2, p3;
        a1 = engine.aregs[1].dereference();
        this.cont = engine.cont;

        a2 = engine.makeVariable();
        p1 = new Predicates.dollar_fail_0(cont);
        p2 = new Predicates.dollar_cut_1(a2, p1);
        p3 = new Predicates.dollar_var_1(a1, p2);
        return new Predicates.dollar_getLevel_1(a2, p3);
    }
}

sealed class Ground_1_2 : Ground_1 {

    public override Predicate exec() {
        Term a1, a2;
        Predicate p1, p2;
        a1 = engine.aregs[1].dereference();
        this.cont = engine.cont;

        a2 = engine.makeVariable();
        p1 = new Predicates.dollar_cut_1(a2, cont);
        p2 = new Predicates.dollar_atomic_1(a1, p1);
        return new Predicates.dollar_getLevel_1(a2, p2);
    }
}

sealed class Ground_1_3 : Ground_1 {
    static internal readonly IntegerTerm s1 = new IntegerTerm(1);

    public override Predicate exec() {
        Term a1, a2;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        this.cont = engine.cont;

        a2 = engine.makeVariable();
        p1 = new Predicates.dollar_ground_3(s1, a2, a1, cont);
        return new Predicates.dollar_functor_3(a1, engine.makeVariable(), a2, p1);
    }
}
}

