/*
 * *** Please do not edit ! ***
 * @(#) Repeat_0.cs
 * @procedure repeat/0 in built.pl
 */

/*
 * @version Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class Repeat_0 : Predicate {
    static internal Repeat_0 entry_code;
    static internal readonly Predicate Repeat_0_1 = new Predicates.Repeat_0_1();
    static internal readonly Predicate Repeat_0_2 = new Predicates.Repeat_0_2();
    static internal readonly Predicate Repeat_0_sub_1 = new Predicates.Repeat_0_sub_1();

    public Repeat_0(Predicate cont) {
        this.cont = cont;
    }

    public Repeat_0(){}
    public override void setArgument(Term[] args, Predicate cont) {
        this.cont = cont;
    }

    public override Predicate exec() {
        entry_code = this;
        engine.cont = cont;
        return call();
    }

    public virtual Predicate call() {
        engine.setB0();
        return engine.jtry(Repeat_0_1, Repeat_0_sub_1);
    }

    public override int arity() { return 0; }

    public override string ToString() {
        return "repeat";
    }
}

sealed class Repeat_0_sub_1 : Repeat_0 {

    public override Predicate exec() {
        return engine.trust(Repeat_0_2);
    }
}

sealed class Repeat_0_1 : Repeat_0 {

    public override Predicate exec() {
        return engine.cont;
    }
}

sealed class Repeat_0_2 : Repeat_0 {

    public override Predicate exec() {
        this.cont = engine.cont;

        engine.cont = cont;
        return entry_code.call();
    }
}
}

