/*
 * *** Please do not edit ! ***
 * @(#) Statistics_0.cs
 * @procedure statistics/0 in built.pl
 */

/*
 * @version Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class Statistics_0 : Predicate {
    static internal readonly Predicate Statistics_0_1 = new Predicates.Statistics_0_1();
    static internal readonly Predicate Statistics_0_2 = new Predicates.Statistics_0_2();
    static internal readonly Predicate Statistics_0_sub_1 = new Predicates.Statistics_0_sub_1();

    public Statistics_0(Predicate cont) {
        this.cont = cont;
    }

    public Statistics_0(){}
    public override void setArgument(Term[] args, Predicate cont) {
        this.cont = cont;
    }

    public override Predicate exec() {
        engine.cont = cont;
        return call();
    }

    public virtual Predicate call() {
        engine.setB0();
        return engine.jtry(Statistics_0_1, Statistics_0_sub_1);
    }

    public override int arity() { return 0; }

    public override string ToString() {
        return "statistics";
    }
}

sealed class Statistics_0_sub_1 : Statistics_0 {

    public override Predicate exec() {
        return engine.trust(Statistics_0_2);
    }
}

sealed class Statistics_0_1 : Statistics_0 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("$statistics_mode", 1);
    static internal readonly SymbolTerm s3 = SymbolTerm.makeSymbol("[]");

    public override Predicate exec() {
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9, a10;
        Predicate p1, p2, p3, p4;
        this.cont = engine.cont;

        a1 = engine.makeVariable();
        Term[] h2 = {a1};
        a2 = new StructureTerm(f1, h2);
        a3 = engine.makeVariable();
        a4 = engine.makeVariable();
        a6 = engine.makeVariable();
        a8 = engine.makeVariable();
        a7 = new ListTerm(a8, s3);
        a5 = new ListTerm(a6, a7);
        a10 = new ListTerm(a8, s3);
        a9 = new ListTerm(a6, a10);
        p1 = new Predicates.dollar_fail_0(cont);
        p2 = new Predicates.dollar_writeStatistics_2(a4, a9, p1);
        p3 = new Predicates.dollar_statistics_2(a4, a5, p2);
        p4 = new Predicates.dollar_member_2(a4, a3, p3);
        return new Predicates.Findall_3(a1, a2, a3, p4);
    }
}

sealed class Statistics_0_2 : Statistics_0 {

    public override Predicate exec() {
        return engine.cont;
    }
}
}

