/*
 * *** Please do not edit ! ***
 * @(#) dollar_display_1.cs
 * @procedure $display/1 in inout.pl
 */

/*
 * @version Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_display_1 : Predicate {
    static internal readonly Predicate dollar_display_1_1 = new Predicates.dollar_display_1_1();
    static internal readonly Predicate dollar_display_1_2 = new Predicates.dollar_display_1_2();
    static internal readonly Predicate dollar_display_1_3 = new Predicates.dollar_display_1_3();
    static internal readonly Predicate dollar_display_1_4 = new Predicates.dollar_display_1_4();
    static internal readonly Predicate dollar_display_1_sub_1 = new Predicates.dollar_display_1_sub_1();

    public Term arg1;

    public dollar_display_1(Term a1, Predicate cont) {
        arg1 = a1; 
        this.cont = cont;
    }

    public dollar_display_1(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        this.cont = cont;
    }

    public override Predicate exec() {
        engine.aregs[1] = arg1;
        engine.cont = cont;
        return call();
    }

    public virtual Predicate call() {
        engine.setB0();
        return engine.jtry(dollar_display_1_1, dollar_display_1_sub_1);
    }

    public override int arity() { return 1; }

    public override string ToString() {
        return "$display(" + arg1 + ")";
    }
}

sealed class dollar_display_1_sub_1 : dollar_display_1 {
    static internal readonly Predicate dollar_display_1_sub_2 = new Predicates.dollar_display_1_sub_2();

    public override Predicate exec() {
        return engine.retry(dollar_display_1_2, dollar_display_1_sub_2);
    }
}

sealed class dollar_display_1_sub_2 : dollar_display_1 {
    static internal readonly Predicate dollar_display_1_sub_3 = new Predicates.dollar_display_1_sub_3();

    public override Predicate exec() {
        return engine.retry(dollar_display_1_3, dollar_display_1_sub_3);
    }
}

sealed class dollar_display_1_sub_3 : dollar_display_1 {

    public override Predicate exec() {
        return engine.trust(dollar_display_1_4);
    }
}

sealed class dollar_display_1_1 : dollar_display_1 {

    public override Predicate exec() {
        Term a1, a2;
        Predicate p1, p2, p3;
        a1 = engine.aregs[1].dereference();
        this.cont = engine.cont;

        a2 = engine.makeVariable();
        p1 = new Predicates.dollar_fastWrite_1(a1, cont);
        p2 = new Predicates.dollar_cut_1(a2, p1);
        p3 = new Predicates.dollar_atomic_1(a1, p2);
        return new Predicates.dollar_getLevel_1(a2, p3);
    }
}

sealed class dollar_display_1_2 : dollar_display_1 {

    public override Predicate exec() {
        Term a1, a2;
        Predicate p1, p2, p3;
        a1 = engine.aregs[1].dereference();
        this.cont = engine.cont;

        a2 = engine.makeVariable();
        p1 = new Predicates.dollar_fastWrite_1(a1, cont);
        p2 = new Predicates.dollar_cut_1(a2, p1);
        p3 = new Predicates.dollar_csObject_1(a1, p2);
        return new Predicates.dollar_getLevel_1(a2, p3);
    }
}

sealed class dollar_display_1_3 : dollar_display_1 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("ignore_ops");
    static internal readonly SymbolTerm s2 = SymbolTerm.makeSymbol("[]");
    static internal readonly ListTerm s3 = new ListTerm(s1, s2);

    public override Predicate exec() {
        Term a1;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        this.cont = engine.cont;

        p1 = new Predicates.dollar_fail_0(cont);
        return new Predicates.dollar_writeTerm_2(a1, s3, p1);
    }
}

sealed class dollar_display_1_4 : dollar_display_1 {

    public override Predicate exec() {
        return engine.cont;
    }
}
}

