/*
 * *** Please do not edit ! ***
 * @(#) dollar_dummyInout__6_4.cs
 * @procedure $dummy_inout_6/4 in inout.pl
 */

/*
 * @version Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_dummyInout__6_4 : Predicate {
    static internal readonly Predicate dollar_dummyInout__6_4_1 = new Predicates.dollar_dummyInout__6_4_1();
    static internal readonly Predicate dollar_dummyInout__6_4_2 = new Predicates.dollar_dummyInout__6_4_2();
    static internal readonly Predicate dollar_dummyInout__6_4_3 = new Predicates.dollar_dummyInout__6_4_3();
    static internal readonly Predicate dollar_dummyInout__6_4_sub_1 = new Predicates.dollar_dummyInout__6_4_sub_1();

    public Term arg1, arg2, arg3, arg4;

    public dollar_dummyInout__6_4(Term a1, Term a2, Term a3, Term a4, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        arg4 = a4; 
        this.cont = cont;
    }

    public dollar_dummyInout__6_4(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        arg4 = args[3]; 
        this.cont = cont;
    }

    public override Predicate exec() {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.aregs[3] = arg3;
        engine.aregs[4] = arg4;
        engine.cont = cont;
        return call();
    }

    public virtual Predicate call() {
        engine.setB0();
        return engine.jtry(dollar_dummyInout__6_4_1, dollar_dummyInout__6_4_sub_1);
    }

    public override int arity() { return 4; }

    public override string ToString() {
        return "$dummy_inout_6(" + arg1 + ", " + arg2 + ", " + arg3 + ", " + arg4 + ")";
    }
}

sealed class dollar_dummyInout__6_4_sub_1 : dollar_dummyInout__6_4 {
    static internal readonly Predicate dollar_dummyInout__6_4_sub_2 = new Predicates.dollar_dummyInout__6_4_sub_2();

    public override Predicate exec() {
        return engine.retry(dollar_dummyInout__6_4_2, dollar_dummyInout__6_4_sub_2);
    }
}

sealed class dollar_dummyInout__6_4_sub_2 : dollar_dummyInout__6_4 {

    public override Predicate exec() {
        return engine.trust(dollar_dummyInout__6_4_3);
    }
}

sealed class dollar_dummyInout__6_4_1 : dollar_dummyInout__6_4 {
    static internal readonly IntegerTerm s1 = new IntegerTerm(-256);
    static internal readonly IntegerTerm s2 = new IntegerTerm(0);
    static internal readonly SymbolTerm f3 = SymbolTerm.makeSymbol("domain", 2);
    static internal readonly SymbolTerm s4 = SymbolTerm.makeSymbol("integer");
    static internal readonly SymbolTerm s5 = SymbolTerm.makeSymbol("character");
    static internal readonly Term[] h10 = {s4, s5};
    static internal readonly StructureTerm s6 = new StructureTerm(f3, h10);
    static internal readonly SymbolTerm f7 = SymbolTerm.makeSymbol("skip", 2);
    static internal readonly IntegerTerm s9 = new IntegerTerm(2);

    public override Predicate exec() {
        Term a1, a2, a3, a4, a5, a6, a7;
        Predicate p1, p2, p3, p4;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        this.cont = engine.cont;

        a5 = engine.makeVariable();
        a6 = engine.makeVariable();
        Term[] h8 = {a1, a2};
        a7 = new StructureTerm(f7, h8);
        p1 = new Predicates.dollar_illarg_3(s6, a7, s9, cont);
        p2 = new Predicates.dollar_cut_1(a5, p1);
        p3 = new Predicates.dollar_arithNotEqual_2(a6, s2, p2);
        p4 = new Predicates.dollar_bitwiseConj_3(a3, s1, a6, p3);
        return new Predicates.dollar_getLevel_1(a5, p4);
    }
}

sealed class dollar_dummyInout__6_4_2 : dollar_dummyInout__6_4 {

    public override Predicate exec() {
        Term a1, a2, a3, a4;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        this.cont = engine.cont;

        return new Predicates.dollar_dummyInout__7_2(a1, a3, cont);
    }
}

sealed class dollar_dummyInout__6_4_3 : dollar_dummyInout__6_4 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("type", 1);
    static internal readonly SymbolTerm s2 = SymbolTerm.makeSymbol("stream");
    static internal readonly Term[] h7 = {s2};
    static internal readonly StructureTerm s3 = new StructureTerm(f1, h7);
    static internal readonly SymbolTerm f4 = SymbolTerm.makeSymbol("skip", 2);
    static internal readonly IntegerTerm s6 = new IntegerTerm(1);

    public override Predicate exec() {
        Term a1, a2, a3, a4, a5;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        this.cont = engine.cont;

        Term[] h5 = {a4, a2};
        a5 = new StructureTerm(f4, h5);
        return new Predicates.dollar_illarg_3(s3, a5, s6, cont);
    }
}
}

