/*
 * *** Please do not edit ! ***
 * @(#) dollar_memPair_2.cs
 * @procedure $mem_pair/2 in inout.pl
 */

/*
 * @version Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_memPair_2 : Predicate {
    static internal readonly Predicate dollar_memPair_2_1 = new Predicates.dollar_memPair_2_1();
    static internal readonly Predicate dollar_memPair_2_2 = new Predicates.dollar_memPair_2_2();
    static internal readonly Predicate dollar_memPair_2_var = new Predicates.dollar_memPair_2_var();

    public Term arg1, arg2;

    public dollar_memPair_2(Term a1, Term a2, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        this.cont = cont;
    }

    public dollar_memPair_2(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        this.cont = cont;
    }

    public override Predicate exec() {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.cont = cont;
        return call();
    }

    public virtual Predicate call() {
        engine.setB0();
        return engine.switch_on_term(
                                   dollar_memPair_2_var,
                                   dollar_memPair_2_2,
                                   dollar_memPair_2_2,
                                   dollar_memPair_2_var,
                                   dollar_memPair_2_2
                                   );
    }

    public override int arity() { return 2; }

    public override string ToString() {
        return "$mem_pair(" + arg1 + ", " + arg2 + ")";
    }
}

sealed class dollar_memPair_2_var : dollar_memPair_2 {
    static internal readonly Predicate dollar_memPair_2_var_1 = new Predicates.dollar_memPair_2_var_1();

    public override Predicate exec() {
        return engine.jtry(dollar_memPair_2_1, dollar_memPair_2_var_1);
    }
}

sealed class dollar_memPair_2_var_1 : dollar_memPair_2 {

    public override Predicate exec() {
        return engine.trust(dollar_memPair_2_2);
    }
}

sealed class dollar_memPair_2_1 : dollar_memPair_2 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("=", 2);

    public override Predicate exec() {
        Term a1, a2, a3, a4, a5, a6, a7, a8;
        Predicate p1, p2, p3;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        this.cont = engine.cont;

        if ( a1.isStructure() ){
            if (f1 != ((StructureTerm)a1).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a1).args;
            a3 = args[0];
            a4 = args[1];
        } else if (a1.isVariable() ){
            a3 = engine.makeVariable();
            a4 = engine.makeVariable();
            Term[] args = {a3, a4};
            if ( !a1.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a2.isList() ){
            a5 = ((ListTerm)a2).car;
        } else if ( a2.isVariable() ){
            a5 = engine.makeVariable();
            if ( !a2.unify(new ListTerm(a5, engine.makeVariable()), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a5.isStructure() ){
            if (f1 != ((StructureTerm)a5).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a5).args;
            a6 = args[0];
            a7 = args[1];
        } else if (a5.isVariable() ){
            a6 = engine.makeVariable();
            a7 = engine.makeVariable();
            Term[] args = {a6, a7};
            if ( !a5.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        a8 = engine.makeVariable();
        p1 = new Predicates.dollar_unify_2(a4, a7, cont);
        p2 = new Predicates.dollar_cut_1(a8, p1);
        p3 = new Predicates.dollar_equalityOfTerm_2(a3, a6, p2);
        return new Predicates.dollar_getLevel_1(a8, p3);
    }
}

sealed class dollar_memPair_2_2 : dollar_memPair_2 {

    public override Predicate exec() {
        Term a1, a2, a3;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        this.cont = engine.cont;

        if ( a2.isList() ){
            a3 = ((ListTerm)a2).cdr;
        } else if ( a2.isVariable() ){
            a3 = engine.makeVariable();
            if ( !a2.unify(new ListTerm(engine.makeVariable(), a3), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        return new Predicates.dollar_member_2(a1, a3, cont);
    }
}
}

