/*
 * *** Please do not edit ! ***
 * @(#) dollar_parseTokens2_7.cs
 * @procedure $parse_tokens2/7 in inout.pl
 */

/*
 * @version Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_parseTokens2_7 : Predicate {
    static internal readonly Predicate dollar_parseTokens2_7_1 = new Predicates.dollar_parseTokens2_7_1();
    static internal readonly Predicate dollar_parseTokens2_7_2 = new Predicates.dollar_parseTokens2_7_2();
    static internal readonly Predicate dollar_parseTokens2_7_3 = new Predicates.dollar_parseTokens2_7_3();
    static internal readonly Predicate dollar_parseTokens2_7_sub_1 = new Predicates.dollar_parseTokens2_7_sub_1();

    public Term arg1, arg2, arg3, arg4, arg5, arg6, arg7;

    public dollar_parseTokens2_7(Term a1, Term a2, Term a3, Term a4, Term a5, Term a6, Term a7, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        arg4 = a4; 
        arg5 = a5; 
        arg6 = a6; 
        arg7 = a7; 
        this.cont = cont;
    }

    public dollar_parseTokens2_7(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        arg4 = args[3]; 
        arg5 = args[4]; 
        arg6 = args[5]; 
        arg7 = args[6]; 
        this.cont = cont;
    }

    public override Predicate exec() {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.aregs[3] = arg3;
        engine.aregs[4] = arg4;
        engine.aregs[5] = arg5;
        engine.aregs[6] = arg6;
        engine.aregs[7] = arg7;
        engine.cont = cont;
        return call();
    }

    public virtual Predicate call() {
        engine.setB0();
        return engine.jtry(dollar_parseTokens2_7_1, dollar_parseTokens2_7_sub_1);
    }

    public override int arity() { return 7; }

    public override string ToString() {
        return "$parse_tokens2(" + arg1 + ", " + arg2 + ", " + arg3 + ", " + arg4 + ", " + arg5 + ", " + arg6 + ", " + arg7 + ")";
    }
}

sealed class dollar_parseTokens2_7_sub_1 : dollar_parseTokens2_7 {
    static internal readonly Predicate dollar_parseTokens2_7_sub_2 = new Predicates.dollar_parseTokens2_7_sub_2();

    public override Predicate exec() {
        return engine.retry(dollar_parseTokens2_7_2, dollar_parseTokens2_7_sub_2);
    }
}

sealed class dollar_parseTokens2_7_sub_2 : dollar_parseTokens2_7 {

    public override Predicate exec() {
        return engine.trust(dollar_parseTokens2_7_3);
    }
}

sealed class dollar_parseTokens2_7_1 : dollar_parseTokens2_7 {

    public override Predicate exec() {
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9;
        Predicate p1, p2, p3, p4;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        a5 = engine.aregs[5].dereference();
        a6 = engine.aregs[6].dereference();
        a7 = engine.aregs[7].dereference();
        this.cont = engine.cont;

        if ( !a2.unify(a4, engine.trail) ) return engine.fail();
        if ( !a3.unify(a5, engine.trail) ) return engine.fail();
        a8 = engine.makeVariable();
        a9 = engine.makeVariable();
        p1 = new Predicates.dollar_cut_1(a8, cont);
        p2 = new Predicates.dollar_lessOrEqual_2(a3, a1, p1);
        p3 = new Predicates.dollar_parseTokensIsTerminator_1(a9, p2);
        p4 = new Predicates.dollar_parseTokensPeepNext_3(a9, a6, a7, p3);
        return new Predicates.dollar_getLevel_1(a8, p4);
    }
}

sealed class dollar_parseTokens2_7_2 : dollar_parseTokens2_7 {

    public override Predicate exec() {
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9, a10;
        Predicate p1, p2, p3, p4;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        a5 = engine.aregs[5].dereference();
        a6 = engine.aregs[6].dereference();
        a7 = engine.aregs[7].dereference();
        this.cont = engine.cont;

        a8 = engine.makeVariable();
        a9 = engine.makeVariable();
        a10 = engine.makeVariable();
        p1 = new Predicates.dollar_parseTokensPostInOps_7(a1, a2, a3, a4, a5, a10, a7, cont);
        p2 = new Predicates.dollar_cut_1(a8, p1);
        p3 = new Predicates.dollar_parseTokensIsPostInOp_1(a9, p2);
        p4 = new Predicates.dollar_parseTokensPeepNext_3(a9, a6, a10, p3);
        return new Predicates.dollar_getLevel_1(a8, p4);
    }
}

sealed class dollar_parseTokens2_7_3 : dollar_parseTokens2_7 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("operator");
    static internal readonly SymbolTerm s2 = SymbolTerm.makeSymbol("expected");
    static internal readonly SymbolTerm s3 = SymbolTerm.makeSymbol("after");
    static internal readonly SymbolTerm s4 = SymbolTerm.makeSymbol("expression");
    static internal readonly SymbolTerm s5 = SymbolTerm.makeSymbol("[]");
    static internal readonly ListTerm s6 = new ListTerm(s4, s5);
    static internal readonly ListTerm s7 = new ListTerm(s3, s6);
    static internal readonly ListTerm s8 = new ListTerm(s2, s7);
    static internal readonly ListTerm s9 = new ListTerm(s1, s8);

    public override Predicate exec() {
        Term a1, a2, a3, a4, a5, a6, a7;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        a5 = engine.aregs[5].dereference();
        a6 = engine.aregs[6].dereference();
        a7 = engine.aregs[7].dereference();
        this.cont = engine.cont;

        return new Predicates.dollar_parseTokensError_3(s9, a6, a7, cont);
    }
}
}

