/*
 * *** Please do not edit ! ***
 * @(#) dollar_tokens_1.cs
 * @procedure $tokens/1 in inout.pl
 */

/*
 * @version Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_tokens_1 : Predicate {
    static internal readonly SymbolTerm functor = SymbolTerm.makeSymbol("$tokens", 1);
    static internal readonly Predicate dollar_fail_0 = new Predicates.dollar_fail_0();
    static internal readonly Predicate dollar_tokens_1_res_0 = new Predicates.dollar_tokens_1_res_0();
    static internal readonly Predicate dollar_tokens_1_res_1 = new Predicates.dollar_tokens_1_res_1();
    static internal readonly Predicate dollar_tokens_1_res_2 = new Predicates.dollar_tokens_1_res_2();
    static internal readonly Predicate dollar_tokens_1_res_3 = new Predicates.dollar_tokens_1_res_3();

    public Term arg1;

    public dollar_tokens_1(Term a1, Predicate cont) {
        arg1 = a1; 
        this.cont = cont;
    }

    public dollar_tokens_1(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        this.cont = cont;
    }

    public override Predicate exec() {
        engine.aregs[1] = arg1;
        engine.cont = cont;
        return call();
    }

    public virtual Predicate call() {
        engine.setB0();
        if ( !functor.res.isList() )
            return engine.fail();
        engine.lookUpHash(functor);
        if ( !engine.pickupResource(functor, 2) )
            return engine.fail();
        if ( !engine.hasMoreResource() )
            return dollar_tokens_1_res_1;
        return engine.tryResource(dollar_tokens_1_res_1, dollar_tokens_1_res_0);
    }

    public override int arity() { return 1; }

    public override string ToString() {
        return "$tokens(" + arg1 + ")";
    }
}

sealed class dollar_tokens_1_res_0 : dollar_tokens_1 {

    public override Predicate exec() {
        engine.restoreResource();
        if ( !engine.pickupResource(functor, 2) )
            return dollar_tokens_1_res_2;
        if ( !engine.hasMoreResource() )
            return dollar_tokens_1_res_3;
        return engine.retryResource(dollar_tokens_1_res_1, dollar_tokens_1_res_0);
    }
}

sealed class dollar_tokens_1_res_1 : dollar_tokens_1 {

    public override Predicate exec() {
        return engine.executeClosure(engine.consume(2));
    }
}

sealed class dollar_tokens_1_res_2 : dollar_tokens_1 {

    public override Predicate exec() {
        return engine.trustResource(dollar_fail_0);
    }
}

sealed class dollar_tokens_1_res_3 : dollar_tokens_1 {

    public override Predicate exec() {
        return engine.trustResource(dollar_tokens_1_res_1);
    }
}
}

