/*
 * *** Please do not edit ! ***
 * @(#) dollar_writeSpaceIfNeeded_2.cs
 * @procedure $write_space_if_needed/2 in inout.pl
 */

/*
 * @version Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_writeSpaceIfNeeded_2 : Predicate {
    static internal readonly Predicate dollar_writeSpaceIfNeeded_2_1 = new Predicates.dollar_writeSpaceIfNeeded_2_1();
    static internal readonly Predicate dollar_writeSpaceIfNeeded_2_2 = new Predicates.dollar_writeSpaceIfNeeded_2_2();
    static internal readonly Predicate dollar_writeSpaceIfNeeded_2_3 = new Predicates.dollar_writeSpaceIfNeeded_2_3();
    static internal readonly Predicate dollar_writeSpaceIfNeeded_2_4 = new Predicates.dollar_writeSpaceIfNeeded_2_4();
    static internal readonly Predicate dollar_writeSpaceIfNeeded_2_int = new Predicates.dollar_writeSpaceIfNeeded_2_int();
    static internal readonly Predicate dollar_writeSpaceIfNeeded_2_lis = new Predicates.dollar_writeSpaceIfNeeded_2_lis();
    static internal readonly Predicate dollar_writeSpaceIfNeeded_2_str = new Predicates.dollar_writeSpaceIfNeeded_2_str();
    static internal readonly Predicate dollar_writeSpaceIfNeeded_2_var = new Predicates.dollar_writeSpaceIfNeeded_2_var();

    public Term arg1, arg2;

    public dollar_writeSpaceIfNeeded_2(Term a1, Term a2, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        this.cont = cont;
    }

    public dollar_writeSpaceIfNeeded_2(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        this.cont = cont;
    }

    public override Predicate exec() {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.cont = cont;
        return call();
    }

    public virtual Predicate call() {
        engine.setB0();
        return engine.switch_on_term(
                                   dollar_writeSpaceIfNeeded_2_var,
                                   dollar_writeSpaceIfNeeded_2_int,
                                   dollar_writeSpaceIfNeeded_2_var,
                                   dollar_writeSpaceIfNeeded_2_str,
                                   dollar_writeSpaceIfNeeded_2_lis
                                   );
    }

    public override int arity() { return 2; }

    public override string ToString() {
        return "$write_space_if_needed(" + arg1 + ", " + arg2 + ")";
    }
}

sealed class dollar_writeSpaceIfNeeded_2_var : dollar_writeSpaceIfNeeded_2 {
    static internal readonly Predicate dollar_writeSpaceIfNeeded_2_var_1 = new Predicates.dollar_writeSpaceIfNeeded_2_var_1();

    public override Predicate exec() {
        return engine.jtry(dollar_writeSpaceIfNeeded_2_1, dollar_writeSpaceIfNeeded_2_var_1);
    }
}

sealed class dollar_writeSpaceIfNeeded_2_var_1 : dollar_writeSpaceIfNeeded_2 {
    static internal readonly Predicate dollar_writeSpaceIfNeeded_2_var_2 = new Predicates.dollar_writeSpaceIfNeeded_2_var_2();

    public override Predicate exec() {
        return engine.retry(dollar_writeSpaceIfNeeded_2_2, dollar_writeSpaceIfNeeded_2_var_2);
    }
}

sealed class dollar_writeSpaceIfNeeded_2_var_2 : dollar_writeSpaceIfNeeded_2 {
    static internal readonly Predicate dollar_writeSpaceIfNeeded_2_var_3 = new Predicates.dollar_writeSpaceIfNeeded_2_var_3();

    public override Predicate exec() {
        return engine.retry(dollar_writeSpaceIfNeeded_2_3, dollar_writeSpaceIfNeeded_2_var_3);
    }
}

sealed class dollar_writeSpaceIfNeeded_2_var_3 : dollar_writeSpaceIfNeeded_2 {

    public override Predicate exec() {
        return engine.trust(dollar_writeSpaceIfNeeded_2_4);
    }
}

sealed class dollar_writeSpaceIfNeeded_2_int : dollar_writeSpaceIfNeeded_2 {
    static internal readonly Predicate dollar_writeSpaceIfNeeded_2_int_1 = new Predicates.dollar_writeSpaceIfNeeded_2_int_1();

    public override Predicate exec() {
        return engine.jtry(dollar_writeSpaceIfNeeded_2_2, dollar_writeSpaceIfNeeded_2_int_1);
    }
}

sealed class dollar_writeSpaceIfNeeded_2_int_1 : dollar_writeSpaceIfNeeded_2 {

    public override Predicate exec() {
        return engine.trust(dollar_writeSpaceIfNeeded_2_4);
    }
}

sealed class dollar_writeSpaceIfNeeded_2_str : dollar_writeSpaceIfNeeded_2 {
    static internal readonly Predicate dollar_writeSpaceIfNeeded_2_str_1 = new Predicates.dollar_writeSpaceIfNeeded_2_str_1();

    public override Predicate exec() {
        return engine.jtry(dollar_writeSpaceIfNeeded_2_2, dollar_writeSpaceIfNeeded_2_str_1);
    }
}

sealed class dollar_writeSpaceIfNeeded_2_str_1 : dollar_writeSpaceIfNeeded_2 {

    public override Predicate exec() {
        return engine.trust(dollar_writeSpaceIfNeeded_2_4);
    }
}

sealed class dollar_writeSpaceIfNeeded_2_lis : dollar_writeSpaceIfNeeded_2 {
    static internal readonly Predicate dollar_writeSpaceIfNeeded_2_lis_1 = new Predicates.dollar_writeSpaceIfNeeded_2_lis_1();

    public override Predicate exec() {
        return engine.jtry(dollar_writeSpaceIfNeeded_2_2, dollar_writeSpaceIfNeeded_2_lis_1);
    }
}

sealed class dollar_writeSpaceIfNeeded_2_lis_1 : dollar_writeSpaceIfNeeded_2 {

    public override Predicate exec() {
        return engine.trust(dollar_writeSpaceIfNeeded_2_4);
    }
}

sealed class dollar_writeSpaceIfNeeded_2_1 : dollar_writeSpaceIfNeeded_2 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("punct");

    public override Predicate exec() {
        Term a1, a2;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        this.cont = engine.cont;

        if ( !s1.unify(a1, engine.trail) ) return engine.fail();
        return new Predicates.dollar_neckCut_0(cont);
    }
}

sealed class dollar_writeSpaceIfNeeded_2_2 : dollar_writeSpaceIfNeeded_2 {
    static internal readonly IntegerTerm s1 = new IntegerTerm(32);
    static internal readonly SymbolTerm s2 = SymbolTerm.makeSymbol("[]");
    static internal readonly ListTerm s3 = new ListTerm(s1, s2);

    public override Predicate exec() {
        Term a1, a2;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        this.cont = engine.cont;

        if ( !a1.unify(a2, engine.trail) ) return engine.fail();
        p1 = new Predicates.dollar_put_1(s3, cont);
        return new Predicates.dollar_neckCut_0(p1);
    }
}

sealed class dollar_writeSpaceIfNeeded_2_3 : dollar_writeSpaceIfNeeded_2 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("other");
    static internal readonly SymbolTerm s2 = SymbolTerm.makeSymbol("alpha");
    static internal readonly IntegerTerm s3 = new IntegerTerm(32);
    static internal readonly SymbolTerm s4 = SymbolTerm.makeSymbol("[]");
    static internal readonly ListTerm s5 = new ListTerm(s3, s4);

    public override Predicate exec() {
        Term a1, a2;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        this.cont = engine.cont;

        if ( !s1.unify(a1, engine.trail) ) return engine.fail();
        if ( !s2.unify(a2, engine.trail) ) return engine.fail();
        p1 = new Predicates.dollar_put_1(s5, cont);
        return new Predicates.dollar_neckCut_0(p1);
    }
}

sealed class dollar_writeSpaceIfNeeded_2_4 : dollar_writeSpaceIfNeeded_2 {

    public override Predicate exec() {
        return engine.cont;
    }
}
}

