/*
 * *** Please do not edit ! ***
 * @(#) dollar_writeTermOp1_7.cs
 * @procedure $write_term_op1/7 in inout.pl
 */

/*
 * @version Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_writeTermOp1_7 : Predicate {
    static internal readonly Predicate dollar_writeTermOp1_7_1 = new Predicates.dollar_writeTermOp1_7_1();
    static internal readonly Predicate dollar_writeTermOp1_7_2 = new Predicates.dollar_writeTermOp1_7_2();
    static internal readonly Predicate dollar_writeTermOp1_7_3 = new Predicates.dollar_writeTermOp1_7_3();
    static internal readonly Predicate dollar_writeTermOp1_7_4 = new Predicates.dollar_writeTermOp1_7_4();
    static internal readonly Predicate dollar_writeTermOp1_7_5 = new Predicates.dollar_writeTermOp1_7_5();
    static internal readonly Predicate dollar_writeTermOp1_7_6 = new Predicates.dollar_writeTermOp1_7_6();
    static internal readonly Predicate dollar_writeTermOp1_7_7 = new Predicates.dollar_writeTermOp1_7_7();
    static internal readonly Predicate dollar_writeTermOp1_7_sub_1 = new Predicates.dollar_writeTermOp1_7_sub_1();

    public Term arg1, arg2, arg3, arg4, arg5, arg6, arg7;

    public dollar_writeTermOp1_7(Term a1, Term a2, Term a3, Term a4, Term a5, Term a6, Term a7, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        arg4 = a4; 
        arg5 = a5; 
        arg6 = a6; 
        arg7 = a7; 
        this.cont = cont;
    }

    public dollar_writeTermOp1_7(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        arg4 = args[3]; 
        arg5 = args[4]; 
        arg6 = args[5]; 
        arg7 = args[6]; 
        this.cont = cont;
    }

    public override Predicate exec() {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.aregs[3] = arg3;
        engine.aregs[4] = arg4;
        engine.aregs[5] = arg5;
        engine.aregs[6] = arg6;
        engine.aregs[7] = arg7;
        engine.cont = cont;
        return call();
    }

    public virtual Predicate call() {
        engine.setB0();
        return engine.jtry(dollar_writeTermOp1_7_1, dollar_writeTermOp1_7_sub_1);
    }

    public override int arity() { return 7; }

    public override string ToString() {
        return "$write_term_op1(" + arg1 + ", " + arg2 + ", " + arg3 + ", " + arg4 + ", " + arg5 + ", " + arg6 + ", " + arg7 + ")";
    }
}

sealed class dollar_writeTermOp1_7_sub_1 : dollar_writeTermOp1_7 {
    static internal readonly Predicate dollar_writeTermOp1_7_sub_2 = new Predicates.dollar_writeTermOp1_7_sub_2();

    public override Predicate exec() {
        return engine.retry(dollar_writeTermOp1_7_2, dollar_writeTermOp1_7_sub_2);
    }
}

sealed class dollar_writeTermOp1_7_sub_2 : dollar_writeTermOp1_7 {
    static internal readonly Predicate dollar_writeTermOp1_7_sub_3 = new Predicates.dollar_writeTermOp1_7_sub_3();

    public override Predicate exec() {
        return engine.retry(dollar_writeTermOp1_7_3, dollar_writeTermOp1_7_sub_3);
    }
}

sealed class dollar_writeTermOp1_7_sub_3 : dollar_writeTermOp1_7 {
    static internal readonly Predicate dollar_writeTermOp1_7_sub_4 = new Predicates.dollar_writeTermOp1_7_sub_4();

    public override Predicate exec() {
        return engine.retry(dollar_writeTermOp1_7_4, dollar_writeTermOp1_7_sub_4);
    }
}

sealed class dollar_writeTermOp1_7_sub_4 : dollar_writeTermOp1_7 {
    static internal readonly Predicate dollar_writeTermOp1_7_sub_5 = new Predicates.dollar_writeTermOp1_7_sub_5();

    public override Predicate exec() {
        return engine.retry(dollar_writeTermOp1_7_5, dollar_writeTermOp1_7_sub_5);
    }
}

sealed class dollar_writeTermOp1_7_sub_5 : dollar_writeTermOp1_7 {
    static internal readonly Predicate dollar_writeTermOp1_7_sub_6 = new Predicates.dollar_writeTermOp1_7_sub_6();

    public override Predicate exec() {
        return engine.retry(dollar_writeTermOp1_7_6, dollar_writeTermOp1_7_sub_6);
    }
}

sealed class dollar_writeTermOp1_7_sub_6 : dollar_writeTermOp1_7 {

    public override Predicate exec() {
        return engine.trust(dollar_writeTermOp1_7_7);
    }
}

sealed class dollar_writeTermOp1_7_1 : dollar_writeTermOp1_7 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("fx");
    static internal readonly SymbolTerm s2 = SymbolTerm.makeSymbol("[]");
    static internal readonly IntegerTerm s3 = new IntegerTerm(1);

    public override Predicate exec() {
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9, a10;
        Predicate p1, p2, p3;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        a5 = engine.aregs[5].dereference();
        a6 = engine.aregs[6].dereference();
        a7 = engine.aregs[7].dereference();
        this.cont = engine.cont;

        if ( !s1.unify(a2, engine.trail) ) return engine.fail();
        if ( a3.isList() ){
            a8 = ((ListTerm)a3).car;
            if ( !s2.unify(((ListTerm)a3).cdr, engine.trail) )
                return engine.fail();
        } else if ( a3.isVariable() ){
            a8 = engine.makeVariable();
            if ( !a3.unify(new ListTerm(a8, s2), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        a9 = engine.makeVariable();
        a10 = engine.makeVariable();
        p1 = new Predicates.dollar_writeTerm0_5(a8, a10, a9, a6, a7, cont);
        p2 = new Predicates.dollar_minus_3(a4, s3, a10, p1);
        p3 = new Predicates.dollar_writeAtom_4(a1, a5, a9, a7, p2);
        return new Predicates.dollar_neckCut_0(p3);
    }
}

sealed class dollar_writeTermOp1_7_2 : dollar_writeTermOp1_7 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("fy");
    static internal readonly SymbolTerm s2 = SymbolTerm.makeSymbol("[]");

    public override Predicate exec() {
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9, a10;
        Predicate p1, p2, p3;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        a5 = engine.aregs[5].dereference();
        a6 = engine.aregs[6].dereference();
        a7 = engine.aregs[7].dereference();
        this.cont = engine.cont;

        if ( !s1.unify(a2, engine.trail) ) return engine.fail();
        if ( a3.isList() ){
            a8 = ((ListTerm)a3).car;
            if ( !s2.unify(((ListTerm)a3).cdr, engine.trail) )
                return engine.fail();
        } else if ( a3.isVariable() ){
            a8 = engine.makeVariable();
            if ( !a3.unify(new ListTerm(a8, s2), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        a9 = engine.makeVariable();
        a10 = engine.makeVariable();
        p1 = new Predicates.dollar_writeTerm0_5(a8, a10, a9, a6, a7, cont);
        p2 = new Predicates.dollar_is_2(a10, a4, p1);
        p3 = new Predicates.dollar_writeAtom_4(a1, a5, a9, a7, p2);
        return new Predicates.dollar_neckCut_0(p3);
    }
}

sealed class dollar_writeTermOp1_7_3 : dollar_writeTermOp1_7 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("xf");
    static internal readonly SymbolTerm s2 = SymbolTerm.makeSymbol("[]");
    static internal readonly IntegerTerm s3 = new IntegerTerm(1);

    public override Predicate exec() {
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9, a10;
        Predicate p1, p2, p3;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        a5 = engine.aregs[5].dereference();
        a6 = engine.aregs[6].dereference();
        a7 = engine.aregs[7].dereference();
        this.cont = engine.cont;

        if ( !s1.unify(a2, engine.trail) ) return engine.fail();
        if ( a3.isList() ){
            a8 = ((ListTerm)a3).car;
            if ( !s2.unify(((ListTerm)a3).cdr, engine.trail) )
                return engine.fail();
        } else if ( a3.isVariable() ){
            a8 = engine.makeVariable();
            if ( !a3.unify(new ListTerm(a8, s2), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        a9 = engine.makeVariable();
        a10 = engine.makeVariable();
        p1 = new Predicates.dollar_writeAtom_4(a1, a10, a6, a7, cont);
        p2 = new Predicates.dollar_writeTerm0_5(a8, a9, a5, a10, a7, p1);
        p3 = new Predicates.dollar_minus_3(a4, s3, a9, p2);
        return new Predicates.dollar_neckCut_0(p3);
    }
}

sealed class dollar_writeTermOp1_7_4 : dollar_writeTermOp1_7 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("yf");
    static internal readonly SymbolTerm s2 = SymbolTerm.makeSymbol("[]");

    public override Predicate exec() {
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9, a10;
        Predicate p1, p2, p3;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        a5 = engine.aregs[5].dereference();
        a6 = engine.aregs[6].dereference();
        a7 = engine.aregs[7].dereference();
        this.cont = engine.cont;

        if ( !s1.unify(a2, engine.trail) ) return engine.fail();
        if ( a3.isList() ){
            a8 = ((ListTerm)a3).car;
            if ( !s2.unify(((ListTerm)a3).cdr, engine.trail) )
                return engine.fail();
        } else if ( a3.isVariable() ){
            a8 = engine.makeVariable();
            if ( !a3.unify(new ListTerm(a8, s2), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        a9 = engine.makeVariable();
        a10 = engine.makeVariable();
        p1 = new Predicates.dollar_writeAtom_4(a1, a10, a6, a7, cont);
        p2 = new Predicates.dollar_writeTerm0_5(a8, a9, a5, a10, a7, p1);
        p3 = new Predicates.dollar_is_2(a9, a4, p2);
        return new Predicates.dollar_neckCut_0(p3);
    }
}

sealed class dollar_writeTermOp1_7_5 : dollar_writeTermOp1_7 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("xfx");
    static internal readonly SymbolTerm s2 = SymbolTerm.makeSymbol("[]");
    static internal readonly IntegerTerm s3 = new IntegerTerm(1);

    public override Predicate exec() {
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14;
        Predicate p1, p2, p3, p4, p5;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        a5 = engine.aregs[5].dereference();
        a6 = engine.aregs[6].dereference();
        a7 = engine.aregs[7].dereference();
        this.cont = engine.cont;

        if ( !s1.unify(a2, engine.trail) ) return engine.fail();
        if ( a3.isList() ){
            a8 = ((ListTerm)a3).car;
            a9 = ((ListTerm)a3).cdr;
        } else if ( a3.isVariable() ){
            a8 = engine.makeVariable();
            a9 = engine.makeVariable();
            if ( !a3.unify(new ListTerm(a8, a9), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a9.isList() ){
            a10 = ((ListTerm)a9).car;
            if ( !s2.unify(((ListTerm)a9).cdr, engine.trail) )
                return engine.fail();
        } else if ( a9.isVariable() ){
            a10 = engine.makeVariable();
            if ( !a9.unify(new ListTerm(a10, s2), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        a11 = engine.makeVariable();
        a12 = engine.makeVariable();
        a13 = engine.makeVariable();
        a14 = engine.makeVariable();
        p1 = new Predicates.dollar_writeTerm0_5(a10, a12, a14, a6, a7, cont);
        p2 = new Predicates.dollar_writeTermInfixOp_4(a1, a13, a14, a7, p1);
        p3 = new Predicates.dollar_writeTerm0_5(a8, a11, a5, a13, a7, p2);
        p4 = new Predicates.dollar_minus_3(a4, s3, a12, p3);
        p5 = new Predicates.dollar_minus_3(a4, s3, a11, p4);
        return new Predicates.dollar_neckCut_0(p5);
    }
}

sealed class dollar_writeTermOp1_7_6 : dollar_writeTermOp1_7 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("xfy");
    static internal readonly SymbolTerm s2 = SymbolTerm.makeSymbol("[]");
    static internal readonly IntegerTerm s3 = new IntegerTerm(1);

    public override Predicate exec() {
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14;
        Predicate p1, p2, p3, p4, p5;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        a5 = engine.aregs[5].dereference();
        a6 = engine.aregs[6].dereference();
        a7 = engine.aregs[7].dereference();
        this.cont = engine.cont;

        if ( !s1.unify(a2, engine.trail) ) return engine.fail();
        if ( a3.isList() ){
            a8 = ((ListTerm)a3).car;
            a9 = ((ListTerm)a3).cdr;
        } else if ( a3.isVariable() ){
            a8 = engine.makeVariable();
            a9 = engine.makeVariable();
            if ( !a3.unify(new ListTerm(a8, a9), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a9.isList() ){
            a10 = ((ListTerm)a9).car;
            if ( !s2.unify(((ListTerm)a9).cdr, engine.trail) )
                return engine.fail();
        } else if ( a9.isVariable() ){
            a10 = engine.makeVariable();
            if ( !a9.unify(new ListTerm(a10, s2), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        a11 = engine.makeVariable();
        a12 = engine.makeVariable();
        a13 = engine.makeVariable();
        a14 = engine.makeVariable();
        p1 = new Predicates.dollar_writeTerm0_5(a10, a12, a14, a6, a7, cont);
        p2 = new Predicates.dollar_writeTermInfixOp_4(a1, a13, a14, a7, p1);
        p3 = new Predicates.dollar_writeTerm0_5(a8, a11, a5, a13, a7, p2);
        p4 = new Predicates.dollar_is_2(a12, a4, p3);
        p5 = new Predicates.dollar_minus_3(a4, s3, a11, p4);
        return new Predicates.dollar_neckCut_0(p5);
    }
}

sealed class dollar_writeTermOp1_7_7 : dollar_writeTermOp1_7 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("yfx");
    static internal readonly SymbolTerm s2 = SymbolTerm.makeSymbol("[]");
    static internal readonly IntegerTerm s3 = new IntegerTerm(1);

    public override Predicate exec() {
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14;
        Predicate p1, p2, p3, p4, p5;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        a5 = engine.aregs[5].dereference();
        a6 = engine.aregs[6].dereference();
        a7 = engine.aregs[7].dereference();
        this.cont = engine.cont;

        if ( !s1.unify(a2, engine.trail) ) return engine.fail();
        if ( a3.isList() ){
            a8 = ((ListTerm)a3).car;
            a9 = ((ListTerm)a3).cdr;
        } else if ( a3.isVariable() ){
            a8 = engine.makeVariable();
            a9 = engine.makeVariable();
            if ( !a3.unify(new ListTerm(a8, a9), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a9.isList() ){
            a10 = ((ListTerm)a9).car;
            if ( !s2.unify(((ListTerm)a9).cdr, engine.trail) )
                return engine.fail();
        } else if ( a9.isVariable() ){
            a10 = engine.makeVariable();
            if ( !a9.unify(new ListTerm(a10, s2), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        a11 = engine.makeVariable();
        a12 = engine.makeVariable();
        a13 = engine.makeVariable();
        a14 = engine.makeVariable();
        p1 = new Predicates.dollar_writeTerm0_5(a10, a12, a14, a6, a7, cont);
        p2 = new Predicates.dollar_writeTermInfixOp_4(a1, a13, a14, a7, p1);
        p3 = new Predicates.dollar_writeTerm0_5(a8, a11, a5, a13, a7, p2);
        p4 = new Predicates.dollar_minus_3(a4, s3, a12, p3);
        p5 = new Predicates.dollar_is_2(a11, a4, p4);
        return new Predicates.dollar_neckCut_0(p5);
    }
}
}

