/*
 * *** Please do not edit ! ***
 * @(#) dollar_writeTermOp_7.cs
 * @procedure $write_term_op/7 in inout.pl
 */

/*
 * @version Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_writeTermOp_7 : Predicate {
    static internal readonly Predicate dollar_writeTermOp_7_1 = new Predicates.dollar_writeTermOp_7_1();
    static internal readonly Predicate dollar_writeTermOp_7_2 = new Predicates.dollar_writeTermOp_7_2();
    static internal readonly Predicate dollar_writeTermOp_7_sub_1 = new Predicates.dollar_writeTermOp_7_sub_1();

    public Term arg1, arg2, arg3, arg4, arg5, arg6, arg7;

    public dollar_writeTermOp_7(Term a1, Term a2, Term a3, Term a4, Term a5, Term a6, Term a7, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        arg4 = a4; 
        arg5 = a5; 
        arg6 = a6; 
        arg7 = a7; 
        this.cont = cont;
    }

    public dollar_writeTermOp_7(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        arg4 = args[3]; 
        arg5 = args[4]; 
        arg6 = args[5]; 
        arg7 = args[6]; 
        this.cont = cont;
    }

    public override Predicate exec() {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.aregs[3] = arg3;
        engine.aregs[4] = arg4;
        engine.aregs[5] = arg5;
        engine.aregs[6] = arg6;
        engine.aregs[7] = arg7;
        engine.cont = cont;
        return call();
    }

    public virtual Predicate call() {
        engine.setB0();
        return engine.jtry(dollar_writeTermOp_7_1, dollar_writeTermOp_7_sub_1);
    }

    public override int arity() { return 7; }

    public override string ToString() {
        return "$write_term_op(" + arg1 + ", " + arg2 + ", " + arg3 + ", " + arg4 + ", " + arg5 + ", " + arg6 + ", " + arg7 + ")";
    }
}

sealed class dollar_writeTermOp_7_sub_1 : dollar_writeTermOp_7 {

    public override Predicate exec() {
        return engine.trust(dollar_writeTermOp_7_2);
    }
}

sealed class dollar_writeTermOp_7_1 : dollar_writeTermOp_7 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("punct");
    static internal readonly IntegerTerm s2 = new IntegerTerm(40);
    static internal readonly SymbolTerm s3 = SymbolTerm.makeSymbol("[]");
    static internal readonly ListTerm s4 = new ListTerm(s2, s3);
    static internal readonly IntegerTerm s5 = new IntegerTerm(41);
    static internal readonly ListTerm s6 = new ListTerm(s5, s3);

    public override Predicate exec() {
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9;
        Predicate p1, p2, p3, p4, p5, p6, p7;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        a5 = engine.aregs[5].dereference();
        a6 = engine.aregs[6].dereference();
        a7 = engine.aregs[7].dereference();
        this.cont = engine.cont;

        if ( !s1.unify(a6, engine.trail) ) return engine.fail();
        a8 = engine.makeVariable();
        a9 = engine.makeVariable();
        p1 = new Predicates.dollar_put_1(s6, cont);
        p2 = new Predicates.dollar_writeTermOp1_7(a1, a2, a3, a9, s1, engine.makeVariable(), a7, p1);
        p3 = new Predicates.dollar_put_1(s4, p2);
        p4 = new Predicates.dollar_writeSpaceIfNeeded_2(a5, s1, p3);
        p5 = new Predicates.dollar_cut_1(a8, p4);
        p6 = new Predicates.dollar_greaterThan_2(a9, a4, p5);
        p7 = new Predicates.CurrentOp_3(a9, a2, a1, p6);
        return new Predicates.dollar_getLevel_1(a8, p7);
    }
}

sealed class dollar_writeTermOp_7_2 : dollar_writeTermOp_7 {

    public override Predicate exec() {
        Term a1, a2, a3, a4, a5, a6, a7, a8;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        a5 = engine.aregs[5].dereference();
        a6 = engine.aregs[6].dereference();
        a7 = engine.aregs[7].dereference();
        this.cont = engine.cont;

        a8 = engine.makeVariable();
        p1 = new Predicates.dollar_writeTermOp1_7(a1, a2, a3, a8, a5, a6, a7, cont);
        return new Predicates.CurrentOp_3(a8, a2, a1, p1);
    }
}
}

