/*
 * *** Please do not edit ! ***
 * @(#) ReadToken_1.cs
 * @procedure read_token/1 in inout.pl
 */

/*
 * @version Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class ReadToken_1 : Predicate {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("[]");

    public Term arg1;

    public ReadToken_1(Term a1, Predicate cont) {
        arg1 = a1; 
        this.cont = cont;
    }

    public ReadToken_1(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        this.cont = cont;
    }

    public override Predicate exec() {
        engine.setB0();
        Term a1, a2, a3, a4;
        Predicate p1;
        a1 = arg1.dereference();

        a2 = engine.makeVariable();
        a3 = engine.makeVariable();
        a4 = new ListTerm(a2, s1);
        p1 = new Predicates.dollar_readToken1_3(a4, a3, a1, cont);
        return new Predicates.dollar_readToken0_2(a2, a3, p1);
    }

    public override int arity() { return 1; }

    public override string ToString() {
        return "read_token(" + arg1 + ")";
    }
}
}

