/*
 * *** Please do not edit ! ***
 * @(#) Read_2.cs
 * @procedure read/2 in inout.pl
 */

/*
 * @version Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class Read_2 : Predicate {

    public Term arg1, arg2;

    public Read_2(Term a1, Term a2, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        this.cont = cont;
    }

    public Read_2(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        this.cont = cont;
    }

    public override Predicate exec() {
        engine.setB0();
        Term a1, a2, a3;
        Predicate p1, p2, p3;
        a1 = arg1.dereference();
        a2 = arg2.dereference();

        a3 = engine.makeVariable();
        p1 = new Predicates.dollar_setInput_1(a3, cont);
        p2 = new Predicates.Read_1(a2, p1);
        p3 = new Predicates.dollar_setInput_1(a1, p2);
        return new Predicates.dollar_currentInput_1(a3, p3);
    }

    public override int arity() { return 2; }

    public override string ToString() {
        return "read(" + arg1 + ", " + arg2 + ")";
    }
}
}

