/*
 * *** Please do not edit ! ***
 * @(#) Writeq_1.cs
 * @procedure writeq/1 in inout.pl
 */

/*
 * @version Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class Writeq_1 : Predicate {
    static internal readonly Predicate Writeq_1_1 = new Predicates.Writeq_1_1();
    static internal readonly Predicate Writeq_1_2 = new Predicates.Writeq_1_2();
    static internal readonly Predicate Writeq_1_3 = new Predicates.Writeq_1_3();
    static internal readonly Predicate Writeq_1_4 = new Predicates.Writeq_1_4();
    static internal readonly Predicate Writeq_1_sub_1 = new Predicates.Writeq_1_sub_1();

    public Term arg1;

    public Writeq_1(Term a1, Predicate cont) {
        arg1 = a1; 
        this.cont = cont;
    }

    public Writeq_1(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        this.cont = cont;
    }

    public override Predicate exec() {
        engine.aregs[1] = arg1;
        engine.cont = cont;
        return call();
    }

    public virtual Predicate call() {
        engine.setB0();
        return engine.jtry(Writeq_1_1, Writeq_1_sub_1);
    }

    public override int arity() { return 1; }

    public override string ToString() {
        return "writeq(" + arg1 + ")";
    }
}

sealed class Writeq_1_sub_1 : Writeq_1 {
    static internal readonly Predicate Writeq_1_sub_2 = new Predicates.Writeq_1_sub_2();

    public override Predicate exec() {
        return engine.retry(Writeq_1_2, Writeq_1_sub_2);
    }
}

sealed class Writeq_1_sub_2 : Writeq_1 {
    static internal readonly Predicate Writeq_1_sub_3 = new Predicates.Writeq_1_sub_3();

    public override Predicate exec() {
        return engine.retry(Writeq_1_3, Writeq_1_sub_3);
    }
}

sealed class Writeq_1_sub_3 : Writeq_1 {

    public override Predicate exec() {
        return engine.trust(Writeq_1_4);
    }
}

sealed class Writeq_1_1 : Writeq_1 {

    public override Predicate exec() {
        Term a1, a2;
        Predicate p1, p2, p3;
        a1 = engine.aregs[1].dereference();
        this.cont = engine.cont;

        a2 = engine.makeVariable();
        p1 = new Predicates.dollar_fastWriteq_1(a1, cont);
        p2 = new Predicates.dollar_cut_1(a2, p1);
        p3 = new Predicates.dollar_atomic_1(a1, p2);
        return new Predicates.dollar_getLevel_1(a2, p3);
    }
}

sealed class Writeq_1_2 : Writeq_1 {

    public override Predicate exec() {
        Term a1, a2;
        Predicate p1, p2, p3;
        a1 = engine.aregs[1].dereference();
        this.cont = engine.cont;

        a2 = engine.makeVariable();
        p1 = new Predicates.dollar_fastWriteq_1(a1, cont);
        p2 = new Predicates.dollar_cut_1(a2, p1);
        p3 = new Predicates.dollar_csObject_1(a1, p2);
        return new Predicates.dollar_getLevel_1(a2, p3);
    }
}

sealed class Writeq_1_3 : Writeq_1 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("quoted");
    static internal readonly SymbolTerm s2 = SymbolTerm.makeSymbol("numbervars");
    static internal readonly SymbolTerm s3 = SymbolTerm.makeSymbol("[]");
    static internal readonly ListTerm s4 = new ListTerm(s2, s3);
    static internal readonly ListTerm s5 = new ListTerm(s1, s4);

    public override Predicate exec() {
        Term a1;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        this.cont = engine.cont;

        p1 = new Predicates.dollar_fail_0(cont);
        return new Predicates.dollar_writeTerm_2(a1, s5, p1);
    }
}

sealed class Writeq_1_4 : Writeq_1 {

    public override Predicate exec() {
        return engine.cont;
    }
}
}

