/*
 * *** Please do not edit ! ***
 * @(#) dollar_ancestor_2.cs
 * @procedure $ancestor/2 in interpreter.pl
 */

/*
 * @version Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_ancestor_2 : Predicate {
    static internal readonly SymbolTerm functor = SymbolTerm.makeSymbol("$ancestor", 2);
    static internal readonly Predicate dollar_fail_0 = new Predicates.dollar_fail_0();
    static internal readonly Predicate dollar_ancestor_2_res_0 = new Predicates.dollar_ancestor_2_res_0();
    static internal readonly Predicate dollar_ancestor_2_res_1 = new Predicates.dollar_ancestor_2_res_1();
    static internal readonly Predicate dollar_ancestor_2_res_2 = new Predicates.dollar_ancestor_2_res_2();
    static internal readonly Predicate dollar_ancestor_2_res_3 = new Predicates.dollar_ancestor_2_res_3();

    public Term arg1, arg2;

    public dollar_ancestor_2(Term a1, Term a2, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        this.cont = cont;
    }

    public dollar_ancestor_2(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        this.cont = cont;
    }

    public override Predicate exec() {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.cont = cont;
        return call();
    }

    public virtual Predicate call() {
        engine.setB0();
        if ( !functor.res.isList() )
            return engine.fail();
        engine.lookUpHash(functor);
        if ( !engine.pickupResource(functor, 3) )
            return engine.fail();
        if ( !engine.hasMoreResource() )
            return dollar_ancestor_2_res_1;
        return engine.tryResource(dollar_ancestor_2_res_1, dollar_ancestor_2_res_0);
    }

    public override int arity() { return 2; }

    public override string ToString() {
        return "$ancestor(" + arg1 + ", " + arg2 + ")";
    }
}

sealed class dollar_ancestor_2_res_0 : dollar_ancestor_2 {

    public override Predicate exec() {
        engine.restoreResource();
        if ( !engine.pickupResource(functor, 3) )
            return dollar_ancestor_2_res_2;
        if ( !engine.hasMoreResource() )
            return dollar_ancestor_2_res_3;
        return engine.retryResource(dollar_ancestor_2_res_1, dollar_ancestor_2_res_0);
    }
}

sealed class dollar_ancestor_2_res_1 : dollar_ancestor_2 {

    public override Predicate exec() {
        return engine.executeClosure(engine.consume(3));
    }
}

sealed class dollar_ancestor_2_res_2 : dollar_ancestor_2 {

    public override Predicate exec() {
        return engine.trustResource(dollar_fail_0);
    }
}

sealed class dollar_ancestor_2_res_3 : dollar_ancestor_2 {

    public override Predicate exec() {
        return engine.trustResource(dollar_ancestor_2_res_1);
    }
}
}

