/*
 * *** Please do not edit ! ***
 * @(#) dollar_assertSpies_1.cs
 * @procedure $assert_spies/1 in interpreter.pl
 */

/*
 * @version Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_assertSpies_1 : Predicate {
    static internal readonly Predicate dollar_fail_0 = new Predicates.dollar_fail_0();
    static internal readonly Predicate dollar_assertSpies_1_1 = new Predicates.dollar_assertSpies_1_1();
    static internal readonly Predicate dollar_assertSpies_1_2 = new Predicates.dollar_assertSpies_1_2();
    static internal readonly Predicate dollar_assertSpies_1_var = new Predicates.dollar_assertSpies_1_var();

    public Term arg1;

    public dollar_assertSpies_1(Term a1, Predicate cont) {
        arg1 = a1; 
        this.cont = cont;
    }

    public dollar_assertSpies_1(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        this.cont = cont;
    }

    public override Predicate exec() {
        engine.aregs[1] = arg1;
        engine.cont = cont;
        return call();
    }

    public virtual Predicate call() {
        engine.setB0();
        return engine.switch_on_term(
                                   dollar_assertSpies_1_var,
                                   dollar_fail_0,
                                   dollar_assertSpies_1_1,
                                   dollar_fail_0,
                                   dollar_assertSpies_1_2
                                   );
    }

    public override int arity() { return 1; }

    public override string ToString() {
        return "$assert_spies(" + arg1 + ")";
    }
}

sealed class dollar_assertSpies_1_var : dollar_assertSpies_1 {
    static internal readonly Predicate dollar_assertSpies_1_var_1 = new Predicates.dollar_assertSpies_1_var_1();

    public override Predicate exec() {
        return engine.jtry(dollar_assertSpies_1_1, dollar_assertSpies_1_var_1);
    }
}

sealed class dollar_assertSpies_1_var_1 : dollar_assertSpies_1 {

    public override Predicate exec() {
        return engine.trust(dollar_assertSpies_1_2);
    }
}

sealed class dollar_assertSpies_1_1 : dollar_assertSpies_1 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("[]");

    public override Predicate exec() {
        Term a1;
        a1 = engine.aregs[1].dereference();
        this.cont = engine.cont;

        if ( !s1.unify(a1, engine.trail) ) return engine.fail();
        return new Predicates.dollar_neckCut_0(cont);
    }
}

sealed class dollar_assertSpies_1_2 : dollar_assertSpies_1 {

    public override Predicate exec() {
        Term a1, a2, a3;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        this.cont = engine.cont;

        if ( a1.isList() ){
            a2 = ((ListTerm)a1).car;
            a3 = ((ListTerm)a1).cdr;
        } else if ( a1.isVariable() ){
            a2 = engine.makeVariable();
            a3 = engine.makeVariable();
            if ( !a1.unify(new ListTerm(a2, a3), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        p1 = new Predicates.dollar_assertSpies_1(a3, cont);
        return new Predicates.dollar_assertSpy_1(a2, p1);
    }
}
}

