/*
 * *** Please do not edit ! ***
 * @(#) dollar_assertSpy_1.cs
 * @procedure $assert_spy/1 in interpreter.pl
 */

/*
 * @version Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_assertSpy_1 : Predicate {
    static internal readonly Predicate dollar_assertSpy_1_1 = new Predicates.dollar_assertSpy_1_1();
    static internal readonly Predicate dollar_assertSpy_1_2 = new Predicates.dollar_assertSpy_1_2();
    static internal readonly Predicate dollar_assertSpy_1_sub_1 = new Predicates.dollar_assertSpy_1_sub_1();

    public Term arg1;

    public dollar_assertSpy_1(Term a1, Predicate cont) {
        arg1 = a1; 
        this.cont = cont;
    }

    public dollar_assertSpy_1(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        this.cont = cont;
    }

    public override Predicate exec() {
        engine.aregs[1] = arg1;
        engine.cont = cont;
        return call();
    }

    public virtual Predicate call() {
        engine.setB0();
        return engine.jtry(dollar_assertSpy_1_1, dollar_assertSpy_1_sub_1);
    }

    public override int arity() { return 1; }

    public override string ToString() {
        return "$assert_spy(" + arg1 + ")";
    }
}

sealed class dollar_assertSpy_1_sub_1 : dollar_assertSpy_1 {

    public override Predicate exec() {
        return engine.trust(dollar_assertSpy_1_2);
    }
}

sealed class dollar_assertSpy_1_1 : dollar_assertSpy_1 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("/", 2);
    static internal readonly SymbolTerm f3 = SymbolTerm.makeSymbol("$current_spy", 2);
    static internal readonly SymbolTerm s5 = SymbolTerm.makeSymbol("{Spypoint ");
    static internal readonly SymbolTerm s6 = SymbolTerm.makeSymbol(" is already defined}");

    public override Predicate exec() {
        Term a1, a2, a3, a4, a5, a6;
        Predicate p1, p2, p3, p4, p5, p6, p7;
        a1 = engine.aregs[1].dereference();
        this.cont = engine.cont;

        a2 = engine.makeVariable();
        a4 = engine.makeVariable();
        a5 = engine.makeVariable();
        Term[] h2 = {a4, a5};
        a3 = new StructureTerm(f1, h2);
        Term[] h4 = {a4, a5};
        a6 = new StructureTerm(f3, h4);
        p1 = new Predicates.dollar_cut_1(a2, cont);
        p2 = new Predicates.dollar_nl_0(p1);
        p3 = new Predicates.Write_1(s6, p2);
        p4 = new Predicates.Write_1(a1, p3);
        p5 = new Predicates.Write_1(s5, p4);
        p6 = new Predicates.Clause_2(a6, engine.makeVariable(), p5);
        p7 = new Predicates.dollar_unify_2(a1, a3, p6);
        return new Predicates.dollar_getLevel_1(a2, p7);
    }
}

sealed class dollar_assertSpy_1_2 : dollar_assertSpy_1 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("/", 2);
    static internal readonly SymbolTerm f3 = SymbolTerm.makeSymbol("$current_spy", 2);
    static internal readonly SymbolTerm s5 = SymbolTerm.makeSymbol("{Spypoint ");
    static internal readonly SymbolTerm s6 = SymbolTerm.makeSymbol(" is added}");

    public override Predicate exec() {
        Term a1, a2, a3, a4, a5;
        Predicate p1, p2, p3, p4, p5;
        a1 = engine.aregs[1].dereference();
        this.cont = engine.cont;

        a3 = engine.makeVariable();
        a4 = engine.makeVariable();
        Term[] h2 = {a3, a4};
        a2 = new StructureTerm(f1, h2);
        Term[] h4 = {a3, a4};
        a5 = new StructureTerm(f3, h4);
        p1 = new Predicates.dollar_nl_0(cont);
        p2 = new Predicates.Write_1(s6, p1);
        p3 = new Predicates.Write_1(a1, p2);
        p4 = new Predicates.Write_1(s5, p3);
        p5 = new Predicates.Assert_1(a5, p4);
        return new Predicates.dollar_unify_2(a1, a2, p5);
    }
}
}

