/*
 * *** Please do not edit ! ***
 * @(#) dollar_cafeWriteResult0_1.cs
 * @procedure $cafe_write_result0/1 in interpreter.pl
 */

/*
 * @version Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_cafeWriteResult0_1 : Predicate {
    static internal readonly Predicate dollar_fail_0 = new Predicates.dollar_fail_0();
    static internal readonly Predicate dollar_cafeWriteResult0_1_1 = new Predicates.dollar_cafeWriteResult0_1_1();
    static internal readonly Predicate dollar_cafeWriteResult0_1_2 = new Predicates.dollar_cafeWriteResult0_1_2();
    static internal readonly Predicate dollar_cafeWriteResult0_1_3 = new Predicates.dollar_cafeWriteResult0_1_3();
    static internal readonly Predicate dollar_cafeWriteResult0_1_lis = new Predicates.dollar_cafeWriteResult0_1_lis();
    static internal readonly Predicate dollar_cafeWriteResult0_1_var = new Predicates.dollar_cafeWriteResult0_1_var();

    public Term arg1;

    public dollar_cafeWriteResult0_1(Term a1, Predicate cont) {
        arg1 = a1; 
        this.cont = cont;
    }

    public dollar_cafeWriteResult0_1(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        this.cont = cont;
    }

    public override Predicate exec() {
        engine.aregs[1] = arg1;
        engine.cont = cont;
        return call();
    }

    public virtual Predicate call() {
        engine.setB0();
        return engine.switch_on_term(
                                   dollar_cafeWriteResult0_1_var,
                                   dollar_fail_0,
                                   dollar_cafeWriteResult0_1_1,
                                   dollar_fail_0,
                                   dollar_cafeWriteResult0_1_lis
                                   );
    }

    public override int arity() { return 1; }

    public override string ToString() {
        return "$cafe_write_result0(" + arg1 + ")";
    }
}

sealed class dollar_cafeWriteResult0_1_var : dollar_cafeWriteResult0_1 {
    static internal readonly Predicate dollar_cafeWriteResult0_1_var_1 = new Predicates.dollar_cafeWriteResult0_1_var_1();

    public override Predicate exec() {
        return engine.jtry(dollar_cafeWriteResult0_1_1, dollar_cafeWriteResult0_1_var_1);
    }
}

sealed class dollar_cafeWriteResult0_1_var_1 : dollar_cafeWriteResult0_1 {
    static internal readonly Predicate dollar_cafeWriteResult0_1_var_2 = new Predicates.dollar_cafeWriteResult0_1_var_2();

    public override Predicate exec() {
        return engine.retry(dollar_cafeWriteResult0_1_2, dollar_cafeWriteResult0_1_var_2);
    }
}

sealed class dollar_cafeWriteResult0_1_var_2 : dollar_cafeWriteResult0_1 {

    public override Predicate exec() {
        return engine.trust(dollar_cafeWriteResult0_1_3);
    }
}

sealed class dollar_cafeWriteResult0_1_lis : dollar_cafeWriteResult0_1 {
    static internal readonly Predicate dollar_cafeWriteResult0_1_lis_1 = new Predicates.dollar_cafeWriteResult0_1_lis_1();

    public override Predicate exec() {
        return engine.jtry(dollar_cafeWriteResult0_1_2, dollar_cafeWriteResult0_1_lis_1);
    }
}

sealed class dollar_cafeWriteResult0_1_lis_1 : dollar_cafeWriteResult0_1 {

    public override Predicate exec() {
        return engine.trust(dollar_cafeWriteResult0_1_3);
    }
}

sealed class dollar_cafeWriteResult0_1_1 : dollar_cafeWriteResult0_1 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("[]");
    static internal readonly SymbolTerm s2 = SymbolTerm.makeSymbol("true");

    public override Predicate exec() {
        Term a1;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        this.cont = engine.cont;

        if ( !s1.unify(a1, engine.trail) ) return engine.fail();
        p1 = new Predicates.Write_1(s2, cont);
        return new Predicates.dollar_neckCut_0(p1);
    }
}

sealed class dollar_cafeWriteResult0_1_2 : dollar_cafeWriteResult0_1 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("[]");
    static internal readonly SymbolTerm f2 = SymbolTerm.makeSymbol("=", 2);
    static internal readonly SymbolTerm s3 = SymbolTerm.makeSymbol(" = ");

    public override Predicate exec() {
        Term a1, a2, a3, a4;
        Predicate p1, p2, p3;
        a1 = engine.aregs[1].dereference();
        this.cont = engine.cont;

        if ( a1.isList() ){
            a2 = ((ListTerm)a1).car;
            if ( !s1.unify(((ListTerm)a1).cdr, engine.trail) )
                return engine.fail();
        } else if ( a1.isVariable() ){
            a2 = engine.makeVariable();
            if ( !a1.unify(new ListTerm(a2, s1), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a2.isStructure() ){
            if (f2 != ((StructureTerm)a2).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a2).args;
            a3 = args[0];
            a4 = args[1];
        } else if (a2.isVariable() ){
            a3 = engine.makeVariable();
            a4 = engine.makeVariable();
            Term[] args = {a3, a4};
            if ( !a2.unify(new StructureTerm(f2, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        p1 = new Predicates.Write_1(a4, cont);
        p2 = new Predicates.Write_1(s3, p1);
        p3 = new Predicates.Write_1(a3, p2);
        return new Predicates.dollar_neckCut_0(p3);
    }
}

sealed class dollar_cafeWriteResult0_1_3 : dollar_cafeWriteResult0_1 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("=", 2);
    static internal readonly SymbolTerm s2 = SymbolTerm.makeSymbol(" = ");
    static internal readonly SymbolTerm s3 = SymbolTerm.makeSymbol(",");

    public override Predicate exec() {
        Term a1, a2, a3, a4, a5;
        Predicate p1, p2, p3, p4, p5;
        a1 = engine.aregs[1].dereference();
        this.cont = engine.cont;

        if ( a1.isList() ){
            a2 = ((ListTerm)a1).car;
            a3 = ((ListTerm)a1).cdr;
        } else if ( a1.isVariable() ){
            a2 = engine.makeVariable();
            a3 = engine.makeVariable();
            if ( !a1.unify(new ListTerm(a2, a3), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a2.isStructure() ){
            if (f1 != ((StructureTerm)a2).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a2).args;
            a4 = args[0];
            a5 = args[1];
        } else if (a2.isVariable() ){
            a4 = engine.makeVariable();
            a5 = engine.makeVariable();
            Term[] args = {a4, a5};
            if ( !a2.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        p1 = new Predicates.dollar_cafeWriteResult0_1(a3, cont);
        p2 = new Predicates.dollar_nl_0(p1);
        p3 = new Predicates.Write_1(s3, p2);
        p4 = new Predicates.Write_1(a5, p3);
        p5 = new Predicates.Write_1(s2, p4);
        return new Predicates.Write_1(a4, p5);
    }
}
}

