/*
 * *** Please do not edit ! ***
 * @(#) dollar_fullLeash_1.cs
 * @procedure $full_leash/1 in interpreter.pl
 */

/*
 * @version Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_fullLeash_1 : Predicate {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("call");
    static internal readonly SymbolTerm s2 = SymbolTerm.makeSymbol("exit");
    static internal readonly SymbolTerm s3 = SymbolTerm.makeSymbol("redo");
    static internal readonly SymbolTerm s4 = SymbolTerm.makeSymbol("fail");
    static internal readonly SymbolTerm s5 = SymbolTerm.makeSymbol("[]");
    static internal readonly ListTerm s6 = new ListTerm(s4, s5);
    static internal readonly ListTerm s7 = new ListTerm(s3, s6);
    static internal readonly ListTerm s8 = new ListTerm(s2, s7);
    static internal readonly ListTerm s9 = new ListTerm(s1, s8);

    public Term arg1;

    public dollar_fullLeash_1(Term a1, Predicate cont) {
        arg1 = a1; 
        this.cont = cont;
    }

    public dollar_fullLeash_1(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        this.cont = cont;
    }

    public override Predicate exec() {
        engine.setB0();
        Term a1;
        a1 = arg1.dereference();

        if ( !s9.unify(a1, engine.trail) ) return engine.fail();
        return cont;
    }

    public override int arity() { return 1; }

    public override string ToString() {
        return "$full_leash(" + arg1 + ")";
    }
}
}

