/*
 * *** Please do not edit ! ***
 * @(#) dollar_spyMessages_3.cs
 * @procedure $spy_messages/3 in interpreter.pl
 */

/*
 * @version Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_spyMessages_3 : Predicate {
    static internal readonly Predicate dollar_spyMessages_3_1 = new Predicates.dollar_spyMessages_3_1();
    static internal readonly Predicate dollar_spyMessages_3_2 = new Predicates.dollar_spyMessages_3_2();
    static internal readonly Predicate dollar_spyMessages_3_sub_1 = new Predicates.dollar_spyMessages_3_sub_1();

    public Term arg1, arg2, arg3;

    public dollar_spyMessages_3(Term a1, Term a2, Term a3, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        this.cont = cont;
    }

    public dollar_spyMessages_3(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        this.cont = cont;
    }

    public override Predicate exec() {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.aregs[3] = arg3;
        engine.cont = cont;
        return call();
    }

    public virtual Predicate call() {
        engine.setB0();
        return engine.jtry(dollar_spyMessages_3_1, dollar_spyMessages_3_sub_1);
    }

    public override int arity() { return 3; }

    public override string ToString() {
        return "$spy_messages(" + arg1 + ", " + arg2 + ", " + arg3 + ")";
    }
}

sealed class dollar_spyMessages_3_sub_1 : dollar_spyMessages_3 {

    public override Predicate exec() {
        return engine.trust(dollar_spyMessages_3_2);
    }
}

sealed class dollar_spyMessages_3_1 : dollar_spyMessages_3 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol(" + ");
    static internal readonly SymbolTerm s2 = SymbolTerm.makeSymbol(" ");
    static internal readonly SymbolTerm s3 = SymbolTerm.makeSymbol(" ? ");

    public override Predicate exec() {
        Term a1, a2, a3, a4, a5, a6;
        Predicate p1, p2, p3, p4, p5, p6, p7, p8, p9, p10, p11;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        this.cont = engine.cont;

        a4 = engine.makeVariable();
        a5 = engine.makeVariable();
        a6 = engine.makeVariable();
        p1 = new Predicates.Readline_1(engine.makeVariable(), cont);
        p2 = new Predicates.dollar_flushOutput_0(p1);
        p3 = new Predicates.Write_1(s3, p2);
        p4 = new Predicates.Write_1(a2, p3);
        p5 = new Predicates.dollar_writeLeashMode_1(a3, p4);
        p6 = new Predicates.Write_1(s2, p5);
        p7 = new Predicates.Write_1(a1, p6);
        p8 = new Predicates.Write_1(s1, p7);
        p9 = new Predicates.dollar_cut_1(a4, p8);
        p10 = new Predicates.dollar_currentSpy_2(a5, a6, p9);
        p11 = new Predicates.dollar_functor_3(a2, a5, a6, p10);
        return new Predicates.dollar_getLevel_1(a4, p11);
    }
}

sealed class dollar_spyMessages_3_2 : dollar_spyMessages_3 {

    public override Predicate exec() {
        return engine.cont;
    }
}
}

