/*
 * *** Please do not edit ! ***
 * @(#) dollar_traceRedo_2.cs
 * @procedure $trace_redo/2 in interpreter.pl
 */

/*
 * @version Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_traceRedo_2 : Predicate {
    static internal readonly Predicate dollar_traceRedo_2_1 = new Predicates.dollar_traceRedo_2_1();
    static internal readonly Predicate dollar_traceRedo_2_2 = new Predicates.dollar_traceRedo_2_2();
    static internal readonly Predicate dollar_traceRedo_2_sub_1 = new Predicates.dollar_traceRedo_2_sub_1();

    public Term arg1, arg2;

    public dollar_traceRedo_2(Term a1, Term a2, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        this.cont = cont;
    }

    public dollar_traceRedo_2(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        this.cont = cont;
    }

    public override Predicate exec() {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.cont = cont;
        return call();
    }

    public virtual Predicate call() {
        engine.setB0();
        return engine.jtry(dollar_traceRedo_2_1, dollar_traceRedo_2_sub_1);
    }

    public override int arity() { return 2; }

    public override string ToString() {
        return "$trace_redo(" + arg1 + ", " + arg2 + ")";
    }
}

sealed class dollar_traceRedo_2_sub_1 : dollar_traceRedo_2 {

    public override Predicate exec() {
        return engine.trust(dollar_traceRedo_2_2);
    }
}

sealed class dollar_traceRedo_2_1 : dollar_traceRedo_2 {

    public override Predicate exec() {
        return engine.cont;
    }
}

sealed class dollar_traceRedo_2_2 : dollar_traceRedo_2 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("redo");

    public override Predicate exec() {
        Term a1, a2;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        this.cont = engine.cont;

        p1 = new Predicates.dollar_fail_0(cont);
        return new Predicates.dollar_tracingMessages_3(a2, a1, s1, p1);
    }
}
}

