/*
 * *** Please do not edit ! ***
 * @(#) dollar_trace_2.cs
 * @procedure $trace/2 in interpreter.pl
 */

/*
 * @version Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_trace_2 : Predicate {
    static internal readonly Predicate dollar_trace_2_1 = new Predicates.dollar_trace_2_1();
    static internal readonly Predicate dollar_trace_2_2 = new Predicates.dollar_trace_2_2();
    static internal readonly Predicate dollar_trace_2_3 = new Predicates.dollar_trace_2_3();
    static internal readonly Predicate dollar_trace_2_4 = new Predicates.dollar_trace_2_4();
    static internal readonly Predicate dollar_trace_2_5 = new Predicates.dollar_trace_2_5();
    static internal readonly Predicate dollar_trace_2_6 = new Predicates.dollar_trace_2_6();
    static internal readonly Predicate dollar_trace_2_7 = new Predicates.dollar_trace_2_7();
    static internal readonly Predicate dollar_trace_2_8 = new Predicates.dollar_trace_2_8();
    static internal readonly Predicate dollar_trace_2_9 = new Predicates.dollar_trace_2_9();
    static internal readonly Predicate dollar_trace_2_10 = new Predicates.dollar_trace_2_10();
    static internal readonly Predicate dollar_trace_2_11 = new Predicates.dollar_trace_2_11();
    static internal readonly Predicate dollar_trace_2_12 = new Predicates.dollar_trace_2_12();
    static internal readonly Predicate dollar_trace_2_13 = new Predicates.dollar_trace_2_13();
    static internal readonly Predicate dollar_trace_2_14 = new Predicates.dollar_trace_2_14();
    static internal readonly Predicate dollar_trace_2_15 = new Predicates.dollar_trace_2_15();
    static internal readonly Predicate dollar_trace_2_16 = new Predicates.dollar_trace_2_16();
    static internal readonly Predicate dollar_trace_2_con = new Predicates.dollar_trace_2_con();
    static internal readonly Predicate dollar_trace_2_int = new Predicates.dollar_trace_2_int();
    static internal readonly Predicate dollar_trace_2_lis = new Predicates.dollar_trace_2_lis();
    static internal readonly Predicate dollar_trace_2_str = new Predicates.dollar_trace_2_str();
    static internal readonly Predicate dollar_trace_2_var = new Predicates.dollar_trace_2_var();

    public Term arg1, arg2;

    public dollar_trace_2(Term a1, Term a2, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        this.cont = cont;
    }

    public dollar_trace_2(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        this.cont = cont;
    }

    public override Predicate exec() {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.cont = cont;
        return call();
    }

    public virtual Predicate call() {
        engine.setB0();
        return engine.switch_on_term(
                                   dollar_trace_2_var,
                                   dollar_trace_2_int,
                                   dollar_trace_2_con,
                                   dollar_trace_2_str,
                                   dollar_trace_2_lis
                                   );
    }

    public override int arity() { return 2; }

    public override string ToString() {
        return "$trace(" + arg1 + ", " + arg2 + ")";
    }
}

sealed class dollar_trace_2_var : dollar_trace_2 {
    static internal readonly Predicate dollar_trace_2_var_1 = new Predicates.dollar_trace_2_var_1();

    public override Predicate exec() {
        return engine.jtry(dollar_trace_2_1, dollar_trace_2_var_1);
    }
}

sealed class dollar_trace_2_var_1 : dollar_trace_2 {
    static internal readonly Predicate dollar_trace_2_var_2 = new Predicates.dollar_trace_2_var_2();

    public override Predicate exec() {
        return engine.retry(dollar_trace_2_2, dollar_trace_2_var_2);
    }
}

sealed class dollar_trace_2_var_2 : dollar_trace_2 {
    static internal readonly Predicate dollar_trace_2_var_3 = new Predicates.dollar_trace_2_var_3();

    public override Predicate exec() {
        return engine.retry(dollar_trace_2_3, dollar_trace_2_var_3);
    }
}

sealed class dollar_trace_2_var_3 : dollar_trace_2 {
    static internal readonly Predicate dollar_trace_2_var_4 = new Predicates.dollar_trace_2_var_4();

    public override Predicate exec() {
        return engine.retry(dollar_trace_2_4, dollar_trace_2_var_4);
    }
}

sealed class dollar_trace_2_var_4 : dollar_trace_2 {
    static internal readonly Predicate dollar_trace_2_var_5 = new Predicates.dollar_trace_2_var_5();

    public override Predicate exec() {
        return engine.retry(dollar_trace_2_5, dollar_trace_2_var_5);
    }
}

sealed class dollar_trace_2_var_5 : dollar_trace_2 {
    static internal readonly Predicate dollar_trace_2_var_6 = new Predicates.dollar_trace_2_var_6();

    public override Predicate exec() {
        return engine.retry(dollar_trace_2_6, dollar_trace_2_var_6);
    }
}

sealed class dollar_trace_2_var_6 : dollar_trace_2 {
    static internal readonly Predicate dollar_trace_2_var_7 = new Predicates.dollar_trace_2_var_7();

    public override Predicate exec() {
        return engine.retry(dollar_trace_2_7, dollar_trace_2_var_7);
    }
}

sealed class dollar_trace_2_var_7 : dollar_trace_2 {
    static internal readonly Predicate dollar_trace_2_var_8 = new Predicates.dollar_trace_2_var_8();

    public override Predicate exec() {
        return engine.retry(dollar_trace_2_8, dollar_trace_2_var_8);
    }
}

sealed class dollar_trace_2_var_8 : dollar_trace_2 {
    static internal readonly Predicate dollar_trace_2_var_9 = new Predicates.dollar_trace_2_var_9();

    public override Predicate exec() {
        return engine.retry(dollar_trace_2_9, dollar_trace_2_var_9);
    }
}

sealed class dollar_trace_2_var_9 : dollar_trace_2 {
    static internal readonly Predicate dollar_trace_2_var_10 = new Predicates.dollar_trace_2_var_10();

    public override Predicate exec() {
        return engine.retry(dollar_trace_2_10, dollar_trace_2_var_10);
    }
}

sealed class dollar_trace_2_var_10 : dollar_trace_2 {
    static internal readonly Predicate dollar_trace_2_var_11 = new Predicates.dollar_trace_2_var_11();

    public override Predicate exec() {
        return engine.retry(dollar_trace_2_11, dollar_trace_2_var_11);
    }
}

sealed class dollar_trace_2_var_11 : dollar_trace_2 {
    static internal readonly Predicate dollar_trace_2_var_12 = new Predicates.dollar_trace_2_var_12();

    public override Predicate exec() {
        return engine.retry(dollar_trace_2_12, dollar_trace_2_var_12);
    }
}

sealed class dollar_trace_2_var_12 : dollar_trace_2 {
    static internal readonly Predicate dollar_trace_2_var_13 = new Predicates.dollar_trace_2_var_13();

    public override Predicate exec() {
        return engine.retry(dollar_trace_2_13, dollar_trace_2_var_13);
    }
}

sealed class dollar_trace_2_var_13 : dollar_trace_2 {
    static internal readonly Predicate dollar_trace_2_var_14 = new Predicates.dollar_trace_2_var_14();

    public override Predicate exec() {
        return engine.retry(dollar_trace_2_14, dollar_trace_2_var_14);
    }
}

sealed class dollar_trace_2_var_14 : dollar_trace_2 {
    static internal readonly Predicate dollar_trace_2_var_15 = new Predicates.dollar_trace_2_var_15();

    public override Predicate exec() {
        return engine.retry(dollar_trace_2_15, dollar_trace_2_var_15);
    }
}

sealed class dollar_trace_2_var_15 : dollar_trace_2 {

    public override Predicate exec() {
        return engine.trust(dollar_trace_2_16);
    }
}

sealed class dollar_trace_2_int : dollar_trace_2 {
    static internal readonly Predicate dollar_trace_2_int_1 = new Predicates.dollar_trace_2_int_1();

    public override Predicate exec() {
        return engine.jtry(dollar_trace_2_1, dollar_trace_2_int_1);
    }
}

sealed class dollar_trace_2_int_1 : dollar_trace_2 {
    static internal readonly Predicate dollar_trace_2_int_2 = new Predicates.dollar_trace_2_int_2();

    public override Predicate exec() {
        return engine.retry(dollar_trace_2_15, dollar_trace_2_int_2);
    }
}

sealed class dollar_trace_2_int_2 : dollar_trace_2 {

    public override Predicate exec() {
        return engine.trust(dollar_trace_2_16);
    }
}

sealed class dollar_trace_2_con : dollar_trace_2 {
    static internal readonly Predicate dollar_trace_2_con_1 = new Predicates.dollar_trace_2_con_1();

    public override Predicate exec() {
        return engine.jtry(dollar_trace_2_1, dollar_trace_2_con_1);
    }
}

sealed class dollar_trace_2_con_1 : dollar_trace_2 {
    static internal readonly Predicate dollar_trace_2_con_2 = new Predicates.dollar_trace_2_con_2();

    public override Predicate exec() {
        return engine.retry(dollar_trace_2_2, dollar_trace_2_con_2);
    }
}

sealed class dollar_trace_2_con_2 : dollar_trace_2 {
    static internal readonly Predicate dollar_trace_2_con_3 = new Predicates.dollar_trace_2_con_3();

    public override Predicate exec() {
        return engine.retry(dollar_trace_2_3, dollar_trace_2_con_3);
    }
}

sealed class dollar_trace_2_con_3 : dollar_trace_2 {
    static internal readonly Predicate dollar_trace_2_con_4 = new Predicates.dollar_trace_2_con_4();

    public override Predicate exec() {
        return engine.retry(dollar_trace_2_4, dollar_trace_2_con_4);
    }
}

sealed class dollar_trace_2_con_4 : dollar_trace_2 {
    static internal readonly Predicate dollar_trace_2_con_5 = new Predicates.dollar_trace_2_con_5();

    public override Predicate exec() {
        return engine.retry(dollar_trace_2_15, dollar_trace_2_con_5);
    }
}

sealed class dollar_trace_2_con_5 : dollar_trace_2 {

    public override Predicate exec() {
        return engine.trust(dollar_trace_2_16);
    }
}

sealed class dollar_trace_2_str : dollar_trace_2 {
    static internal readonly Predicate dollar_trace_2_str_1 = new Predicates.dollar_trace_2_str_1();

    public override Predicate exec() {
        return engine.jtry(dollar_trace_2_1, dollar_trace_2_str_1);
    }
}

sealed class dollar_trace_2_str_1 : dollar_trace_2 {
    static internal readonly Predicate dollar_trace_2_str_2 = new Predicates.dollar_trace_2_str_2();

    public override Predicate exec() {
        return engine.retry(dollar_trace_2_5, dollar_trace_2_str_2);
    }
}

sealed class dollar_trace_2_str_2 : dollar_trace_2 {
    static internal readonly Predicate dollar_trace_2_str_3 = new Predicates.dollar_trace_2_str_3();

    public override Predicate exec() {
        return engine.retry(dollar_trace_2_6, dollar_trace_2_str_3);
    }
}

sealed class dollar_trace_2_str_3 : dollar_trace_2 {
    static internal readonly Predicate dollar_trace_2_str_4 = new Predicates.dollar_trace_2_str_4();

    public override Predicate exec() {
        return engine.retry(dollar_trace_2_7, dollar_trace_2_str_4);
    }
}

sealed class dollar_trace_2_str_4 : dollar_trace_2 {
    static internal readonly Predicate dollar_trace_2_str_5 = new Predicates.dollar_trace_2_str_5();

    public override Predicate exec() {
        return engine.retry(dollar_trace_2_8, dollar_trace_2_str_5);
    }
}

sealed class dollar_trace_2_str_5 : dollar_trace_2 {
    static internal readonly Predicate dollar_trace_2_str_6 = new Predicates.dollar_trace_2_str_6();

    public override Predicate exec() {
        return engine.retry(dollar_trace_2_9, dollar_trace_2_str_6);
    }
}

sealed class dollar_trace_2_str_6 : dollar_trace_2 {
    static internal readonly Predicate dollar_trace_2_str_7 = new Predicates.dollar_trace_2_str_7();

    public override Predicate exec() {
        return engine.retry(dollar_trace_2_10, dollar_trace_2_str_7);
    }
}

sealed class dollar_trace_2_str_7 : dollar_trace_2 {
    static internal readonly Predicate dollar_trace_2_str_8 = new Predicates.dollar_trace_2_str_8();

    public override Predicate exec() {
        return engine.retry(dollar_trace_2_11, dollar_trace_2_str_8);
    }
}

sealed class dollar_trace_2_str_8 : dollar_trace_2 {
    static internal readonly Predicate dollar_trace_2_str_9 = new Predicates.dollar_trace_2_str_9();

    public override Predicate exec() {
        return engine.retry(dollar_trace_2_12, dollar_trace_2_str_9);
    }
}

sealed class dollar_trace_2_str_9 : dollar_trace_2 {
    static internal readonly Predicate dollar_trace_2_str_10 = new Predicates.dollar_trace_2_str_10();

    public override Predicate exec() {
        return engine.retry(dollar_trace_2_13, dollar_trace_2_str_10);
    }
}

sealed class dollar_trace_2_str_10 : dollar_trace_2 {
    static internal readonly Predicate dollar_trace_2_str_11 = new Predicates.dollar_trace_2_str_11();

    public override Predicate exec() {
        return engine.retry(dollar_trace_2_14, dollar_trace_2_str_11);
    }
}

sealed class dollar_trace_2_str_11 : dollar_trace_2 {
    static internal readonly Predicate dollar_trace_2_str_12 = new Predicates.dollar_trace_2_str_12();

    public override Predicate exec() {
        return engine.retry(dollar_trace_2_15, dollar_trace_2_str_12);
    }
}

sealed class dollar_trace_2_str_12 : dollar_trace_2 {

    public override Predicate exec() {
        return engine.trust(dollar_trace_2_16);
    }
}

sealed class dollar_trace_2_lis : dollar_trace_2 {
    static internal readonly Predicate dollar_trace_2_lis_1 = new Predicates.dollar_trace_2_lis_1();

    public override Predicate exec() {
        return engine.jtry(dollar_trace_2_1, dollar_trace_2_lis_1);
    }
}

sealed class dollar_trace_2_lis_1 : dollar_trace_2 {
    static internal readonly Predicate dollar_trace_2_lis_2 = new Predicates.dollar_trace_2_lis_2();

    public override Predicate exec() {
        return engine.retry(dollar_trace_2_15, dollar_trace_2_lis_2);
    }
}

sealed class dollar_trace_2_lis_2 : dollar_trace_2 {

    public override Predicate exec() {
        return engine.trust(dollar_trace_2_16);
    }
}

sealed class dollar_trace_2_1 : dollar_trace_2 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("var");
    static internal readonly SymbolTerm f2 = SymbolTerm.makeSymbol("$trace", 2);
    static internal readonly IntegerTerm s4 = new IntegerTerm(1);

    public override Predicate exec() {
        Term a1, a2, a3, a4;
        Predicate p1, p2, p3;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        this.cont = engine.cont;

        a3 = engine.makeVariable();
        Term[] h3 = {a1, a2};
        a4 = new StructureTerm(f2, h3);
        p1 = new Predicates.dollar_illarg_3(s1, a4, s4, cont);
        p2 = new Predicates.dollar_cut_1(a3, p1);
        p3 = new Predicates.dollar_var_1(a1, p2);
        return new Predicates.dollar_getLevel_1(a3, p3);
    }
}

sealed class dollar_trace_2_2 : dollar_trace_2 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("true");

    public override Predicate exec() {
        Term a1, a2;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        this.cont = engine.cont;

        if ( !s1.unify(a1, engine.trail) ) return engine.fail();
        return new Predicates.dollar_neckCut_0(cont);
    }
}

sealed class dollar_trace_2_3 : dollar_trace_2 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("!");
    static internal readonly SymbolTerm f2 = SymbolTerm.makeSymbol("$trace_reduce", 1);
    static internal readonly SymbolTerm f4 = SymbolTerm.makeSymbol("!", 2);
    static internal readonly SymbolTerm s6 = SymbolTerm.makeSymbol("call");

    public override Predicate exec() {
        Term a1, a2, a3, a4, a5, a6, a7;
        Predicate p1, p2, p3, p4;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        this.cont = engine.cont;

        if ( !s1.unify(a1, engine.trail) ) return engine.fail();
        a3 = engine.makeVariable();
        a5 = engine.makeVariable();
        Term[] h3 = {a5};
        a4 = new StructureTerm(f2, h3);
        a6 = engine.makeVariable();
        Term[] h5 = {a5, a6};
        a7 = new StructureTerm(f4, h5);
        p1 = new Predicates.dollar_cut_1(a6, cont);
        p2 = new Predicates.dollar_tracingMessages_3(a2, a7, s6, p1);
        p3 = new Predicates.dollar_cut_1(a3, p2);
        p4 = new Predicates.dollar_ancestor_2(a4, a6, p3);
        return new Predicates.dollar_getLevel_1(a3, p4);
    }
}

sealed class dollar_trace_2_4 : dollar_trace_2 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("!");

    public override Predicate exec() {
        Term a1, a2;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        this.cont = engine.cont;

        if ( !s1.unify(a1, engine.trail) ) return engine.fail();
        return new Predicates.dollar_neckCut_0(cont);
    }
}

sealed class dollar_trace_2_5 : dollar_trace_2 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("not", 1);
    static internal readonly SymbolTerm f2 = SymbolTerm.makeSymbol("\\+", 1);

    public override Predicate exec() {
        Term a1, a2, a3, a4;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        this.cont = engine.cont;

        if ( a1.isStructure() ){
            if (f1 != ((StructureTerm)a1).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a1).args;
            a3 = args[0];
        } else if (a1.isVariable() ){
            a3 = engine.makeVariable();
            Term[] args = {a3};
            if ( !a1.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        Term[] h3 = {a3};
        a4 = new StructureTerm(f2, h3);
        p1 = new Predicates.dollar_trace_2(a4, a2, cont);
        return new Predicates.dollar_neckCut_0(p1);
    }
}

sealed class dollar_trace_2_6 : dollar_trace_2 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("\\+", 1);

    public override Predicate exec() {
        Term a1, a2, a3, a4;
        Predicate p1, p2, p3;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        this.cont = engine.cont;

        if ( a1.isStructure() ){
            if (f1 != ((StructureTerm)a1).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a1).args;
            a3 = args[0];
        } else if (a1.isVariable() ){
            a3 = engine.makeVariable();
            Term[] args = {a3};
            if ( !a1.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        a4 = engine.makeVariable();
        p1 = new Predicates.dollar_fail_0(cont);
        p2 = new Predicates.dollar_cut_1(a4, p1);
        p3 = new Predicates.dollar_trace_2(a3, a2, p2);
        return new Predicates.dollar_getLevel_1(a4, p3);
    }
}

sealed class dollar_trace_2_7 : dollar_trace_2 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("\\+", 1);

    public override Predicate exec() {
        Term a1, a2;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        this.cont = engine.cont;

        if ( a1.isStructure() ){
            if (f1 != ((StructureTerm)a1).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a1).args;
        } else if (a1.isVariable() ){
            Term[] args = {engine.makeVariable()};
            if ( !a1.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        return new Predicates.dollar_neckCut_0(cont);
    }
}

sealed class dollar_trace_2_8 : dollar_trace_2 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("->", 2);
    static internal readonly SymbolTerm f2 = SymbolTerm.makeSymbol(";", 2);
    static internal readonly SymbolTerm s4 = SymbolTerm.makeSymbol("fail");

    public override Predicate exec() {
        Term a1, a2, a3, a4, a5, a6;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        this.cont = engine.cont;

        if ( a1.isStructure() ){
            if (f1 != ((StructureTerm)a1).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a1).args;
            a3 = args[0];
            a4 = args[1];
        } else if (a1.isVariable() ){
            a3 = engine.makeVariable();
            a4 = engine.makeVariable();
            Term[] args = {a3, a4};
            if ( !a1.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        Term[] h3 = {a3, a4};
        a6 = new StructureTerm(f1, h3);
        Term[] h5 = {a6, s4};
        a5 = new StructureTerm(f2, h5);
        p1 = new Predicates.dollar_trace_2(a5, a2, cont);
        return new Predicates.dollar_neckCut_0(p1);
    }
}

sealed class dollar_trace_2_9 : dollar_trace_2 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol(";", 2);
    static internal readonly SymbolTerm f2 = SymbolTerm.makeSymbol("->", 2);

    public override Predicate exec() {
        Term a1, a2, a3, a4, a5, a6;
        Predicate p1, p2, p3;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        this.cont = engine.cont;

        if ( a1.isStructure() ){
            if (f1 != ((StructureTerm)a1).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a1).args;
            a3 = args[0];
        } else if (a1.isVariable() ){
            a3 = engine.makeVariable();
            Term[] args = {a3, engine.makeVariable()};
            if ( !a1.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a3.isStructure() ){
            if (f2 != ((StructureTerm)a3).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a3).args;
            a4 = args[0];
            a5 = args[1];
        } else if (a3.isVariable() ){
            a4 = engine.makeVariable();
            a5 = engine.makeVariable();
            Term[] args = {a4, a5};
            if ( !a3.unify(new StructureTerm(f2, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        a6 = engine.makeVariable();
        p1 = new Predicates.dollar_trace_2(a5, a2, cont);
        p2 = new Predicates.dollar_cut_1(a6, p1);
        p3 = new Predicates.dollar_trace_2(a4, a2, p2);
        return new Predicates.dollar_getLevel_1(a6, p3);
    }
}

sealed class dollar_trace_2_10 : dollar_trace_2 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol(";", 2);
    static internal readonly SymbolTerm f2 = SymbolTerm.makeSymbol("->", 2);

    public override Predicate exec() {
        Term a1, a2, a3, a4;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        this.cont = engine.cont;

        if ( a1.isStructure() ){
            if (f1 != ((StructureTerm)a1).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a1).args;
            a3 = args[0];
            a4 = args[1];
        } else if (a1.isVariable() ){
            a3 = engine.makeVariable();
            a4 = engine.makeVariable();
            Term[] args = {a3, a4};
            if ( !a1.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a3.isStructure() ){
            if (f2 != ((StructureTerm)a3).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a3).args;
        } else if (a3.isVariable() ){
            Term[] args = {engine.makeVariable(), engine.makeVariable()};
            if ( !a3.unify(new StructureTerm(f2, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        p1 = new Predicates.dollar_trace_2(a4, a2, cont);
        return new Predicates.dollar_neckCut_0(p1);
    }
}

sealed class dollar_trace_2_11 : dollar_trace_2 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("findall", 3);
    static internal readonly SymbolTerm f2 = SymbolTerm.makeSymbol("$trace", 2);

    public override Predicate exec() {
        Term a1, a2, a3, a4, a5, a6;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        this.cont = engine.cont;

        if ( a1.isStructure() ){
            if (f1 != ((StructureTerm)a1).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a1).args;
            a3 = args[0];
            a4 = args[1];
            a5 = args[2];
        } else if (a1.isVariable() ){
            a3 = engine.makeVariable();
            a4 = engine.makeVariable();
            a5 = engine.makeVariable();
            Term[] args = {a3, a4, a5};
            if ( !a1.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        Term[] h3 = {a4, a2};
        a6 = new StructureTerm(f2, h3);
        p1 = new Predicates.Findall_3(a3, a6, a5, cont);
        return new Predicates.dollar_neckCut_0(p1);
    }
}

sealed class dollar_trace_2_12 : dollar_trace_2 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol(",", 2);

    public override Predicate exec() {
        Term a1, a2, a3, a4;
        Predicate p1, p2;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        this.cont = engine.cont;

        if ( a1.isStructure() ){
            if (f1 != ((StructureTerm)a1).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a1).args;
            a3 = args[0];
            a4 = args[1];
        } else if (a1.isVariable() ){
            a3 = engine.makeVariable();
            a4 = engine.makeVariable();
            Term[] args = {a3, a4};
            if ( !a1.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        p1 = new Predicates.dollar_trace_2(a4, a2, cont);
        p2 = new Predicates.dollar_trace_2(a3, a2, p1);
        return new Predicates.dollar_neckCut_0(p2);
    }
}

sealed class dollar_trace_2_13 : dollar_trace_2 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol(";", 2);

    public override Predicate exec() {
        Term a1, a2, a3, a4;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        this.cont = engine.cont;

        if ( a1.isStructure() ){
            if (f1 != ((StructureTerm)a1).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a1).args;
            a3 = args[0];
            a4 = args[1];
        } else if (a1.isVariable() ){
            a3 = engine.makeVariable();
            a4 = engine.makeVariable();
            Term[] args = {a3, a4};
            if ( !a1.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        p1 = new Predicates.dollar_dummyInterpreter__9_3(a3, a4, a2, cont);
        return new Predicates.dollar_neckCut_0(p1);
    }
}

sealed class dollar_trace_2_14 : dollar_trace_2 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("call", 1);

    public override Predicate exec() {
        Term a1, a2, a3;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        this.cont = engine.cont;

        if ( a1.isStructure() ){
            if (f1 != ((StructureTerm)a1).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a1).args;
            a3 = args[0];
        } else if (a1.isVariable() ){
            a3 = engine.makeVariable();
            Term[] args = {a3};
            if ( !a1.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        p1 = new Predicates.dollar_trace_2(a3, a2, cont);
        return new Predicates.dollar_neckCut_0(p1);
    }
}

sealed class dollar_trace_2_15 : dollar_trace_2 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("call");
    static internal readonly SymbolTerm s2 = SymbolTerm.makeSymbol("exit");

    public override Predicate exec() {
        Term a1, a2;
        Predicate p1, p2, p3;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        this.cont = engine.cont;

        p1 = new Predicates.dollar_traceRedo_2(a1, a2, cont);
        p2 = new Predicates.dollar_tracingMessages_3(a2, a1, s2, p1);
        p3 = new Predicates.dollar_dummyInterpreter__10_2(a1, a2, p2);
        return new Predicates.dollar_tracingMessages_3(a2, a1, s1, p3);
    }
}

sealed class dollar_trace_2_16 : dollar_trace_2 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("fail");

    public override Predicate exec() {
        Term a1, a2;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        this.cont = engine.cont;

        p1 = new Predicates.dollar_fail_0(cont);
        return new Predicates.dollar_tracingMessages_3(a2, a1, s1, p1);
    }
}
}

