/*
 * *** Please do not edit ! ***
 * @(#) dollar_writeClause0_1.cs
 * @procedure $write_clause0/1 in interpreter.pl
 */

/*
 * @version Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_writeClause0_1 : Predicate {
    static internal readonly Predicate dollar_fail_0 = new Predicates.dollar_fail_0();
    static internal readonly Predicate dollar_writeClause0_1_1 = new Predicates.dollar_writeClause0_1_1();
    static internal readonly Predicate dollar_writeClause0_1_2 = new Predicates.dollar_writeClause0_1_2();
    static internal readonly Predicate dollar_writeClause0_1_var = new Predicates.dollar_writeClause0_1_var();

    public Term arg1;

    public dollar_writeClause0_1(Term a1, Predicate cont) {
        arg1 = a1; 
        this.cont = cont;
    }

    public dollar_writeClause0_1(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        this.cont = cont;
    }

    public override Predicate exec() {
        engine.aregs[1] = arg1;
        engine.cont = cont;
        return call();
    }

    public virtual Predicate call() {
        engine.setB0();
        return engine.switch_on_term(
                                   dollar_writeClause0_1_var,
                                   dollar_fail_0,
                                   dollar_fail_0,
                                   dollar_writeClause0_1_var,
                                   dollar_fail_0
                                   );
    }

    public override int arity() { return 1; }

    public override string ToString() {
        return "$write_clause0(" + arg1 + ")";
    }
}

sealed class dollar_writeClause0_1_var : dollar_writeClause0_1 {
    static internal readonly Predicate dollar_writeClause0_1_var_1 = new Predicates.dollar_writeClause0_1_var_1();

    public override Predicate exec() {
        return engine.jtry(dollar_writeClause0_1_1, dollar_writeClause0_1_var_1);
    }
}

sealed class dollar_writeClause0_1_var_1 : dollar_writeClause0_1 {

    public override Predicate exec() {
        return engine.trust(dollar_writeClause0_1_2);
    }
}

sealed class dollar_writeClause0_1_1 : dollar_writeClause0_1 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol(":-", 2);
    static internal readonly SymbolTerm s2 = SymbolTerm.makeSymbol("true");
    static internal readonly SymbolTerm s3 = SymbolTerm.makeSymbol(".");

    public override Predicate exec() {
        Term a1, a2, a3, a4;
        Predicate p1, p2, p3, p4, p5;
        a1 = engine.aregs[1].dereference();
        this.cont = engine.cont;

        if ( a1.isStructure() ){
            if (f1 != ((StructureTerm)a1).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a1).args;
            a2 = args[0];
            a3 = args[1];
        } else if (a1.isVariable() ){
            a2 = engine.makeVariable();
            a3 = engine.makeVariable();
            Term[] args = {a2, a3};
            if ( !a1.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        a4 = engine.makeVariable();
        p1 = new Predicates.dollar_nl_0(cont);
        p2 = new Predicates.Write_1(s3, p1);
        p3 = new Predicates.Writeq_1(a2, p2);
        p4 = new Predicates.dollar_cut_1(a4, p3);
        p5 = new Predicates.dollar_equalityOfTerm_2(a3, s2, p4);
        return new Predicates.dollar_getLevel_1(a4, p5);
    }
}

sealed class dollar_writeClause0_1_2 : dollar_writeClause0_1 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol(":-", 2);
    static internal readonly SymbolTerm s2 = SymbolTerm.makeSymbol(" :- ");

    public override Predicate exec() {
        Term a1, a2, a3;
        Predicate p1, p2, p3;
        a1 = engine.aregs[1].dereference();
        this.cont = engine.cont;

        if ( a1.isStructure() ){
            if (f1 != ((StructureTerm)a1).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a1).args;
            a2 = args[0];
            a3 = args[1];
        } else if (a1.isVariable() ){
            a2 = engine.makeVariable();
            a3 = engine.makeVariable();
            Term[] args = {a2, a3};
            if ( !a1.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        p1 = new Predicates.dollar_writeBody_1(a3, cont);
        p2 = new Predicates.dollar_nl_0(p1);
        p3 = new Predicates.Write_1(s2, p2);
        return new Predicates.Writeq_1(a2, p3);
    }
}
}

