/*
 * *** Please do not edit ! ***
 * @(#) Listing_0.cs
 * @procedure listing/0 in interpreter.pl
 */

/*
 * @version Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class Listing_0 : Predicate {
    static internal readonly Predicate Listing_0_1 = new Predicates.Listing_0_1();
    static internal readonly Predicate Listing_0_2 = new Predicates.Listing_0_2();
    static internal readonly Predicate Listing_0_sub_1 = new Predicates.Listing_0_sub_1();

    public Listing_0(Predicate cont) {
        this.cont = cont;
    }

    public Listing_0(){}
    public override void setArgument(Term[] args, Predicate cont) {
        this.cont = cont;
    }

    public override Predicate exec() {
        engine.cont = cont;
        return call();
    }

    public virtual Predicate call() {
        engine.setB0();
        return engine.jtry(Listing_0_1, Listing_0_sub_1);
    }

    public override int arity() { return 0; }

    public override string ToString() {
        return "listing";
    }
}

sealed class Listing_0_sub_1 : Listing_0 {

    public override Predicate exec() {
        return engine.trust(Listing_0_2);
    }
}

sealed class Listing_0_1 : Listing_0 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("$current_predicates", 2);
    static internal readonly IntegerTerm s3 = new IntegerTerm(36);
    static internal readonly SymbolTerm f4 = SymbolTerm.makeSymbol(":-", 2);
    static internal readonly SymbolTerm f6 = SymbolTerm.makeSymbol("clause", 2);

    public override Predicate exec() {
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9, a10;
        Predicate p1, p2, p3, p4, p5, p6, p7, p8;
        this.cont = engine.cont;

        a2 = engine.makeVariable();
        a3 = engine.makeVariable();
        Term[] h2 = {a2, a3};
        a1 = new StructureTerm(f1, h2);
        a5 = engine.makeVariable();
        a4 = new ListTerm(a5, engine.makeVariable());
        a6 = engine.makeVariable();
        a8 = engine.makeVariable();
        Term[] h5 = {a6, a8};
        a7 = new StructureTerm(f4, h5);
        Term[] h7 = {a6, a8};
        a9 = new StructureTerm(f6, h7);
        a10 = engine.makeVariable();
        p1 = new Predicates.dollar_fail_0(cont);
        p2 = new Predicates.dollar_nl_0(p1);
        p3 = new Predicates.dollar_writeClauses_1(a10, p2);
        p4 = new Predicates.Findall_3(a7, a9, a10, p3);
        p5 = new Predicates.dollar_functor_3(a6, a2, a3, p4);
        p6 = new Predicates.dollar_arithNotEqual_2(a5, s3, p5);
        p7 = new Predicates.Name_2(a2, a4, p6);
        p8 = new Predicates.Clause_2(a1, engine.makeVariable(), p7);
        return new Predicates.dollar_nl_0(p8);
    }
}

sealed class Listing_0_2 : Listing_0 {

    public override Predicate exec() {
        return engine.cont;
    }
}
}

