/*
 * *** Please do not edit ! ***
 * @(#) dollar_allocVoids1_4.cs
 * @procedure $alloc_voids1/4 in plcs.pl
 */

/*
 * @version Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_allocVoids1_4 : Predicate {
    static internal dollar_allocVoids1_4 entry_code;
    static internal readonly Predicate dollar_fail_0 = new Predicates.dollar_fail_0();
    static internal readonly Predicate dollar_allocVoids1_4_1 = new Predicates.dollar_allocVoids1_4_1();
    static internal readonly Predicate dollar_allocVoids1_4_2 = new Predicates.dollar_allocVoids1_4_2();
    static internal readonly Predicate dollar_allocVoids1_4_3 = new Predicates.dollar_allocVoids1_4_3();
    static internal readonly Predicate dollar_allocVoids1_4_4 = new Predicates.dollar_allocVoids1_4_4();
    static internal readonly Predicate dollar_allocVoids1_4_5 = new Predicates.dollar_allocVoids1_4_5();
    static internal readonly Predicate dollar_allocVoids1_4_lis = new Predicates.dollar_allocVoids1_4_lis();
    static internal readonly Predicate dollar_allocVoids1_4_var = new Predicates.dollar_allocVoids1_4_var();

    public Term arg1, arg2, arg3, arg4;

    public dollar_allocVoids1_4(Term a1, Term a2, Term a3, Term a4, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        arg4 = a4; 
        this.cont = cont;
    }

    public dollar_allocVoids1_4(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        arg4 = args[3]; 
        this.cont = cont;
    }

    public override Predicate exec() {
        entry_code = this;
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.aregs[3] = arg3;
        engine.aregs[4] = arg4;
        engine.cont = cont;
        return call();
    }

    public virtual Predicate call() {
        engine.setB0();
        return engine.switch_on_term(
                                   dollar_allocVoids1_4_var,
                                   dollar_fail_0,
                                   dollar_allocVoids1_4_1,
                                   dollar_fail_0,
                                   dollar_allocVoids1_4_lis
                                   );
    }

    public override int arity() { return 4; }

    public override string ToString() {
        return "$alloc_voids1(" + arg1 + ", " + arg2 + ", " + arg3 + ", " + arg4 + ")";
    }
}

sealed class dollar_allocVoids1_4_var : dollar_allocVoids1_4 {
    static internal readonly Predicate dollar_allocVoids1_4_var_1 = new Predicates.dollar_allocVoids1_4_var_1();

    public override Predicate exec() {
        return engine.jtry(dollar_allocVoids1_4_1, dollar_allocVoids1_4_var_1);
    }
}

sealed class dollar_allocVoids1_4_var_1 : dollar_allocVoids1_4 {
    static internal readonly Predicate dollar_allocVoids1_4_var_2 = new Predicates.dollar_allocVoids1_4_var_2();

    public override Predicate exec() {
        return engine.retry(dollar_allocVoids1_4_2, dollar_allocVoids1_4_var_2);
    }
}

sealed class dollar_allocVoids1_4_var_2 : dollar_allocVoids1_4 {
    static internal readonly Predicate dollar_allocVoids1_4_var_3 = new Predicates.dollar_allocVoids1_4_var_3();

    public override Predicate exec() {
        return engine.retry(dollar_allocVoids1_4_3, dollar_allocVoids1_4_var_3);
    }
}

sealed class dollar_allocVoids1_4_var_3 : dollar_allocVoids1_4 {
    static internal readonly Predicate dollar_allocVoids1_4_var_4 = new Predicates.dollar_allocVoids1_4_var_4();

    public override Predicate exec() {
        return engine.retry(dollar_allocVoids1_4_4, dollar_allocVoids1_4_var_4);
    }
}

sealed class dollar_allocVoids1_4_var_4 : dollar_allocVoids1_4 {

    public override Predicate exec() {
        return engine.trust(dollar_allocVoids1_4_5);
    }
}

sealed class dollar_allocVoids1_4_lis : dollar_allocVoids1_4 {
    static internal readonly Predicate dollar_allocVoids1_4_lis_1 = new Predicates.dollar_allocVoids1_4_lis_1();

    public override Predicate exec() {
        return engine.jtry(dollar_allocVoids1_4_2, dollar_allocVoids1_4_lis_1);
    }
}

sealed class dollar_allocVoids1_4_lis_1 : dollar_allocVoids1_4 {
    static internal readonly Predicate dollar_allocVoids1_4_lis_2 = new Predicates.dollar_allocVoids1_4_lis_2();

    public override Predicate exec() {
        return engine.retry(dollar_allocVoids1_4_3, dollar_allocVoids1_4_lis_2);
    }
}

sealed class dollar_allocVoids1_4_lis_2 : dollar_allocVoids1_4 {
    static internal readonly Predicate dollar_allocVoids1_4_lis_3 = new Predicates.dollar_allocVoids1_4_lis_3();

    public override Predicate exec() {
        return engine.retry(dollar_allocVoids1_4_4, dollar_allocVoids1_4_lis_3);
    }
}

sealed class dollar_allocVoids1_4_lis_3 : dollar_allocVoids1_4 {

    public override Predicate exec() {
        return engine.trust(dollar_allocVoids1_4_5);
    }
}

sealed class dollar_allocVoids1_4_1 : dollar_allocVoids1_4 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("[]");

    public override Predicate exec() {
        Term a1, a2, a3, a4;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        this.cont = engine.cont;

        if ( !s1.unify(a1, engine.trail) ) return engine.fail();
        if ( !a3.unify(a4, engine.trail) ) return engine.fail();
        return cont;
    }
}

sealed class dollar_allocVoids1_4_2 : dollar_allocVoids1_4 {
    static internal readonly IntegerTerm s1 = new IntegerTerm(1);
    static internal readonly SymbolTerm s2 = SymbolTerm.makeSymbol("void");
    static internal readonly SymbolTerm s3 = SymbolTerm.makeSymbol("[]");

    public override Predicate exec() {
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12;
        Predicate p1, p2, p3, p4;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        this.cont = engine.cont;

        if ( a1.isList() ){
            a5 = ((ListTerm)a1).car;
            a6 = ((ListTerm)a1).cdr;
        } else if ( a1.isVariable() ){
            a5 = engine.makeVariable();
            a6 = engine.makeVariable();
            if ( !a1.unify(new ListTerm(a5, a6), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        a7 = engine.makeVariable();
        a8 = engine.makeVariable();
        a12 = new ListTerm(engine.makeVariable(), s3);
        a11 = new ListTerm(s2, a12);
        a10 = new ListTerm(a5, a11);
        a9 = new ListTerm(a10, a3);
        p1 = new Predicates.dollar_allocVoids1_4(a6, a2, a8, a4, cont);
        p2 = new Predicates.dollar_unify_2(a8, a9, p1);
        p3 = new Predicates.dollar_cut_1(a7, p2);
        p4 = new Predicates.dollar_countVariable_3(a5, a2, s1, p3);
        return new Predicates.dollar_getLevel_1(a7, p4);
    }
}

sealed class dollar_allocVoids1_4_3 : dollar_allocVoids1_4 {

    public override Predicate exec() {
        Term a1, a2, a3, a4, a5;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        this.cont = engine.cont;

        if ( a1.isList() ){
            a5 = ((ListTerm)a1).cdr;
        } else if ( a1.isVariable() ){
            a5 = engine.makeVariable();
            if ( !a1.unify(new ListTerm(engine.makeVariable(), a5), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        engine.aregs[1] = a5;
        engine.aregs[2] = a2;
        engine.aregs[3] = a3;
        engine.aregs[4] = a4;
        engine.cont = cont;
        return entry_code.call();
    }
}

sealed class dollar_allocVoids1_4_4 : dollar_allocVoids1_4 {
    static internal readonly IntegerTerm s1 = new IntegerTerm(1);
    static internal readonly SymbolTerm s2 = SymbolTerm.makeSymbol("void");
    static internal readonly SymbolTerm s3 = SymbolTerm.makeSymbol("[]");

    public override Predicate exec() {
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12;
        Predicate p1, p2, p3, p4;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        this.cont = engine.cont;

        if ( a1.isList() ){
            a5 = ((ListTerm)a1).car;
            a6 = ((ListTerm)a1).cdr;
        } else if ( a1.isVariable() ){
            a5 = engine.makeVariable();
            a6 = engine.makeVariable();
            if ( !a1.unify(new ListTerm(a5, a6), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        a7 = engine.makeVariable();
        a8 = engine.makeVariable();
        a12 = new ListTerm(engine.makeVariable(), s3);
        a11 = new ListTerm(s2, a12);
        a10 = new ListTerm(a5, a11);
        a9 = new ListTerm(a10, a3);
        p1 = new Predicates.dollar_allocVoids1_4(a6, a2, a8, a4, cont);
        p2 = new Predicates.dollar_unify_2(a8, a9, p1);
        p3 = new Predicates.dollar_cut_1(a7, p2);
        p4 = new Predicates.dollar_countVariable_3(a5, a2, s1, p3);
        return new Predicates.dollar_getLevel_1(a7, p4);
    }
}

sealed class dollar_allocVoids1_4_5 : dollar_allocVoids1_4 {

    public override Predicate exec() {
        Term a1, a2, a3, a4, a5;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        this.cont = engine.cont;

        if ( a1.isList() ){
            a5 = ((ListTerm)a1).cdr;
        } else if ( a1.isVariable() ){
            a5 = engine.makeVariable();
            if ( !a1.unify(new ListTerm(engine.makeVariable(), a5), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        engine.aregs[1] = a5;
        engine.aregs[2] = a2;
        engine.aregs[3] = a3;
        engine.aregs[4] = a4;
        engine.cont = cont;
        return entry_code.call();
    }
}
}

