/*
 * *** Please do not edit ! ***
 * @(#) dollar_compileChunks_4.cs
 * @procedure $compile_chunks/4 in plcs.pl
 */

/*
 * @version Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_compileChunks_4 : Predicate {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("[]");

    public Term arg1, arg2, arg3, arg4;

    public dollar_compileChunks_4(Term a1, Term a2, Term a3, Term a4, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        arg4 = a4; 
        this.cont = cont;
    }

    public dollar_compileChunks_4(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        arg4 = args[3]; 
        this.cont = cont;
    }

    public override Predicate exec() {
        engine.setB0();
        Term a1, a2, a3, a4, a5;
        Predicate p1;
        a1 = arg1.dereference();
        a2 = arg2.dereference();
        a3 = arg3.dereference();
        a4 = arg4.dereference();

        a5 = engine.makeVariable();
        p1 = new Predicates.dollar_compileChunk_5(a1, a5, a2, a3, a4, cont);
        return new Predicates.dollar_allocVoids_3(a1, s1, a5, p1);
    }

    public override int arity() { return 4; }

    public override string ToString() {
        return "$compile_chunks(" + arg1 + ", " + arg2 + ", " + arg3 + ", " + arg4 + ")";
    }
}
}

