/*
 * *** Please do not edit ! ***
 * @(#) dollar_compileOnePred_4.cs
 * @procedure $compile_one_pred/4 in plcs.pl
 */

/*
 * @version Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_compileOnePred_4 : Predicate {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("[]");
    static internal readonly SymbolTerm f2 = SymbolTerm.makeSymbol("comment", 1);
    static internal readonly SymbolTerm f4 = SymbolTerm.makeSymbol(":", 2);
    static internal readonly SymbolTerm f5 = SymbolTerm.makeSymbol("+", 2);
    static internal readonly SymbolTerm s6 = SymbolTerm.makeSymbol("top");
    static internal readonly SymbolTerm f9 = SymbolTerm.makeSymbol("exec_method", 4);

    public Term arg1, arg2, arg3, arg4;

    public dollar_compileOnePred_4(Term a1, Term a2, Term a3, Term a4, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        arg4 = a4; 
        this.cont = cont;
    }

    public dollar_compileOnePred_4(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        arg4 = args[3]; 
        this.cont = cont;
    }

    public override Predicate exec() {
        engine.setB0();
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14, a15, a16, a17, a18, a19, a20, a21, a22, a23, a24, a25;
        Predicate p1, p2, p3, p4, p5, p6, p7, p8;
        a1 = arg1.dereference();
        a2 = arg2.dereference();
        a3 = arg3.dereference();
        a4 = arg4.dereference();

        if ( a1.isList() ){
            a5 = ((ListTerm)a1).car;
            if ( !s1.unify(((ListTerm)a1).cdr, engine.trail) )
                return engine.fail();
        } else if ( a1.isVariable() ){
            a5 = engine.makeVariable();
            if ( !a1.unify(new ListTerm(a5, s1), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        a6 = engine.makeVariable();
        Term[] h3 = {a6};
        a7 = new StructureTerm(f2, h3);
        a8 = engine.makeVariable();
        Term[] h7 = {a2, s6};
        a10 = new StructureTerm(f5, h7);
        Term[] h8 = {a10, s1};
        a9 = new StructureTerm(f4, h8);
        a11 = engine.makeVariable();
        a12 = engine.makeVariable();
        a13 = engine.makeVariable();
        a14 = engine.makeVariable();
        a15 = engine.makeVariable();
        a18 = engine.makeVariable();
        a20 = engine.makeVariable();
        a19 = new ListTerm(a20, s1);
        a17 = new ListTerm(a18, a19);
        a21 = engine.makeVariable();
        Term[] h10 = {a2, a17, s6, a21};
        a16 = new StructureTerm(f9, h10);
        a22 = engine.makeVariable();
        a25 = new ListTerm(a20, s1);
        a24 = new ListTerm(engine.makeVariable(), a25);
        a23 = new ListTerm(a18, a24);
        p1 = new Predicates.dollar_unify_2(a22, a23, cont);
        p2 = new Predicates.dollar_gatherStaticResPred_2(a21, a12, p1);
        p3 = new Predicates.dollar_compileClause_5(a5, a14, a22, a21, s1, p2);
        p4 = new Predicates._C_3(a15, a16, a4, p3);
        p5 = new Predicates._C_3(a13, a14, a15, p4);
        p6 = new Predicates._C_3(a11, a12, a13, p5);
        p7 = new Predicates._C_3(a8, a9, a11, p6);
        p8 = new Predicates._C_3(a3, a7, a8, p7);
        return new Predicates.dollar_copyTerm_2(a5, a6, p8);
    }

    public override int arity() { return 4; }

    public override string ToString() {
        return "$compile_one_pred(" + arg1 + ", " + arg2 + ", " + arg3 + ", " + arg4 + ")";
    }
}
}

