/*
 * *** Please do not edit ! ***
 * @(#) dollar_compileResClause_6.cs
 * @procedure $compile_res_clause/6 in plcs.pl
 */

/*
 * @version Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_compileResClause_6 : Predicate {
    static internal readonly Predicate dollar_compileResClause_6_1 = new Predicates.dollar_compileResClause_6_1();
    static internal readonly Predicate dollar_compileResClause_6_2 = new Predicates.dollar_compileResClause_6_2();
    static internal readonly Predicate dollar_compileResClause_6_var = new Predicates.dollar_compileResClause_6_var();

    public Term arg1, arg2, arg3, arg4, arg5, arg6;

    public dollar_compileResClause_6(Term a1, Term a2, Term a3, Term a4, Term a5, Term a6, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        arg4 = a4; 
        arg5 = a5; 
        arg6 = a6; 
        this.cont = cont;
    }

    public dollar_compileResClause_6(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        arg4 = args[3]; 
        arg5 = args[4]; 
        arg6 = args[5]; 
        this.cont = cont;
    }

    public override Predicate exec() {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.aregs[3] = arg3;
        engine.aregs[4] = arg4;
        engine.aregs[5] = arg5;
        engine.aregs[6] = arg6;
        engine.cont = cont;
        return call();
    }

    public virtual Predicate call() {
        engine.setB0();
        return engine.switch_on_term(
                                   dollar_compileResClause_6_var,
                                   dollar_compileResClause_6_2,
                                   dollar_compileResClause_6_2,
                                   dollar_compileResClause_6_var,
                                   dollar_compileResClause_6_2
                                   );
    }

    public override int arity() { return 6; }

    public override string ToString() {
        return "$compile_res_clause(" + arg1 + ", " + arg2 + ", " + arg3 + ", " + arg4 + ", " + arg5 + ", " + arg6 + ")";
    }
}

sealed class dollar_compileResClause_6_var : dollar_compileResClause_6 {
    static internal readonly Predicate dollar_compileResClause_6_var_1 = new Predicates.dollar_compileResClause_6_var_1();

    public override Predicate exec() {
        return engine.jtry(dollar_compileResClause_6_1, dollar_compileResClause_6_var_1);
    }
}

sealed class dollar_compileResClause_6_var_1 : dollar_compileResClause_6 {

    public override Predicate exec() {
        return engine.trust(dollar_compileResClause_6_2);
    }
}

sealed class dollar_compileResClause_6_1 : dollar_compileResClause_6 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol(":-", 2);
    static internal readonly SymbolTerm s4 = SymbolTerm.makeSymbol("[]");

    public override Predicate exec() {
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14, a15;
        Predicate p1, p2, p3, p4, p5;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        a5 = engine.aregs[5].dereference();
        a6 = engine.aregs[6].dereference();
        this.cont = engine.cont;

        if ( a1.isStructure() ){
            if (f1 != ((StructureTerm)a1).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a1).args;
            a7 = args[0];
            a8 = args[1];
        } else if (a1.isVariable() ){
            a7 = engine.makeVariable();
            a8 = engine.makeVariable();
            Term[] args = {a7, a8};
            if ( !a1.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        a9 = engine.makeVariable();
        Term[] h2 = {a7, a8};
        a10 = new StructureTerm(f1, h2);
        a12 = engine.makeVariable();
        a13 = engine.makeVariable();
        Term[] h3 = {a12, a13};
        a11 = new StructureTerm(f1, h3);
        a14 = engine.makeVariable();
        a15 = engine.makeVariable();
        p1 = new Predicates.dollar_cut_1(a9, cont);
        p2 = new Predicates.dollar_compileGround_4(a15, a4, a3, s4, p1);
        p3 = new Predicates.dollar_compileChunks_4(a14, a15, a5, a6, p2);
        p4 = new Predicates.dollar_precompileR_4(a12, a13, a2, a14, p3);
        p5 = new Predicates.dollar_transform_2(a10, a11, p4);
        return new Predicates.dollar_getLevel_1(a9, p5);
    }
}

sealed class dollar_compileResClause_6_2 : dollar_compileResClause_6 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("compilation");
    static internal readonly SymbolTerm s2 = SymbolTerm.makeSymbol("of");
    static internal readonly SymbolTerm s3 = SymbolTerm.makeSymbol("resource");
    static internal readonly SymbolTerm s4 = SymbolTerm.makeSymbol("failed");
    static internal readonly SymbolTerm s5 = SymbolTerm.makeSymbol("[]");
    static internal readonly ListTerm s6 = new ListTerm(s4, s5);

    public override Predicate exec() {
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9, a10;
        Predicate p1, p2;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        a5 = engine.aregs[5].dereference();
        a6 = engine.aregs[6].dereference();
        this.cont = engine.cont;

        a10 = new ListTerm(a1, s6);
        a9 = new ListTerm(s3, a10);
        a8 = new ListTerm(s2, a9);
        a7 = new ListTerm(s1, a8);
        p1 = new Predicates.dollar_unify_2(a6, a5, cont);
        p2 = new Predicates.dollar_fail_0(p1);
        return new Predicates.dollar_message_1(a7, p2);
    }
}
}

