/*
 * *** Please do not edit ! ***
 * @(#) dollar_createPredName_2.cs
 * @procedure $create_pred_name/2 in plcs.pl
 */

/*
 * @version Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_createPredName_2 : Predicate {
    static internal readonly Predicate dollar_createPredName_2_1 = new Predicates.dollar_createPredName_2_1();
    static internal readonly Predicate dollar_createPredName_2_2 = new Predicates.dollar_createPredName_2_2();
    static internal readonly Predicate dollar_createPredName_2_3 = new Predicates.dollar_createPredName_2_3();
    static internal readonly Predicate dollar_createPredName_2_4 = new Predicates.dollar_createPredName_2_4();
    static internal readonly Predicate dollar_createPredName_2_5 = new Predicates.dollar_createPredName_2_5();
    static internal readonly Predicate dollar_createPredName_2_sub_1 = new Predicates.dollar_createPredName_2_sub_1();

    public Term arg1, arg2;

    public dollar_createPredName_2(Term a1, Term a2, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        this.cont = cont;
    }

    public dollar_createPredName_2(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        this.cont = cont;
    }

    public override Predicate exec() {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.cont = cont;
        return call();
    }

    public virtual Predicate call() {
        engine.setB0();
        return engine.jtry(dollar_createPredName_2_1, dollar_createPredName_2_sub_1);
    }

    public override int arity() { return 2; }

    public override string ToString() {
        return "$create_pred_name(" + arg1 + ", " + arg2 + ")";
    }
}

sealed class dollar_createPredName_2_sub_1 : dollar_createPredName_2 {
    static internal readonly Predicate dollar_createPredName_2_sub_2 = new Predicates.dollar_createPredName_2_sub_2();

    public override Predicate exec() {
        return engine.retry(dollar_createPredName_2_2, dollar_createPredName_2_sub_2);
    }
}

sealed class dollar_createPredName_2_sub_2 : dollar_createPredName_2 {
    static internal readonly Predicate dollar_createPredName_2_sub_3 = new Predicates.dollar_createPredName_2_sub_3();

    public override Predicate exec() {
        return engine.retry(dollar_createPredName_2_3, dollar_createPredName_2_sub_3);
    }
}

sealed class dollar_createPredName_2_sub_3 : dollar_createPredName_2 {
    static internal readonly Predicate dollar_createPredName_2_sub_4 = new Predicates.dollar_createPredName_2_sub_4();

    public override Predicate exec() {
        return engine.retry(dollar_createPredName_2_4, dollar_createPredName_2_sub_4);
    }
}

sealed class dollar_createPredName_2_sub_4 : dollar_createPredName_2 {

    public override Predicate exec() {
        return engine.trust(dollar_createPredName_2_5);
    }
}

sealed class dollar_createPredName_2_1 : dollar_createPredName_2 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("_");
    static internal readonly IntegerTerm s2 = new IntegerTerm(0);
    static internal readonly SymbolTerm s3 = SymbolTerm.makeSymbol("[]");
    static internal readonly ListTerm s4 = new ListTerm(s2, s3);
    static internal readonly ListTerm s5 = new ListTerm(s1, s4);

    public override Predicate exec() {
        Term a1, a2, a3, a4, a5;
        Predicate p1, p2, p3, p4;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        this.cont = engine.cont;

        a3 = engine.makeVariable();
        a4 = engine.makeVariable();
        a5 = new ListTerm(a4, s5);
        p1 = new Predicates.dollar_listToString_2(a5, a2, cont);
        p2 = new Predicates.dollar_changeName_2(a1, a4, p1);
        p3 = new Predicates.dollar_cut_1(a3, p2);
        p4 = new Predicates.dollar_atom_1(a1, p3);
        return new Predicates.dollar_getLevel_1(a3, p4);
    }
}

sealed class dollar_createPredName_2_2 : dollar_createPredName_2 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("$res", 2);
    static internal readonly SymbolTerm f2 = SymbolTerm.makeSymbol("/", 2);
    static internal readonly SymbolTerm s5 = SymbolTerm.makeSymbol("_");
    static internal readonly SymbolTerm s6 = SymbolTerm.makeSymbol("_res");
    static internal readonly SymbolTerm s7 = SymbolTerm.makeSymbol("[]");

    public override Predicate exec() {
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14;
        Predicate p1, p2, p3, p4;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        this.cont = engine.cont;

        a3 = engine.makeVariable();
        a6 = engine.makeVariable();
        a7 = engine.makeVariable();
        Term[] h3 = {a6, a7};
        a5 = new StructureTerm(f2, h3);
        a8 = engine.makeVariable();
        Term[] h4 = {a5, a8};
        a4 = new StructureTerm(f1, h4);
        a9 = engine.makeVariable();
        a14 = new ListTerm(a8, s7);
        a13 = new ListTerm(s6, a14);
        a12 = new ListTerm(a7, a13);
        a11 = new ListTerm(s5, a12);
        a10 = new ListTerm(a9, a11);
        p1 = new Predicates.dollar_listToString_2(a10, a2, cont);
        p2 = new Predicates.dollar_changeName_2(a6, a9, p1);
        p3 = new Predicates.dollar_cut_1(a3, p2);
        p4 = new Predicates.dollar_unify_2(a1, a4, p3);
        return new Predicates.dollar_getLevel_1(a3, p4);
    }
}

sealed class dollar_createPredName_2_3 : dollar_createPredName_2 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("/", 2);
    static internal readonly SymbolTerm s3 = SymbolTerm.makeSymbol("_");
    static internal readonly SymbolTerm s4 = SymbolTerm.makeSymbol("[]");

    public override Predicate exec() {
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9, a10;
        Predicate p1, p2, p3, p4;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        this.cont = engine.cont;

        a3 = engine.makeVariable();
        a5 = engine.makeVariable();
        a6 = engine.makeVariable();
        Term[] h2 = {a5, a6};
        a4 = new StructureTerm(f1, h2);
        a7 = engine.makeVariable();
        a10 = new ListTerm(a6, s4);
        a9 = new ListTerm(s3, a10);
        a8 = new ListTerm(a7, a9);
        p1 = new Predicates.dollar_listToString_2(a8, a2, cont);
        p2 = new Predicates.dollar_changeName_2(a5, a7, p1);
        p3 = new Predicates.dollar_cut_1(a3, p2);
        p4 = new Predicates.dollar_unify_2(a1, a4, p3);
        return new Predicates.dollar_getLevel_1(a3, p4);
    }
}

sealed class dollar_createPredName_2_4 : dollar_createPredName_2 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("+", 2);
    static internal readonly SymbolTerm f2 = SymbolTerm.makeSymbol("/", 2);
    static internal readonly SymbolTerm s6 = SymbolTerm.makeSymbol("_");
    static internal readonly SymbolTerm s7 = SymbolTerm.makeSymbol("[]");

    public override Predicate exec() {
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14, a15, a16, a17, a18;
        Predicate p1, p2, p3, p4;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        this.cont = engine.cont;

        a3 = engine.makeVariable();
        a6 = engine.makeVariable();
        a7 = engine.makeVariable();
        Term[] h3 = {a6, a7};
        a5 = new StructureTerm(f2, h3);
        a9 = engine.makeVariable();
        a10 = engine.makeVariable();
        Term[] h4 = {a9, a10};
        a8 = new StructureTerm(f2, h4);
        Term[] h5 = {a5, a8};
        a4 = new StructureTerm(f1, h5);
        a11 = engine.makeVariable();
        a18 = new ListTerm(a10, s7);
        a17 = new ListTerm(s6, a18);
        a16 = new ListTerm(a9, a17);
        a15 = new ListTerm(s6, a16);
        a14 = new ListTerm(a7, a15);
        a13 = new ListTerm(s6, a14);
        a12 = new ListTerm(a11, a13);
        p1 = new Predicates.dollar_listToString_2(a12, a2, cont);
        p2 = new Predicates.dollar_changeName_2(a6, a11, p1);
        p3 = new Predicates.dollar_cut_1(a3, p2);
        p4 = new Predicates.dollar_unify_2(a1, a4, p3);
        return new Predicates.dollar_getLevel_1(a3, p4);
    }
}

sealed class dollar_createPredName_2_5 : dollar_createPredName_2 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("+", 2);
    static internal readonly SymbolTerm f2 = SymbolTerm.makeSymbol("/", 2);
    static internal readonly SymbolTerm s5 = SymbolTerm.makeSymbol("_");
    static internal readonly SymbolTerm s6 = SymbolTerm.makeSymbol("[]");

    public override Predicate exec() {
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13;
        Predicate p1, p2;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        this.cont = engine.cont;

        a5 = engine.makeVariable();
        a6 = engine.makeVariable();
        Term[] h3 = {a5, a6};
        a4 = new StructureTerm(f2, h3);
        a7 = engine.makeVariable();
        Term[] h4 = {a4, a7};
        a3 = new StructureTerm(f1, h4);
        a8 = engine.makeVariable();
        a13 = new ListTerm(a7, s6);
        a12 = new ListTerm(s5, a13);
        a11 = new ListTerm(a6, a12);
        a10 = new ListTerm(s5, a11);
        a9 = new ListTerm(a8, a10);
        p1 = new Predicates.dollar_listToString_2(a9, a2, cont);
        p2 = new Predicates.dollar_changeName_2(a5, a8, p1);
        return new Predicates.dollar_unify_2(a1, a3, p2);
    }
}
}

