/*
 * *** Please do not edit ! ***
 * @(#) dollar_firstCallOpt_3.cs
 * @procedure $first_call_opt/3 in plcs.pl
 */

/*
 * @version Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_firstCallOpt_3 : Predicate {
    static internal readonly Predicate dollar_firstCallOpt_3_1 = new Predicates.dollar_firstCallOpt_3_1();
    static internal readonly Predicate dollar_firstCallOpt_3_2 = new Predicates.dollar_firstCallOpt_3_2();
    static internal readonly Predicate dollar_firstCallOpt_3_3 = new Predicates.dollar_firstCallOpt_3_3();
    static internal readonly Predicate dollar_firstCallOpt_3_int = new Predicates.dollar_firstCallOpt_3_int();
    static internal readonly Predicate dollar_firstCallOpt_3_lis = new Predicates.dollar_firstCallOpt_3_lis();
    static internal readonly Predicate dollar_firstCallOpt_3_str = new Predicates.dollar_firstCallOpt_3_str();
    static internal readonly Predicate dollar_firstCallOpt_3_var = new Predicates.dollar_firstCallOpt_3_var();

    public Term arg1, arg2, arg3;

    public dollar_firstCallOpt_3(Term a1, Term a2, Term a3, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        this.cont = cont;
    }

    public dollar_firstCallOpt_3(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        this.cont = cont;
    }

    public override Predicate exec() {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.aregs[3] = arg3;
        engine.cont = cont;
        return call();
    }

    public virtual Predicate call() {
        engine.setB0();
        return engine.switch_on_term(
                                   dollar_firstCallOpt_3_var,
                                   dollar_firstCallOpt_3_int,
                                   dollar_firstCallOpt_3_var,
                                   dollar_firstCallOpt_3_str,
                                   dollar_firstCallOpt_3_lis
                                   );
    }

    public override int arity() { return 3; }

    public override string ToString() {
        return "$first_call_opt(" + arg1 + ", " + arg2 + ", " + arg3 + ")";
    }
}

sealed class dollar_firstCallOpt_3_var : dollar_firstCallOpt_3 {
    static internal readonly Predicate dollar_firstCallOpt_3_var_1 = new Predicates.dollar_firstCallOpt_3_var_1();

    public override Predicate exec() {
        return engine.jtry(dollar_firstCallOpt_3_1, dollar_firstCallOpt_3_var_1);
    }
}

sealed class dollar_firstCallOpt_3_var_1 : dollar_firstCallOpt_3 {
    static internal readonly Predicate dollar_firstCallOpt_3_var_2 = new Predicates.dollar_firstCallOpt_3_var_2();

    public override Predicate exec() {
        return engine.retry(dollar_firstCallOpt_3_2, dollar_firstCallOpt_3_var_2);
    }
}

sealed class dollar_firstCallOpt_3_var_2 : dollar_firstCallOpt_3 {

    public override Predicate exec() {
        return engine.trust(dollar_firstCallOpt_3_3);
    }
}

sealed class dollar_firstCallOpt_3_int : dollar_firstCallOpt_3 {
    static internal readonly Predicate dollar_firstCallOpt_3_int_1 = new Predicates.dollar_firstCallOpt_3_int_1();

    public override Predicate exec() {
        return engine.jtry(dollar_firstCallOpt_3_2, dollar_firstCallOpt_3_int_1);
    }
}

sealed class dollar_firstCallOpt_3_int_1 : dollar_firstCallOpt_3 {

    public override Predicate exec() {
        return engine.trust(dollar_firstCallOpt_3_3);
    }
}

sealed class dollar_firstCallOpt_3_str : dollar_firstCallOpt_3 {
    static internal readonly Predicate dollar_firstCallOpt_3_str_1 = new Predicates.dollar_firstCallOpt_3_str_1();

    public override Predicate exec() {
        return engine.jtry(dollar_firstCallOpt_3_2, dollar_firstCallOpt_3_str_1);
    }
}

sealed class dollar_firstCallOpt_3_str_1 : dollar_firstCallOpt_3 {

    public override Predicate exec() {
        return engine.trust(dollar_firstCallOpt_3_3);
    }
}

sealed class dollar_firstCallOpt_3_lis : dollar_firstCallOpt_3 {
    static internal readonly Predicate dollar_firstCallOpt_3_lis_1 = new Predicates.dollar_firstCallOpt_3_lis_1();

    public override Predicate exec() {
        return engine.jtry(dollar_firstCallOpt_3_2, dollar_firstCallOpt_3_lis_1);
    }
}

sealed class dollar_firstCallOpt_3_lis_1 : dollar_firstCallOpt_3 {

    public override Predicate exec() {
        return engine.trust(dollar_firstCallOpt_3_3);
    }
}

sealed class dollar_firstCallOpt_3_1 : dollar_firstCallOpt_3 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("true");

    public override Predicate exec() {
        Term a1, a2, a3;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        this.cont = engine.cont;

        if ( !s1.unify(a1, engine.trail) ) return engine.fail();
        if ( !a2.unify(a3, engine.trail) ) return engine.fail();
        return new Predicates.dollar_neckCut_0(cont);
    }
}

sealed class dollar_firstCallOpt_3_2 : dollar_firstCallOpt_3 {
    static internal readonly IntegerTerm s1 = new IntegerTerm(1);
    static internal readonly SymbolTerm f2 = SymbolTerm.makeSymbol("$fco_predicates", 2);
    static internal readonly SymbolTerm s4 = SymbolTerm.makeSymbol("$FCO");

    public override Predicate exec() {
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14, a15;
        Predicate p1, p2, p3, p4, p5, p6, p7, p8, p9, p10;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        this.cont = engine.cont;

        a4 = engine.makeVariable();
        a6 = engine.makeVariable();
        a7 = engine.makeVariable();
        a5 = new ListTerm(a6, a7);
        a9 = engine.makeVariable();
        a10 = engine.makeVariable();
        a8 = new ListTerm(a9, a10);
        a11 = engine.makeVariable();
        a12 = engine.makeVariable();
        a13 = engine.makeVariable();
        Term[] h3 = {a6, a11};
        a14 = new StructureTerm(f2, h3);
        a15 = new ListTerm(s4, a10);
        p1 = new Predicates.eq_stop_stop_2(a3, a15, cont);
        p2 = new Predicates.Assert_1(a14, p1);
        p3 = new Predicates.dollar_cut_1(a4, p2);
        p4 = new Predicates.dollar_arithEqual_2(a11, a13, p3);
        p5 = new Predicates.dollar_minus_3(a12, s1, a13, p4);
        p6 = new Predicates.dollar_equalityOfTerm_2(a6, a9, p5);
        p7 = new Predicates.Length_2(a10, a12, p6);
        p8 = new Predicates.Length_2(a7, a11, p7);
        p9 = new Predicates.eq_stop_stop_2(a2, a8, p8);
        p10 = new Predicates.eq_stop_stop_2(a1, a5, p9);
        return new Predicates.dollar_getLevel_1(a4, p10);
    }
}

sealed class dollar_firstCallOpt_3_3 : dollar_firstCallOpt_3 {

    public override Predicate exec() {
        Term a1, a2, a3;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        this.cont = engine.cont;

        if ( !a2.unify(a3, engine.trail) ) return engine.fail();
        return cont;
    }
}
}

