/*
 * *** Please do not edit ! ***
 * @(#) dollar_forallVars_3.cs
 * @procedure $forall_vars/3 in plcs.pl
 */

/*
 * @version Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_forallVars_3 : Predicate {
    static internal readonly Predicate dollar_forallVars_3_1 = new Predicates.dollar_forallVars_3_1();
    static internal readonly Predicate dollar_forallVars_3_2 = new Predicates.dollar_forallVars_3_2();
    static internal readonly Predicate dollar_forallVars_3_3 = new Predicates.dollar_forallVars_3_3();
    static internal readonly Predicate dollar_forallVars_3_sub_1 = new Predicates.dollar_forallVars_3_sub_1();

    public Term arg1, arg2, arg3;

    public dollar_forallVars_3(Term a1, Term a2, Term a3, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        this.cont = cont;
    }

    public dollar_forallVars_3(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        this.cont = cont;
    }

    public override Predicate exec() {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.aregs[3] = arg3;
        engine.cont = cont;
        return call();
    }

    public virtual Predicate call() {
        engine.setB0();
        return engine.jtry(dollar_forallVars_3_1, dollar_forallVars_3_sub_1);
    }

    public override int arity() { return 3; }

    public override string ToString() {
        return "$forall_vars(" + arg1 + ", " + arg2 + ", " + arg3 + ")";
    }
}

sealed class dollar_forallVars_3_sub_1 : dollar_forallVars_3 {
    static internal readonly Predicate dollar_forallVars_3_sub_2 = new Predicates.dollar_forallVars_3_sub_2();

    public override Predicate exec() {
        return engine.retry(dollar_forallVars_3_2, dollar_forallVars_3_sub_2);
    }
}

sealed class dollar_forallVars_3_sub_2 : dollar_forallVars_3 {

    public override Predicate exec() {
        return engine.trust(dollar_forallVars_3_3);
    }
}

sealed class dollar_forallVars_3_1 : dollar_forallVars_3 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol(",", 2);

    public override Predicate exec() {
        Term a1, a2, a3, a4, a5, a6, a7, a8;
        Predicate p1, p2, p3, p4, p5, p6;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        this.cont = engine.cont;

        a4 = engine.makeVariable();
        a6 = engine.makeVariable();
        a7 = engine.makeVariable();
        Term[] h2 = {a6, a7};
        a5 = new StructureTerm(f1, h2);
        a8 = engine.makeVariable();
        p1 = new Predicates.dollar_forallVars_3(a7, a8, a3, cont);
        p2 = new Predicates._C_3(a2, a6, a8, p1);
        p3 = new Predicates.dollar_var_1(a6, p2);
        p4 = new Predicates.dollar_cut_1(a4, p3);
        p5 = new Predicates.dollar_unify_2(a1, a5, p4);
        p6 = new Predicates.dollar_nonvar_1(a1, p5);
        return new Predicates.dollar_getLevel_1(a4, p6);
    }
}

sealed class dollar_forallVars_3_2 : dollar_forallVars_3 {

    public override Predicate exec() {
        Term a1, a2, a3, a4;
        Predicate p1, p2, p3;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        this.cont = engine.cont;

        a4 = engine.makeVariable();
        p1 = new Predicates.dollar_cut_1(a4, cont);
        p2 = new Predicates._C_3(a2, a1, a3, p1);
        p3 = new Predicates.dollar_var_1(a1, p2);
        return new Predicates.dollar_getLevel_1(a4, p3);
    }
}

sealed class dollar_forallVars_3_3 : dollar_forallVars_3 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("free");
    static internal readonly SymbolTerm s2 = SymbolTerm.makeSymbol("variable");
    static internal readonly SymbolTerm s3 = SymbolTerm.makeSymbol("is");
    static internal readonly SymbolTerm s4 = SymbolTerm.makeSymbol("invalid");
    static internal readonly SymbolTerm s5 = SymbolTerm.makeSymbol("[]");
    static internal readonly ListTerm s6 = new ListTerm(s4, s5);
    static internal readonly ListTerm s7 = new ListTerm(s3, s6);

    public override Predicate exec() {
        Term a1, a2, a3, a4, a5, a6;
        Predicate p1, p2, p3;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        this.cont = engine.cont;

        a6 = new ListTerm(a1, s7);
        a5 = new ListTerm(s2, a6);
        a4 = new ListTerm(s1, a5);
        p1 = new Predicates.dollar_unify_2(a3, a2, cont);
        p2 = new Predicates.dollar_fail_0(p1);
        p3 = new Predicates.dollar_message_1(a4, p2);
        return new Predicates.dollar_neckCut_0(p3);
    }
}
}

