/*
 * *** Please do not edit ! ***
 * @(#) dollar_gatherStaticResPred_2.cs
 * @procedure $gather_static_res_pred/2 in plcs.pl
 */

/*
 * @version Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_gatherStaticResPred_2 : Predicate {
    static internal dollar_gatherStaticResPred_2 entry_code;
    static internal readonly Predicate dollar_fail_0 = new Predicates.dollar_fail_0();
    static internal readonly Predicate dollar_gatherStaticResPred_2_1 = new Predicates.dollar_gatherStaticResPred_2_1();
    static internal readonly Predicate dollar_gatherStaticResPred_2_2 = new Predicates.dollar_gatherStaticResPred_2_2();
    static internal readonly Predicate dollar_gatherStaticResPred_2_3 = new Predicates.dollar_gatherStaticResPred_2_3();
    static internal readonly Predicate dollar_gatherStaticResPred_2_lis = new Predicates.dollar_gatherStaticResPred_2_lis();
    static internal readonly Predicate dollar_gatherStaticResPred_2_var = new Predicates.dollar_gatherStaticResPred_2_var();

    public Term arg1, arg2;

    public dollar_gatherStaticResPred_2(Term a1, Term a2, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        this.cont = cont;
    }

    public dollar_gatherStaticResPred_2(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        this.cont = cont;
    }

    public override Predicate exec() {
        entry_code = this;
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.cont = cont;
        return call();
    }

    public virtual Predicate call() {
        engine.setB0();
        return engine.switch_on_term(
                                   dollar_gatherStaticResPred_2_var,
                                   dollar_fail_0,
                                   dollar_gatherStaticResPred_2_1,
                                   dollar_fail_0,
                                   dollar_gatherStaticResPred_2_lis
                                   );
    }

    public override int arity() { return 2; }

    public override string ToString() {
        return "$gather_static_res_pred(" + arg1 + ", " + arg2 + ")";
    }
}

sealed class dollar_gatherStaticResPred_2_var : dollar_gatherStaticResPred_2 {
    static internal readonly Predicate dollar_gatherStaticResPred_2_var_1 = new Predicates.dollar_gatherStaticResPred_2_var_1();

    public override Predicate exec() {
        return engine.jtry(dollar_gatherStaticResPred_2_1, dollar_gatherStaticResPred_2_var_1);
    }
}

sealed class dollar_gatherStaticResPred_2_var_1 : dollar_gatherStaticResPred_2 {
    static internal readonly Predicate dollar_gatherStaticResPred_2_var_2 = new Predicates.dollar_gatherStaticResPred_2_var_2();

    public override Predicate exec() {
        return engine.retry(dollar_gatherStaticResPred_2_2, dollar_gatherStaticResPred_2_var_2);
    }
}

sealed class dollar_gatherStaticResPred_2_var_2 : dollar_gatherStaticResPred_2 {

    public override Predicate exec() {
        return engine.trust(dollar_gatherStaticResPred_2_3);
    }
}

sealed class dollar_gatherStaticResPred_2_lis : dollar_gatherStaticResPred_2 {
    static internal readonly Predicate dollar_gatherStaticResPred_2_lis_1 = new Predicates.dollar_gatherStaticResPred_2_lis_1();

    public override Predicate exec() {
        return engine.jtry(dollar_gatherStaticResPred_2_2, dollar_gatherStaticResPred_2_lis_1);
    }
}

sealed class dollar_gatherStaticResPred_2_lis_1 : dollar_gatherStaticResPred_2 {

    public override Predicate exec() {
        return engine.trust(dollar_gatherStaticResPred_2_3);
    }
}

sealed class dollar_gatherStaticResPred_2_1 : dollar_gatherStaticResPred_2 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("[]");

    public override Predicate exec() {
        Term a1, a2;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        this.cont = engine.cont;

        if ( !s1.unify(a1, engine.trail) ) return engine.fail();
        if ( !s1.unify(a2, engine.trail) ) return engine.fail();
        return new Predicates.dollar_neckCut_0(cont);
    }
}

sealed class dollar_gatherStaticResPred_2_2 : dollar_gatherStaticResPred_2 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("put_closure", 3);
    static internal readonly SymbolTerm f2 = SymbolTerm.makeSymbol("put_static_pred", 1);

    public override Predicate exec() {
        Term a1, a2, a3, a4, a5, a6, a7;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        this.cont = engine.cont;

        if ( a1.isList() ){
            a3 = ((ListTerm)a1).car;
            a4 = ((ListTerm)a1).cdr;
        } else if ( a1.isVariable() ){
            a3 = engine.makeVariable();
            a4 = engine.makeVariable();
            if ( !a1.unify(new ListTerm(a3, a4), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a3.isStructure() ){
            if (f1 != ((StructureTerm)a3).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a3).args;
            a5 = args[0];
        } else if (a3.isVariable() ){
            a5 = engine.makeVariable();
            Term[] args = {a5, engine.makeVariable(), engine.makeVariable()};
            if ( !a3.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a2.isList() ){
            a6 = ((ListTerm)a2).car;
            a7 = ((ListTerm)a2).cdr;
        } else if ( a2.isVariable() ){
            a6 = engine.makeVariable();
            a7 = engine.makeVariable();
            if ( !a2.unify(new ListTerm(a6, a7), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a6.isStructure() ){
            if (f2 != ((StructureTerm)a6).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a6).args;
            if ( !a5.unify(args[0],  engine.trail) )
                return engine.fail();
        } else if (a6.isVariable() ){
            Term[] args = {a5};
            if ( !a6.unify(new StructureTerm(f2, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        p1 = new Predicates.dollar_gatherStaticResPred_2(a4, a7, cont);
        return new Predicates.dollar_neckCut_0(p1);
    }
}

sealed class dollar_gatherStaticResPred_2_3 : dollar_gatherStaticResPred_2 {

    public override Predicate exec() {
        Term a1, a2, a3;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        this.cont = engine.cont;

        if ( a1.isList() ){
            a3 = ((ListTerm)a1).cdr;
        } else if ( a1.isVariable() ){
            a3 = engine.makeVariable();
            if ( !a1.unify(new ListTerm(engine.makeVariable(), a3), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        engine.aregs[1] = a3;
        engine.aregs[2] = a2;
        engine.cont = cont;
        return entry_code.call();
    }
}
}

