/*
 * *** Please do not edit ! ***
 * @(#) dollar_plcsInit_1.cs
 * @procedure $plcs_init/1 in plcs.pl
 */

/*
 * @version Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_plcsInit_1 : Predicate {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("$file_name", 1);
    static internal readonly SymbolTerm f3 = SymbolTerm.makeSymbol("$dummy_counter", 1);
    static internal readonly SymbolTerm f5 = SymbolTerm.makeSymbol("$internal_clause", 2);
    static internal readonly SymbolTerm f7 = SymbolTerm.makeSymbol("$internal_predicates", 2);
    static internal readonly SymbolTerm f9 = SymbolTerm.makeSymbol("$dynamic_predicates", 2);
    static internal readonly SymbolTerm f11 = SymbolTerm.makeSymbol("$resource_predicates", 2);
    static internal readonly SymbolTerm f13 = SymbolTerm.makeSymbol("$fco_predicates", 2);
    static internal readonly SymbolTerm f15 = SymbolTerm.makeSymbol("$res_counter", 1);
    static internal readonly IntegerTerm s18 = new IntegerTerm(0);
    static internal readonly Term[] h21 = {s18};
    static internal readonly StructureTerm s19 = new StructureTerm(f3, h21);
    static internal readonly Term[] h22 = {s18};
    static internal readonly StructureTerm s20 = new StructureTerm(f15, h22);

    public Term arg1;

    public dollar_plcsInit_1(Term a1, Predicate cont) {
        arg1 = a1; 
        this.cont = cont;
    }

    public dollar_plcsInit_1(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        this.cont = cont;
    }

    public override Predicate exec() {
        engine.setB0();
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9, a10;
        Predicate p1, p2, p3, p4, p5, p6, p7, p8, p9, p10;
        a1 = arg1.dereference();

        Term[] h2 = {engine.makeVariable()};
        a2 = new StructureTerm(f1, h2);
        Term[] h4 = {engine.makeVariable()};
        a3 = new StructureTerm(f3, h4);
        Term[] h6 = {engine.makeVariable(), engine.makeVariable()};
        a4 = new StructureTerm(f5, h6);
        Term[] h8 = {engine.makeVariable(), engine.makeVariable()};
        a5 = new StructureTerm(f7, h8);
        Term[] h10 = {engine.makeVariable(), engine.makeVariable()};
        a6 = new StructureTerm(f9, h10);
        Term[] h12 = {engine.makeVariable(), engine.makeVariable()};
        a7 = new StructureTerm(f11, h12);
        Term[] h14 = {engine.makeVariable(), engine.makeVariable()};
        a8 = new StructureTerm(f13, h14);
        Term[] h16 = {engine.makeVariable()};
        a9 = new StructureTerm(f15, h16);
        Term[] h17 = {a1};
        a10 = new StructureTerm(f1, h17);
        p1 = new Predicates.Assert_1(s20, cont);
        p2 = new Predicates.Assert_1(s19, p1);
        p3 = new Predicates.Assert_1(a10, p2);
        p4 = new Predicates.Retractall_1(a9, p3);
        p5 = new Predicates.Retractall_1(a8, p4);
        p6 = new Predicates.Retractall_1(a7, p5);
        p7 = new Predicates.Retractall_1(a6, p6);
        p8 = new Predicates.Retractall_1(a5, p7);
        p9 = new Predicates.Retractall_1(a4, p8);
        p10 = new Predicates.Retractall_1(a3, p9);
        return new Predicates.Retractall_1(a2, p10);
    }

    public override int arity() { return 1; }

    public override string ToString() {
        return "$plcs_init(" + arg1 + ")";
    }
}
}

