/*
 * *** Please do not edit ! ***
 * @(#) dollar_precompileHeadR_4.cs
 * @procedure $precompile_head_r/4 in plcs.pl
 */

/*
 * @version Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_precompileHeadR_4 : Predicate {
    static internal readonly Predicate dollar_precompileHeadR_4_1 = new Predicates.dollar_precompileHeadR_4_1();
    static internal readonly Predicate dollar_precompileHeadR_4_2 = new Predicates.dollar_precompileHeadR_4_2();
    static internal readonly Predicate dollar_precompileHeadR_4_sub_1 = new Predicates.dollar_precompileHeadR_4_sub_1();

    public Term arg1, arg2, arg3, arg4;

    public dollar_precompileHeadR_4(Term a1, Term a2, Term a3, Term a4, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        arg4 = a4; 
        this.cont = cont;
    }

    public dollar_precompileHeadR_4(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        arg4 = args[3]; 
        this.cont = cont;
    }

    public override Predicate exec() {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.aregs[3] = arg3;
        engine.aregs[4] = arg4;
        engine.cont = cont;
        return call();
    }

    public virtual Predicate call() {
        engine.setB0();
        return engine.jtry(dollar_precompileHeadR_4_1, dollar_precompileHeadR_4_sub_1);
    }

    public override int arity() { return 4; }

    public override string ToString() {
        return "$precompile_head_r(" + arg1 + ", " + arg2 + ", " + arg3 + ", " + arg4 + ")";
    }
}

sealed class dollar_precompileHeadR_4_sub_1 : dollar_precompileHeadR_4 {

    public override Predicate exec() {
        return engine.trust(dollar_precompileHeadR_4_2);
    }
}

sealed class dollar_precompileHeadR_4_1 : dollar_precompileHeadR_4 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("[]");

    public override Predicate exec() {
        Term a1, a2, a3, a4;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        this.cont = engine.cont;

        if ( !s1.unify(a2, engine.trail) ) return engine.fail();
        p1 = new Predicates.dollar_precompileHead_3(a1, a3, a4, cont);
        return new Predicates.dollar_neckCut_0(p1);
    }
}

sealed class dollar_precompileHeadR_4_2 : dollar_precompileHeadR_4 {
    static internal readonly IntegerTerm s1 = new IntegerTerm(1);

    public override Predicate exec() {
        Term a1, a2, a3, a4, a5, a6, a7;
        Predicate p1, p2;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        this.cont = engine.cont;

        a6 = engine.makeVariable();
        a5 = new ListTerm(engine.makeVariable(), a6);
        a7 = engine.makeVariable();
        p1 = new Predicates.dollar_precompHead_4(a7, s1, a3, a4, cont);
        p2 = new Predicates.dollar_append_3(a6, a2, a7, p1);
        return new Predicates.eq_stop_stop_2(a1, a5, p2);
    }
}
}

