/*
 * *** Please do not edit ! ***
 * @(#) dollar_precompile_3.cs
 * @procedure $precompile/3 in plcs.pl
 */

/*
 * @version Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_precompile_3 : Predicate {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("[]");

    public Term arg1, arg2, arg3;

    public dollar_precompile_3(Term a1, Term a2, Term a3, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        this.cont = cont;
    }

    public dollar_precompile_3(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        this.cont = cont;
    }

    public override Predicate exec() {
        engine.setB0();
        Term a1, a2, a3, a4, a5, a6;
        Predicate p1, p2, p3;
        a1 = arg1.dereference();
        a2 = arg2.dereference();
        a3 = arg3.dereference();

        a4 = engine.makeVariable();
        a5 = engine.makeVariable();
        a6 = engine.makeVariable();
        p1 = new Predicates.dollar_flattenCode_3(a4, a3, s1, cont);
        p2 = new Predicates.dollar_precompileBody_3(a6, a5, s1, p1);
        p3 = new Predicates.dollar_firstCallOpt_3(a1, a2, a6, p2);
        return new Predicates.dollar_precompileHead_3(a1, a4, a5, p3);
    }

    public override int arity() { return 3; }

    public override string ToString() {
        return "$precompile(" + arg1 + ", " + arg2 + ", " + arg3 + ")";
    }
}
}

