/*
 * *** Please do not edit ! ***
 * @(#) dollar_toupper_2.cs
 * @procedure $toupper/2 in plcs.pl
 */

/*
 * @version Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_toupper_2 : Predicate {
    static internal readonly IntegerTerm s1 = new IntegerTerm(97);
    static internal readonly IntegerTerm s2 = new IntegerTerm(65);

    public Term arg1, arg2;

    public dollar_toupper_2(Term a1, Term a2, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        this.cont = cont;
    }

    public dollar_toupper_2(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        this.cont = cont;
    }

    public override Predicate exec() {
        engine.setB0();
        Term a1, a2, a3;
        Predicate p1;
        a1 = arg1.dereference();
        a2 = arg2.dereference();

        a3 = engine.makeVariable();
        p1 = new Predicates.dollar_plus_3(a3, s2, a2, cont);
        return new Predicates.dollar_minus_3(a1, s1, a3, p1);
    }

    public override int arity() { return 2; }

    public override string ToString() {
        return "$toupper(" + arg1 + ", " + arg2 + ")";
    }
}
}

