/*
 * *** Please do not edit ! ***
 * @(#) dollar_wjDeref_3.cs
 * @procedure $wj_deref/3 in plcs.pl
 */

/*
 * @version Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_wjDeref_3 : Predicate {
    static internal readonly Predicate dollar_wjDeref_3_1 = new Predicates.dollar_wjDeref_3_1();
    static internal readonly Predicate dollar_wjDeref_3_2 = new Predicates.dollar_wjDeref_3_2();
    static internal readonly Predicate dollar_wjDeref_3_sub_1 = new Predicates.dollar_wjDeref_3_sub_1();

    public Term arg1, arg2, arg3;

    public dollar_wjDeref_3(Term a1, Term a2, Term a3, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        this.cont = cont;
    }

    public dollar_wjDeref_3(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        this.cont = cont;
    }

    public override Predicate exec() {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.aregs[3] = arg3;
        engine.cont = cont;
        return call();
    }

    public virtual Predicate call() {
        engine.setB0();
        return engine.jtry(dollar_wjDeref_3_1, dollar_wjDeref_3_sub_1);
    }

    public override int arity() { return 3; }

    public override string ToString() {
        return "$wj_deref(" + arg1 + ", " + arg2 + ", " + arg3 + ")";
    }
}

sealed class dollar_wjDeref_3_sub_1 : dollar_wjDeref_3 {

    public override Predicate exec() {
        return engine.trust(dollar_wjDeref_3_2);
    }
}

sealed class dollar_wjDeref_3_1 : dollar_wjDeref_3 {
    static internal readonly IntegerTerm s1 = new IntegerTerm(8);
    static internal readonly SymbolTerm s2 = SymbolTerm.makeSymbol("this.cont = engine.cont;");
    static internal readonly SymbolTerm s3 = SymbolTerm.makeSymbol("[]");
    static internal readonly ListTerm s4 = new ListTerm(s2, s3);

    public override Predicate exec() {
        Term a1, a2, a3, a4;
        Predicate p1, p2, p3;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        this.cont = engine.cont;

        a4 = engine.makeVariable();
        p1 = new Predicates.dollar_writelnStream_3(a1, s1, s4, cont);
        p2 = new Predicates.dollar_cut_1(a4, p1);
        p3 = new Predicates.dollar_greaterThan_2(a2, a3, p2);
        return new Predicates.dollar_getLevel_1(a4, p3);
    }
}

sealed class dollar_wjDeref_3_2 : dollar_wjDeref_3 {
    static internal readonly IntegerTerm s1 = new IntegerTerm(8);
    static internal readonly SymbolTerm s2 = SymbolTerm.makeSymbol("a");
    static internal readonly SymbolTerm s3 = SymbolTerm.makeSymbol(" = ");
    static internal readonly SymbolTerm s4 = SymbolTerm.makeSymbol("engine.aregs[");
    static internal readonly SymbolTerm s5 = SymbolTerm.makeSymbol("].dereference();");
    static internal readonly SymbolTerm s6 = SymbolTerm.makeSymbol("[]");
    static internal readonly ListTerm s7 = new ListTerm(s5, s6);
    static internal readonly IntegerTerm s8 = new IntegerTerm(1);

    public override Predicate exec() {
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9;
        Predicate p1, p2;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        this.cont = engine.cont;

        a8 = new ListTerm(a2, s7);
        a7 = new ListTerm(s4, a8);
        a6 = new ListTerm(s3, a7);
        a5 = new ListTerm(a2, a6);
        a4 = new ListTerm(s2, a5);
        a9 = engine.makeVariable();
        p1 = new Predicates.dollar_wjDeref_3(a1, a9, a3, cont);
        p2 = new Predicates.dollar_plus_3(a2, s8, a9, p1);
        return new Predicates.dollar_writelnStream_3(a1, s1, a4, p2);
    }
}
}

