/*
 * *** Please do not edit ! ***
 * @(#) dollar_wjExecNormal_3.cs
 * @procedure $wj_exec_normal/3 in plcs.pl
 */

/*
 * @version Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_wjExecNormal_3 : Predicate {
    static internal readonly Predicate dollar_wjExecNormal_3_1 = new Predicates.dollar_wjExecNormal_3_1();
    static internal readonly Predicate dollar_wjExecNormal_3_2 = new Predicates.dollar_wjExecNormal_3_2();
    static internal readonly Predicate dollar_wjExecNormal_3_sub_1 = new Predicates.dollar_wjExecNormal_3_sub_1();

    public Term arg1, arg2, arg3;

    public dollar_wjExecNormal_3(Term a1, Term a2, Term a3, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        this.cont = cont;
    }

    public dollar_wjExecNormal_3(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        this.cont = cont;
    }

    public override Predicate exec() {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.aregs[3] = arg3;
        engine.cont = cont;
        return call();
    }

    public virtual Predicate call() {
        engine.setB0();
        return engine.jtry(dollar_wjExecNormal_3_1, dollar_wjExecNormal_3_sub_1);
    }

    public override int arity() { return 3; }

    public override string ToString() {
        return "$wj_exec_normal(" + arg1 + ", " + arg2 + ", " + arg3 + ")";
    }
}

sealed class dollar_wjExecNormal_3_sub_1 : dollar_wjExecNormal_3 {

    public override Predicate exec() {
        return engine.trust(dollar_wjExecNormal_3_2);
    }
}

sealed class dollar_wjExecNormal_3_1 : dollar_wjExecNormal_3 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("[]");

    public override Predicate exec() {
        Term a1, a2, a3;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        this.cont = engine.cont;

        if ( !s1.unify(a3, engine.trail) ) return engine.fail();
        return new Predicates.dollar_neckCut_0(cont);
    }
}

sealed class dollar_wjExecNormal_3_2 : dollar_wjExecNormal_3 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("[]");
    static internal readonly IntegerTerm s2 = new IntegerTerm(4);
    static internal readonly SymbolTerm s3 = SymbolTerm.makeSymbol("public override Predicate exec() {");
    static internal readonly ListTerm s4 = new ListTerm(s3, s1);
    static internal readonly IntegerTerm s5 = new IntegerTerm(1);

    public override Predicate exec() {
        Term a1, a2, a3, a4, a5, a6;
        Predicate p1, p2, p3, p4;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        this.cont = engine.cont;

        if ( a3.isList() ){
            a4 = ((ListTerm)a3).car;
            a5 = ((ListTerm)a3).cdr;
        } else if ( a3.isVariable() ){
            a4 = engine.makeVariable();
            a5 = engine.makeVariable();
            if ( !a3.unify(new ListTerm(a4, a5), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a5.isList() ){
            a6 = ((ListTerm)a5).car;
            if ( !s1.unify(((ListTerm)a5).cdr, engine.trail) )
                return engine.fail();
        } else if ( a5.isVariable() ){
            a6 = engine.makeVariable();
            if ( !a5.unify(new ListTerm(a6, s1), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        p1 = new Predicates.dollar_nl_1(a1, cont);
        p2 = new Predicates.dollar_wjDeref_3(a1, s5, a2, p1);
        p3 = new Predicates.dollar_wjPRegister_2(a1, a6, p2);
        p4 = new Predicates.dollar_wjARegister_2(a1, a4, p3);
        return new Predicates.dollar_writelnStream_3(a1, s2, s4, p4);
    }
}
}

