/*
 * *** Please do not edit ! ***
 * @(#) dollar_wjExecRootOneNores_4.cs
 * @procedure $wj_exec_root_one_nores/4 in plcs.pl
 */

/*
 * @version Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_wjExecRootOneNores_4 : Predicate {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("[]");
    static internal readonly IntegerTerm s2 = new IntegerTerm(4);
    static internal readonly SymbolTerm s3 = SymbolTerm.makeSymbol("public override Predicate exec() {");
    static internal readonly ListTerm s4 = new ListTerm(s3, s1);
    static internal readonly IntegerTerm s5 = new IntegerTerm(8);
    static internal readonly SymbolTerm s6 = SymbolTerm.makeSymbol("engine.setB0();");
    static internal readonly ListTerm s7 = new ListTerm(s6, s1);
    static internal readonly IntegerTerm s8 = new IntegerTerm(1);

    public Term arg1, arg2, arg3, arg4;

    public dollar_wjExecRootOneNores_4(Term a1, Term a2, Term a3, Term a4, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        arg4 = a4; 
        this.cont = cont;
    }

    public dollar_wjExecRootOneNores_4(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        arg4 = args[3]; 
        this.cont = cont;
    }

    public override Predicate exec() {
        engine.setB0();
        Term a1, a2, a3, a4, a5, a6, a7;
        Predicate p1, p2, p3, p4, p5, p6, p7;
        a1 = arg1.dereference();
        a2 = arg2.dereference();
        a3 = arg3.dereference();
        a4 = arg4.dereference();

        if ( a4.isList() ){
            a5 = ((ListTerm)a4).car;
            a6 = ((ListTerm)a4).cdr;
        } else if ( a4.isVariable() ){
            a5 = engine.makeVariable();
            a6 = engine.makeVariable();
            if ( !a4.unify(new ListTerm(a5, a6), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a6.isList() ){
            a7 = ((ListTerm)a6).car;
            if ( !s1.unify(((ListTerm)a6).cdr, engine.trail) )
                return engine.fail();
        } else if ( a6.isVariable() ){
            a7 = engine.makeVariable();
            if ( !a6.unify(new ListTerm(a7, s1), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        p1 = new Predicates.dollar_nl_1(a1, cont);
        p2 = new Predicates.dollar_wjDerefOne_3(a1, s8, a3, p1);
        p3 = new Predicates.dollar_wjPRegister_2(a1, a7, p2);
        p4 = new Predicates.dollar_wjARegister_2(a1, a5, p3);
        p5 = new Predicates.dollar_dummyPlcs__9_3(a2, a3, engine.makeVariable(), p4);
        p6 = new Predicates.dollar_writelnStream_3(a1, s5, s7, p5);
        p7 = new Predicates.dollar_writelnStream_3(a1, s2, s4, p6);
        return new Predicates.dollar_neckCut_0(p7);
    }

    public override int arity() { return 4; }

    public override string ToString() {
        return "$wj_exec_root_one_nores(" + arg1 + ", " + arg2 + ", " + arg3 + ", " + arg4 + ")";
    }
}
}

