/*
 * *** Please do not edit ! ***
 * @(#) WriteImdExec_2.cs
 * @procedure write_imd_exec/2 in plcs.pl
 */

/*
 * @version Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class WriteImdExec_2 : Predicate {
    static internal readonly Predicate WriteImdExec_2_1 = new Predicates.WriteImdExec_2_1();
    static internal readonly Predicate WriteImdExec_2_2 = new Predicates.WriteImdExec_2_2();
    static internal readonly Predicate WriteImdExec_2_3 = new Predicates.WriteImdExec_2_3();
    static internal readonly Predicate WriteImdExec_2_sub_1 = new Predicates.WriteImdExec_2_sub_1();

    public Term arg1, arg2;

    public WriteImdExec_2(Term a1, Term a2, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        this.cont = cont;
    }

    public WriteImdExec_2(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        this.cont = cont;
    }

    public override Predicate exec() {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.cont = cont;
        return call();
    }

    public virtual Predicate call() {
        engine.setB0();
        return engine.jtry(WriteImdExec_2_1, WriteImdExec_2_sub_1);
    }

    public override int arity() { return 2; }

    public override string ToString() {
        return "write_imd_exec(" + arg1 + ", " + arg2 + ")";
    }
}

sealed class WriteImdExec_2_sub_1 : WriteImdExec_2 {
    static internal readonly Predicate WriteImdExec_2_sub_2 = new Predicates.WriteImdExec_2_sub_2();

    public override Predicate exec() {
        return engine.retry(WriteImdExec_2_2, WriteImdExec_2_sub_2);
    }
}

sealed class WriteImdExec_2_sub_2 : WriteImdExec_2 {

    public override Predicate exec() {
        return engine.trust(WriteImdExec_2_3);
    }
}

sealed class WriteImdExec_2_1 : WriteImdExec_2 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("[]");

    public override Predicate exec() {
        Term a1, a2;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        this.cont = engine.cont;

        if ( !s1.unify(a2, engine.trail) ) return engine.fail();
        return new Predicates.dollar_neckCut_0(cont);
    }
}

sealed class WriteImdExec_2_2 : WriteImdExec_2 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("[]");
    static internal readonly IntegerTerm s2 = new IntegerTerm(12);

    public override Predicate exec() {
        Term a1, a2, a3;
        Predicate p1, p2, p3;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        this.cont = engine.cont;

        if ( a2.isList() ){
            a3 = ((ListTerm)a2).car;
            if ( !s1.unify(((ListTerm)a2).cdr, engine.trail) )
                return engine.fail();
        } else if ( a2.isVariable() ){
            a3 = engine.makeVariable();
            if ( !a2.unify(new ListTerm(a3, s1), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        p1 = new Predicates.dollar_nl_1(a1, cont);
        p2 = new Predicates.Writeq_2(a1, a3, p1);
        p3 = new Predicates.dollar_tab_2(a1, s2, p2);
        return new Predicates.dollar_neckCut_0(p3);
    }
}

sealed class WriteImdExec_2_3 : WriteImdExec_2 {
    static internal readonly IntegerTerm s1 = new IntegerTerm(12);
    static internal readonly SymbolTerm s2 = SymbolTerm.makeSymbol(",");

    public override Predicate exec() {
        Term a1, a2, a3, a4;
        Predicate p1, p2, p3, p4;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        this.cont = engine.cont;

        if ( a2.isList() ){
            a3 = ((ListTerm)a2).car;
            a4 = ((ListTerm)a2).cdr;
        } else if ( a2.isVariable() ){
            a3 = engine.makeVariable();
            a4 = engine.makeVariable();
            if ( !a2.unify(new ListTerm(a3, a4), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        p1 = new Predicates.WriteImdExec_2(a1, a4, cont);
        p2 = new Predicates.dollar_nl_1(a1, p1);
        p3 = new Predicates.Write_2(a1, s2, p2);
        p4 = new Predicates.Writeq_2(a1, a3, p3);
        return new Predicates.dollar_tab_2(a1, s1, p4);
    }
}
}

