/*
 * @(#)dollar_midImp_1.cs
 *  $B=R8l(B $mid_imp/1
 */

/* 
 * @author Mutsunori Banbara 
 *         banbara@pascal.seg.kobe-u.ac.jp
 *         Nara National College of Technology
 * @author Naoyuki Tamura 
 *         tamura@kobe-u.ac.jp
 *         Kobe University
 */

namespace JJC.Psharp.Predicates {

	using JJC.Psharp.Lang;
	using JJC.Psharp.Lang.Resource;

	public sealed class dollar_midImp_1 : Predicate {
		Term arg1;

		public dollar_midImp_1(Term a1, Predicate cont) {
			arg1 = a1;
			this.cont = cont;
		}
		public dollar_midImp_1() {}
		public override void setArgument(Term[] args, Predicate cont){
			arg1 = args[0];
			this.cont = cont;
		}

		public override Predicate exec() {
			Term a1;
			a1 = arg1.dereference();

			//	int R0 = engine.getR0();
			int R  = engine.resTop();
			if ( ! a1.unify(new ResIndexTerm(R), engine.trail) )
				return engine.fail();
			engine.setRelatedResField();
			return cont;
		}

		public override int arity() { return 1; }
		public override string ToString() {
			return "$mid_imp(" + arg1 + ")";
		}	
	}

}